// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(h) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function Re(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Le(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function Q(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = Q(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function ge(e, n, t) {
        if (t) for (var i in e) {
            if (rn(e, i) && !rn(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (rn(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (rn(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Ue() {}
    function Ve() {
        return false;
    }
    function Ge() {
        return true;
    }
    function We() {
        return this;
    }
    function Je() {
        return null;
    }
    var Xe = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === a) continue;
                if (r instanceof o) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Ke(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function Qe(e, i) {
        return e.replace(/\{([^}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof on ? t.print_to_string() : t;
        });
    }
    function Ze(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function en(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function nn(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function tn() {
        this._values = Object.create(null);
        this._size = 0;
    }
    tn.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new tn();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    tn.fromObject = function(e) {
        var n = new tn();
        n._size = t(n._values, e);
        return n;
    };
    function rn(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function an(e, n, t) {
        var i = e.parent(-1);
        for (var r = 0, a; a = e.parent(r++); i = a) {
            if (zn(a)) {
                return n && a.value === i;
            } else if (a instanceof qt) {
                if (a.left === i) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === i) continue;
            } else if (a instanceof Ft) {
                if (a.condition === i) continue;
            } else if (a instanceof bt) {
                return t;
            } else if (a instanceof St) {
                if (a.expression === i) continue;
            } else if (a instanceof Et) {
                if (a.expressions[0] === i) continue;
            } else if (a instanceof pn) {
                return true;
            } else if (a instanceof li) {
                if (a.tag === i) continue;
            } else if (a instanceof zt) {
                if (a.expression === i) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = on;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var a = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = i && new i();
        if (o && o.initialize || t && t.initialize) a.push("this.initialize();");
        a.push("}");
        var s = new Function(a.join(""))();
        if (o) {
            s.prototype = o;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (rn(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof h !== "undefined") {
            h["AST_" + e] = s;
        }
        return s;
    }
    var Z = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var on = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Ti(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Si(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(Qe("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (on.log_function = function(n, e) {
        if (typeof n != "function") {
            on.info = on.warn = Ue;
            return;
        }
        var t = Object.create(null);
        on.info = e ? function(e, n) {
            i("INFO: " + Qe(e, n));
        } : Ue;
        on.warn = function(e, n) {
            i("WARN: " + Qe(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    on.enable_validation = function() {
        on.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!rn(n.prototype, "transform")) return;
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof on) {
                    t.validate();
                } else if (!(t === null || n && Xe.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = i;
            });
        })(this);
    };
    on.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var sn = i("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var fn = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, sn);
    var un = i("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, sn);
    var cn = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, sn);
    function ln(e) {
        return e instanceof sn && !(e instanceof Wn) && !(e instanceof $n);
    }
    function o(e, n, t, i, r) {
        t = t ? "contain" : "be";
        if (!(e instanceof on)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof wt) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof Nt) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof yi && !r) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof Dt && !i) throw new Error(n + " cannot " + t + " AST_Spread");
        if (ln(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof Jt) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function s(e, n) {
        o(e[n], n);
    }
    var pn = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "body");
        }
    }, sn);
    var dn = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Object/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof dn)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof Tn)) throw new Error("must be contained within AST_Scope");
        }
    }, sn);
    function hn(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var vn = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                hn(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!ln(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, dn);
    var mn = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, vn);
    var j = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!ln(this.body)) throw new Error("body must be AST_Statement");
        }
    }, dn);
    var _n = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new Si(function(e) {
                    if (e instanceof tt) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof Tn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Te)) throw new Error("label must be AST_Label");
        }
    }, j);
    var gn = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, j);
    var bn = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            s(this, "condition");
        }
    }, gn);
    var yn = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, bn);
    var wn = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, bn);
    var xn = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof on)) throw new Error("init must be AST_Node");
                if (ln(this.init) && !(this.init instanceof dt)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) s(this, "condition");
            if (this.step != null) s(this, "step");
        }
    }, gn);
    var kn = i("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof dt) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof St || e instanceof ai)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            s(this, "object");
        }
    }, gn);
    var En = i("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, kn);
    var be = i("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, kn);
    var ye = i("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, be);
    var Sn = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, j);
    var Tn = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: We,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, vn);
    var An = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return qi([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Ti(function(e) {
                if (e instanceof un && e.value == "$ORIG") {
                    return Xe.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return qi([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Ti(function(e) {
                if (e instanceof un && e.value == "$ORIG") {
                    return Xe.splice(t);
                }
            }));
        }
    }, Tn);
    var Dn = i("Lambda", "argnames length_read rest uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Si(function(e) {
                if (e instanceof wt) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof Yt) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof ei) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                hn(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof ei)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof ei)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, Tn);
    var On = i("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, Dn);
    var $n = i("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, Dn);
    function zn(e) {
        return e instanceof Cn || e instanceof jn;
    }
    function qn(e) {
        return e instanceof jn || e instanceof Bn || e instanceof Pn || e instanceof Rn || e instanceof Nn;
    }
    function Fn(e) {
        return e instanceof Rn || e instanceof Nn || e instanceof Un || e instanceof Yn;
    }
    function Mn(e, n) {
        if (zn(e) && e.value) {
            e.value.walk(n);
        } else {
            hn(e, n);
        }
    }
    var Cn = i("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    hn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, $n);
    var jn = i("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    hn(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, $n);
    var Pn = i("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ti)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, $n);
    var Nn = i("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ti)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, $n);
    var Hn = i("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ti)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, $n);
    var Yn = i("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ti)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, $n);
    var In = i("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof ni)) throw new Error("name must be AST_SymbolDefun");
        }
    }, Dn);
    var Bn = i("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, In);
    var Rn = i("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, In);
    var Ln = i("Defun", null, {
        $documentation: "A function definition"
    }, In);
    var Un = i("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, In);
    var Vn = i("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) s(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof Jn)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, dn);
    var Gn = i("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Se)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, Vn);
    var Wn = i("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ii)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, Vn);
    var Jn = i("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node] property name (AST_Node for computed property)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof on) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof on)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof on)) throw new Error("value must be AST_Node");
            }
        }
    });
    var Xn = i("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, Jn);
    var we = i("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof On)) throw new Error("value must be AST_Accessor");
        }
    }, Jn);
    var xe = i("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof On)) throw new Error("value must be AST_Accessor");
        }
    }, Jn);
    var Kn = i("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof $n)) throw new Error("value must be AST_LambdaExpression");
            if (zn(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, Jn);
    var Qn = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, sn);
    var Zn = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, Qn);
    var et = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, Zn);
    var nt = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            s(this, "value");
        }
    }, Zn);
    var tt = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Ae)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Qn);
    var it = i("Break", null, {
        $documentation: "A `break` statement"
    }, tt);
    var rt = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, tt);
    var at = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            if (this.alternative != null) {
                if (!ln(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, j);
    var ot = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                hn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof st)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, vn);
    var st = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, vn);
    var ft = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, st);
    var ut = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                hn(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, st);
    var ct = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                hn(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof lt)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof pt)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, vn);
    var lt = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                hn(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof ri)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, vn);
    var pt = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, vn);
    var dt = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, sn);
    var ht = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof _t)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof Xt)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, dt);
    var vt = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof _t)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof Qt)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, dt);
    var mt = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof _t)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof Zt)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, dt);
    var _t = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    });
    var gt = i("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof Gn || this.body instanceof dt || this.body instanceof In)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, sn);
    var bt = i("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof Gn || this.body instanceof In)) {
                s(this, "body");
            }
        }
    }, sn);
    var ke = i("ExportForeign", "aliases keys path quote", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[string*] array of aliases to export",
            keys: "[string*] array of keys to import",
            path: "[string] the path to import module",
            quote: "[string?] the original quote character"
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (typeof e != "string") throw new Error("aliases must contain string");
            });
            this.keys.forEach(function(e) {
                if (typeof e != "string") throw new Error("keys must contain string");
            });
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, sn);
    var yt = i("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof oi)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, sn);
    var Ee = i("Import", "all default path properties quote", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[string] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified",
            quote: "[string?] the original quote character"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof Kt)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof Kt)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key !== "") throw new Error("invalid default key: " + this.default.key);
            }
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof Kt)) throw new Error("properties must contain AST_SymbolImport");
            });
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, sn);
    var wt = i("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            s(this, "value");
        }
    });
    function f(e, n, t, i) {
        e[n].forEach(function(e) {
            o(e, n, true, t, i);
        });
    }
    var xt = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "expression");
            f(this, "args", true);
        }
    });
    var kt = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, xt);
    var Et = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    var St = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof pi) {
                return e.value;
            }
            if (e instanceof $t && e.operator == "void" && e.expression instanceof pi) {
                return;
            }
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            s(this, "expression");
        }
    });
    var Tt = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, St);
    var At = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            s(this, "property");
        }
    }, St);
    var Dt = i("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Ot = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "expression");
        }
    });
    var $t = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Ot);
    var zt = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Ot);
    var qt = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Mt)) s(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "right");
        }
    });
    var Ft = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            s(this, "consequent");
            s(this, "alternative");
        }
    });
    var Mt = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Nt) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof St || e instanceof ai)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            }
        }
    }, qt);
    var Ct = i("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var jt = i("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                s(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var Pt = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var Nt = i("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function u(e, n, t) {
        if (e instanceof wt && t) return u(e.name, n);
        if (e instanceof Nt) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof Ht) return e.elements.forEach(function(e) {
                if (!(e instanceof yi)) u(e, n, true);
            });
            if (e instanceof It) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var Ht = i("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, Nt);
    var Yt = i("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof on) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof on)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof on)) throw new Error("value must be AST_Node");
        }
    });
    var It = i("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Yt)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Nt);
    var Bt = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Rt || e instanceof Dt)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var Rt = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof on) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof on)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof on)) throw new Error("value must be AST_Node");
        }
    });
    var Lt = i("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            s(this, "value");
        }
    }, Rt);
    var Ut = i("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof $n)) throw new Error("value must be AST_LambdaExpression");
            if (zn(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, Lt);
    var Vt = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof On)) throw new Error("value must be AST_Accessor");
        }
    }, Rt);
    var Gt = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof On)) throw new Error("value must be AST_Accessor");
        }
    }, Rt);
    var Wt = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var Jt = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Wt);
    var Xt = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, Jt);
    var Kt = i("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[string] the original `export` name"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
        }
    }, Xt);
    var Qt = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, Jt);
    var Zt = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, Jt);
    var ei = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, Zt);
    var ni = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, Jt);
    var ti = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, Jt);
    var Se = i("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, Qt);
    var ii = i("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, Qt);
    var ri = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, Jt);
    var Te = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Wt);
    var ai = i("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Wt);
    var oi = i("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[string] the `export` alias"
        },
        _validate: function() {
            if (typeof this.alias != "string") throw new Error("alias must be string");
        }
    }, ai);
    var Ae = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Wt);
    var si = i("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, Wt);
    var fi = i("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, si);
    var ui = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, si);
    var ci = i("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, ui);
    var li = i("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) s(this, "tag");
        }
    });
    var pi = i("Constant", null, {
        $documentation: "Base class for all constants",
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var di = i("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, pi);
    var hi = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, pi);
    var vi = i("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, pi);
    var mi = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, pi);
    var v = i("Atom", null, {
        $documentation: "Base class for atoms",
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, pi);
    var _i = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, v);
    var gi = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, v);
    var bi = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, v);
    var yi = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, v);
    var wi = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, v);
    var xi = i("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, v);
    var ki = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, xi);
    var Ei = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, xi);
    function Si(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Si.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Ue);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof Dn) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof un && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof Dn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof Tn) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof un)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof _n && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof gn || e instanceof it && i instanceof ot) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof Ft && t.condition === e || t instanceof bn && t.condition === e || t instanceof xn && t.condition === e || t instanceof at && t.condition === e || t instanceof et && t.in_bool || t instanceof Et && t.tail_node() !== e || t instanceof pn || t instanceof $t && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof qt && (t.operator == "&&" || t.operator == "||") || t instanceof Ft || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof et) {
                    for (var i, r = t; i = this.parent(++n); r = i) {
                        if (i.TYPE == "Call") {
                            if (!(r instanceof Dn) || r.name) return false;
                        } else if (r instanceof Dn) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ti(e, n) {
        Si.call(this);
        this.before = e;
        this.after = n;
    }
    Ti.prototype = new Si();
    (function(e) {
        function t(e, n) {
            return Xe(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(on, Ue);
        e(_n, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(pn, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(vn, function(e, n) {
            e.body = t(e.body, n);
        });
        e(yn, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(wn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(xn, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(kn, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(Sn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(Zn, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(tt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(at, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(ot, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(ut, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(ct, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(lt, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(dt, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(_t, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(wt, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(Dn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(Cn, n);
        e(jn, n);
        e(Vn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(Jn, function(e, n) {
            if (e.key instanceof on) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(xt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Et, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(Ct, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(jt, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(Tt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(At, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Dt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Ot, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(qt, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Ft, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Pt, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Ht, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(Yt, function(e, n) {
            if (e.key instanceof on) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(It, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(Bt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Rt, function(e, n) {
            if (e.key instanceof on) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(gt, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(bt, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(yt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Ee, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(li, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var De = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof let new return switch throw try typeof var void while with";
    var F = "false null true";
    var P = [ "abstract async await boolean byte char double enum export final float goto implements import int interface long native package private protected public short static super synchronized this throws transient volatile yield", F, De ].join(" ");
    var M = "return new delete throw else case";
    De = en(De);
    P = en(P);
    M = en(M);
    F = en(F);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var C = en([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var N = "\n\r\u2028\u2029";
    var H = "+-*&%=<>!?|~^";
    var d = "[{(";
    var m = ",;:";
    var _ = ")}]";
    var Oe = m + _;
    var Y = d + m;
    var I = Y + "`" + _;
    var B = N + "  \t\f\v​             　\ufeff";
    var R = en(e("./'\"" + H + I + B));
    N = en(e(N));
    H = en(e(H));
    Oe = en(e(Oe));
    Y = en(e(Y));
    I = en(e(I));
    B = en(e(B));
    function ee(e) {
        return e >= 55296 && e <= 56319;
    }
    function ne(e) {
        return e >= 56320 && e <= 57343;
    }
    function L(e) {
        return e >= 48 && e <= 57;
    }
    function te(e) {
        return !R[e];
    }
    function Ai(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Di(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Oi(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Oi.prototype = Object.create(Error.prototype);
    Oi.prototype.constructor = Oi;
    Oi.prototype.name = "SyntaxError";
    n(Oi);
    function $e(e, n, t, i, r) {
        throw new Oi(e, n, t, i, r);
    }
    function ze(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function qe(r, a, o, s) {
        var f = {
            text: r,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: [],
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = l(true, true);
                    switch (t) {
                      case "\\":
                        t += l(true, true);
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            f.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw V;
            if (N[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (N[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !$i[n] || e == "keyword" && M[n] || e == "punc" && Y[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Z(i);
        }
        function _() {
            while (B[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t, n)) n += l();
            return n;
        }
        function b(e) {
            $e(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function w(e) {
            var t = false, i = false, r = false, a = e == ".";
            var n = g(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return r ? false : r = true;

                  case "e":
                  case "E":
                    return r ? true : t ? false : t = i = true;

                  case "+":
                  case "-":
                    return i;

                  case i = false, ".":
                    return a || t || r || y(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (y(n)) {
                if (q.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(r ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function x(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return k(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var i = Di(n);
            if (typeof i != "string") b("Invalid escape sequence: \\" + n);
            return i;
        }
        function k(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && q.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = x(true); else if (N[i]) b("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = m("string", t);
            r.quote = e;
            return r;
        });
        function S(e) {
            var n = f.regex_allowed;
            var t = h(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, i, true));
            f.regex_allowed = n;
            return q;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return q;
        });
        function T() {
            var e = false, n = "", t, i = false, r;
            while (t = c()) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (te(t)) n += l(); else break;
                } else {
                    if (t != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = x();
                    if (!te(t)) b("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (De[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var A = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (N[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = T();
            try {
                var a = new RegExp(e, r);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (C[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return S("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? A("") : D("/");
        }
        function $() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return m("operator", n);
            }
            return L(e.charCodeAt(0)) ? w(".") : m("punc", ".");
        }
        function z() {
            var e = T();
            if (u) return m("name", e);
            return F[e] ? m("atom", e) : !De[e] ? m("name", e) : C[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) b(n); else throw e;
                }
            };
        }
        function q(e) {
            if (e != null) return A(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                S("comment5");
            }
            for (;;) {
                _();
                v();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        S("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        S("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return $();

                  case 47:
                    var i = O();
                    if (i === q) continue;
                    return i;
                }
                if (L(t)) return w();
                if (I[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (H[n]) return D();
                if (t == 92 || !R[n]) return z();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        q.context = function(e) {
            if (e) f = e;
            return f;
        };
        q.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        q.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        q.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        q.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return q;
    }
    var Fe = en("typeof void delete -- ++ ! ~ - +");
    var $i = en("-- ++");
    var Me = en("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var zi = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Ce = en("atom bigint num regexp string");
    function qi(e, c) {
        c = ge(c, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof e == "string" ? qe(e, c.filename, c.html5_comments, c.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return ze(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function o(e, n, t, i) {
            var r = _.input.context();
            $e(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function s(e, n) {
            o(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            s(e, "Unexpected token: " + t(e.type, e.value));
        }
        function f(e, n) {
            if (g(e, n)) return b();
            s(_.token, "Unexpected token: " + t(_.token.type, _.token.value) + ", expected: " + t(e, n));
        }
        function x(e) {
            return f("punc", e);
        }
        function u(e) {
            return e.nlb || !nn(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function l() {
            return !c.strict && (g("eof") || g("punc", "}") || u(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !l()) x(";");
        }
        function d() {
            x("(");
            var e = ve();
            x(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = _.token;
                var n = i.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function E() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var h = n(function() {
            E();
            switch (_.token.type) {
              case "string":
                var e = _.in_directives;
                var n = ve();
                if (e) {
                    if (n instanceof di) {
                        var t = n.start.raw.slice(1, -1);
                        _.input.add_directive(t);
                        n.value = t;
                    } else {
                        _.in_directives = e = false;
                    }
                }
                k();
                return e ? new un(n) : new pn({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return m();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if (ze(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return z(Bn);
                        b();
                        return z(Rn);
                    }
                    break;

                  case "await":
                    if (_.in_async) return m();
                    break;

                  case "export":
                    b();
                    return M();

                  case "import":
                    var i = p();
                    if (!(i.type == "punc" && /^[(.]$/.test(i.value))) {
                        b();
                        return P();
                    }

                  case "yield":
                    if (_.in_generator) return m();
                    break;
                }
                return ze(p(), "punc", ":") ? v() : m();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new mn({
                        start: _.token,
                        body: N(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return m();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new cn();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return S(it);

                  case "class":
                    b();
                    return A(Gn);

                  case "const":
                    b();
                    var r = B();
                    k();
                    return r;

                  case "continue":
                    b();
                    return S(rt);

                  case "debugger":
                    b();
                    k();
                    return new fn();

                  case "do":
                    b();
                    var n = me(h);
                    f("keyword", "while");
                    var a = d();
                    k(true);
                    return new yn({
                        body: n,
                        condition: a
                    });

                  case "while":
                    b();
                    return new wn({
                        condition: d(),
                        body: me(h)
                    });

                  case "for":
                    b();
                    return D();

                  case "function":
                    b();
                    if (!g("operator", "*")) return z(Ln);
                    b();
                    return z(Un);

                  case "if":
                    b();
                    return q();

                  case "let":
                    b();
                    var r = R();
                    k();
                    return r;

                  case "return":
                    if (_.in_function == 0 && !c.bare_returns) o("'return' outside of function");
                    b();
                    var t = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!l()) {
                        t = ve();
                        k();
                    }
                    return new et({
                        value: t
                    });

                  case "switch":
                    b();
                    return new ot({
                        expression: d(),
                        body: me(H)
                    });

                  case "throw":
                    b();
                    if (u(_.token)) o("Illegal newline after 'throw'");
                    var t = ve();
                    k();
                    return new nt({
                        value: t
                    });

                  case "try":
                    b();
                    return Y();

                  case "var":
                    b();
                    var r = L();
                    k();
                    return r;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        o("Strict mode may not include a with statement");
                    }
                    b();
                    return new Sn({
                        expression: d(),
                        body: h()
                    });
                }
            }
            w();
        });
        function v() {
            var n = te(Te);
            if (!nn(_.labels, function(e) {
                return e.name != n.name;
            })) {
                o("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = h();
            _.labels.pop();
            if (!(e instanceof gn)) {
                n.references.forEach(function(e) {
                    if (e instanceof rt) {
                        s(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new _n({
                body: e,
                label: n
            });
        }
        function m() {
            var e = ve();
            k();
            return new pn({
                body: e
            });
        }
        function S(e) {
            var n = null, t;
            if (!l()) {
                n = te(Ae, true);
            }
            if (n != null) {
                t = Le(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) s(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) o(e.TYPE + " not inside a loop or switch");
            k();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function T(e) {
            if (!g("name", e)) return;
            var n = p();
            if (!n) return;
            if (ze(n, "operator", "=")) return;
            if (n.type == "punc" && /^[(;}]$/.test(n.value)) return;
            if (u(n)) return;
            return b();
        }
        function A(e) {
            var n = _.in_async;
            var t = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var i;
            if (e === Gn) {
                i = te(Se);
            } else {
                i = te(ii, true);
            }
            var r = null;
            if (g("keyword", "extends")) {
                b();
                E();
                r = G(true);
            }
            x("{");
            var a = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var o = _.token;
                var s = !!T("static");
                var f = T("async");
                if (g("operator", "*")) {
                    b();
                    var u = g("name") && /^#/.test(_.token.value);
                    var c = Q();
                    var l = _.token;
                    var p = z(f ? Nn : Yn);
                    p.start = l;
                    p.end = y();
                    a.push(new Kn({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: p,
                        end: y()
                    }));
                    continue;
                }
                var u = g("name") && /^#/.test(_.token.value);
                var c = Q();
                if (g("punc", "(")) {
                    var d = _.token;
                    var h = z(f ? Pn : Hn);
                    h.start = d;
                    h.end = y();
                    a.push(new Kn({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: h,
                        end: y()
                    }));
                    continue;
                }
                if (f) w(f);
                var v = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    v = he();
                    _.in_generator = t;
                    _.in_async = n;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var m = null;
                    switch (c) {
                      case "get":
                        m = we;
                        break;

                      case "set":
                        m = xe;
                        break;
                    }
                    if (m) {
                        a.push(new m({
                            start: o,
                            static: s,
                            private: g("name") && /^#/.test(_.token.value),
                            key: Q(),
                            value: X(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                a.push(new Xn({
                    start: o,
                    static: s,
                    private: u,
                    key: c,
                    value: v,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = t;
            _.in_async = n;
            return new e({
                extends: r,
                name: i,
                properties: a
            });
        }
        function D() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), B(true)) : g("keyword", "let") ? (b(), R(true)) : g("keyword", "var") ? (b(), 
                L(true)) : ve(true);
                var t;
                if (e) {
                    f("name", "of");
                    t = ye;
                } else if (g("operator", "in")) {
                    b();
                    t = En;
                } else if (g("name", "of")) {
                    b();
                    t = be;
                }
                if (t) {
                    if (n instanceof dt) {
                        if (n.definitions.length > 1) {
                            s(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== En && n.definitions[0].value) {
                            s(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(pe(n) || (n = de(n)) instanceof Nt)) {
                        s(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return r(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : ve();
            x(";");
            var t = g("punc", ")") ? null : ve();
            x(")");
            return new xn({
                init: e,
                condition: n,
                step: t,
                body: me(h)
            });
        }
        function r(e, n) {
            var t = ve();
            x(")");
            return new e({
                init: n,
                object: t,
                body: me(h)
            });
        }
        function O(e) {
            if (e instanceof Pt) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Dt) {
                    n = O(e.elements.pop().expression);
                }
                return new Ht({
                    start: e.start,
                    elements: e.elements.map(O),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Mt) return new wt({
                start: e.start,
                name: O(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof wt) {
                e.name = O(e.name);
                return e;
            }
            if (e instanceof Ht) {
                e.elements = e.elements.map(O);
                if (e.rest) e.rest = O(e.rest);
                return e;
            }
            if (e instanceof It) {
                e.properties.forEach(function(e) {
                    e.value = O(e.value);
                });
                if (e.rest) e.rest = O(e.rest);
                return e;
            }
            if (e instanceof yi) return e;
            if (e instanceof Bt) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof Dt) {
                    n = O(e.properties.pop().expression);
                }
                return new It({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof Lt)) s(e.start, "Invalid destructuring assignment");
                        return new Yt({
                            start: e.start,
                            key: e.key,
                            value: O(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof ei) return e;
            if (e instanceof ai) return new ei(e);
            s(e.start, "Invalid arrow parameter");
        }
        function $(e, n, t) {
            var i = _.in_async;
            var r = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var o = e.map(O);
            var s = e.rest || null;
            if (s) s = O(s);
            _.in_funarg = a;
            x("=>");
            var f, u;
            var c = _.in_loop;
            var l = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                f = N();
                u = null;
                if (_.input.has_directive("use strict")) {
                    o.forEach(ne);
                }
            } else {
                f = [];
                E();
                u = he();
            }
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = c;
            _.labels = l;
            _.in_generator = r;
            _.in_async = i;
            return new (t ? jn : Cn)({
                start: n,
                argnames: o,
                rest: s,
                body: f,
                value: u,
                end: y()
            });
        }
        var z = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var i;
            if (/Defun$/.test(e.TYPE)) {
                i = te(ni);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                i = te(ti, true);
            }
            if (i && e !== On && !(i instanceof Jt)) w(y());
            x("(");
            var r = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = W(")", !c.strict, false, function() {
                return re(ei);
            });
            _.in_funarg = r;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = N();
            if (_.input.has_directive("use strict")) {
                if (i) ne(i);
                a.forEach(ne);
                if (a.rest) ne(a.rest);
            }
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            return new e({
                name: i,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
        };
        function q() {
            var e = d(), n = h(), t = null;
            if (g("keyword", "else")) {
                b();
                t = h();
            }
            return new at({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function F() {
            return g("name") || Ai(_.token.value);
        }
        function M() {
            if (g("operator", "*")) {
                b();
                var e = "*";
                if (g("name", "as")) {
                    b();
                    if (!F()) f("name");
                    e = _.token.value;
                    b();
                }
                f("name", "from");
                var n = _.token;
                f("string");
                k();
                return new ke({
                    aliases: [ e ],
                    keys: [ "*" ],
                    path: n.value,
                    quote: n.quote
                });
            }
            if (g("punc", "{")) {
                b();
                var i = [];
                var t = [];
                while (F()) {
                    var r = _.token;
                    b();
                    t.push(r);
                    if (g("name", "as")) {
                        b();
                        if (!F()) f("name");
                        i.push(_.token.value);
                        b();
                    } else {
                        i.push(r.value);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    var n = _.token;
                    f("string");
                    k();
                    return new ke({
                        aliases: i,
                        keys: t.map(function(e) {
                            return e.value;
                        }),
                        path: n.value,
                        quote: n.quote
                    });
                }
                k();
                return new yt({
                    properties: t.map(function(e, n) {
                        if (!ze(e, "name")) s(e, "Name expected");
                        var t = ee(oi, e);
                        t.alias = i[n];
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var a = _.token;
                var o = C();
                if (o) {
                    o.start = a;
                    o.end = y();
                } else {
                    o = ve();
                    k();
                }
                return new bt({
                    body: o
                });
            }
            return new gt({
                body: j()
            });
        }
        function a(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === Gn ? Se : ni)(n.name);
            }
            return n;
        }
        function C() {
            if (g("name", "async")) {
                if (!ze(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return a(Bn, z(Pn));
                b();
                return a(Rn, z(Nn));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return a(Gn, A(Wn));

              case "function":
                b();
                if (!g("operator", "*")) return a(Ln, z(Hn));
                b();
                return a(Un, z(Yn));
            }
        }
        var j = n(function() {
            if (g("name", "async")) {
                b();
                f("keyword", "function");
                if (!g("operator", "*")) return z(Bn);
                b();
                return z(Rn);
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return A(Gn);

              case "const":
                b();
                var e = B();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return z(Ln);
                b();
                return z(Un);

              case "let":
                b();
                var e = R();
                k();
                return e;

              case "var":
                b();
                var e = L();
                k();
                return e;
            }
            w();
        });
        function P() {
            var e = null;
            var n = te(Kt, true);
            var t = null;
            if (n ? (n.key = "", g("punc", ",") && b()) : !g("string")) {
                if (g("operator", "*")) {
                    b();
                    f("name", "as");
                    e = te(Kt);
                    e.key = "*";
                } else {
                    x("{");
                    t = [];
                    while (F()) {
                        var i;
                        if (ze(p(), "name", "as")) {
                            var r = _.token.value;
                            b();
                            b();
                            i = te(Kt);
                            i.key = r;
                        } else {
                            i = te(Kt);
                            i.key = i.name;
                        }
                        t.push(i);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) f("name", "from");
            var a = _.token;
            f("string");
            k();
            return new Ee({
                all: e,
                default: n,
                path: a.value,
                properties: t,
                quote: a.quote
            });
        }
        function N() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(h());
            }
            b();
            return e;
        }
        function H() {
            x("{");
            var e = [], n, t, i, r;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new ut({
                        start: (r = _.token, b(), r),
                        expression: ve(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (i) o("More than one default clause in switch statement");
                    t = [];
                    n = new ft({
                        start: (r = _.token, b(), x(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) w();
                    t.push(h());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function Y() {
            var e = N(), n = null, t = null;
            if (g("keyword", "catch")) {
                var i = _.token;
                b();
                var r = null;
                if (g("punc", "(")) {
                    b();
                    r = ie(ri);
                    x(")");
                }
                n = new lt({
                    start: i,
                    argname: r,
                    body: N(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var i = _.token;
                b();
                t = new pt({
                    start: i,
                    body: N(),
                    end: y()
                });
            }
            if (!n && !t) o("Missing catch/finally blocks");
            return new ct({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function I(e, n) {
            var t = [];
            for (;;) {
                var i = _.token;
                var r = ie(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = he(n);
                } else if (!n && (e === Xt || r instanceof Nt)) {
                    o("Missing initializer in declaration");
                }
                t.push(new _t({
                    start: i,
                    name: r,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        var B = function(e) {
            return new ht({
                start: y(),
                definitions: I(Xt, e),
                end: y()
            });
        };
        var R = function(e) {
            return new vt({
                start: y(),
                definitions: I(Qt, e),
                end: y()
            });
        };
        var L = function(e) {
            return new mt({
                start: y(),
                definitions: I(Zt, e),
                end: y()
            });
        };
        var U = function(e) {
            var n = _.token;
            f("operator", "new");
            var t;
            if (g("punc", ".") && ze(p(), "name", "target")) {
                b();
                b();
                t = new ci();
            } else {
                var i = G(false), r;
                if (g("punc", "(")) {
                    b();
                    r = W(")", !c.strict);
                } else {
                    r = [];
                }
                t = new kt({
                    expression: i,
                    args: r
                });
            }
            t.start = n;
            t.end = y();
            return oe(t, e);
        };
        function V() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new hi({
                        value: t
                    });
                } else {
                    e = new wi();
                    if (t < 0) e = new $t({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new vi({
                    value: t
                });
                break;

              case "string":
                e = new di({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new mi({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new ki();
                    break;

                  case "true":
                    e = new Ei();
                    break;

                  case "null":
                    e = new _i();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var G = function(e) {
            if (g("operator", "new")) {
                return U(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    var t = ae(null);
                    t.start = n;
                    t.end = y();
                    return oe(t, e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return $([], n);
                    }
                    var i = ve(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(i.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = i.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var a = n.comments_before[0];
                        if (!a.nlb) {
                            a.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = i.start.comments_after;
                    i.start = n;
                    x(")");
                    var o = y();
                    o.comments_before = i.end.comments_before;
                    o.comments_after.forEach(function(e) {
                        i.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    o.comments_after.length = 0;
                    o.comments_after = i.end.comments_after;
                    i.end = o;
                    if (g("punc", "=>")) return $(i instanceof Et ? i.expressions : [ i ], n);
                    return oe(i, e);

                  case "[":
                    return oe(J(), e);

                  case "{":
                    return oe(K(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var s = A(Wn);
                s.start = n;
                s.end = y();
                return oe(s, e);

              case "function":
                b();
                var f;
                if (g("operator", "*")) {
                    b();
                    f = z(Yn);
                } else {
                    f = z(Hn);
                }
                f.start = n;
                f.end = y();
                return oe(f, e);
            }
            if (g("name")) {
                var u = ee(ai, n);
                b();
                if (u.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var f;
                        if (g("operator", "*")) {
                            b();
                            f = z(Nn);
                        } else {
                            f = z(Pn);
                        }
                        f.start = n;
                        f.end = y();
                        return oe(f, e);
                    }
                    if (g("name") && ze(p(), "punc", "=>")) {
                        n = _.token;
                        u = ee(ai, n);
                        b();
                        return $([ u ], n, true);
                    }
                    if (g("punc", "(")) {
                        var c = oe(u, e);
                        if (!g("punc", "=>")) return c;
                        var l = c.args;
                        if (l[l.length - 1] instanceof Dt) {
                            l.rest = l.pop().expression;
                        }
                        return $(l, n, true);
                    }
                }
                return g("punc", "=>") ? $([ u ], n) : oe(u, e);
            }
            if (Ce[_.token.type]) {
                return oe(V(), e);
            }
            w();
        };
        function W(e, n, t, i) {
            if (!i) i = he;
            var r = true, a = [];
            while (!g("punc", e)) {
                if (r) r = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new yi({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(i());
                } else if (i === he) {
                    a.push(new Dt({
                        start: _.token,
                        expression: (b(), i()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = i();
                    if (a.rest instanceof wt) s(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var J = n(function() {
            x("[");
            return new Pt({
                elements: W("]", !c.strict, true)
            });
        });
        var X = n(function() {
            return z(On);
        });
        var K = n(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!c.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var i = Q();
                    var r = _.token;
                    var a = z(Yn);
                    a.start = r;
                    a.end = y();
                    n.push(new Ut({
                        start: t,
                        key: i,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new Dt({
                        start: t,
                        expression: he(),
                        end: y()
                    }));
                    continue;
                }
                if (ze(p(), "operator", "=")) {
                    var o = te(ai);
                    b();
                    n.push(new Lt({
                        start: t,
                        key: t.value,
                        value: new Mt({
                            start: t,
                            left: o,
                            operator: "=",
                            right: he(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if (ze(p(), "punc", ",") || ze(p(), "punc", "}")) {
                    n.push(new Lt({
                        start: t,
                        key: t.value,
                        value: te(ai),
                        end: y()
                    }));
                    continue;
                }
                var i = Q();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = z(Hn);
                    f.start = s;
                    f.end = y();
                    n.push(new Ut({
                        start: t,
                        key: i,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new Lt({
                        start: t,
                        key: i,
                        value: he(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (i) {
                  case "async":
                    var u = g("operator", "*") && b();
                    i = Q();
                    var s = _.token;
                    var f = z(u ? Nn : Pn);
                    f.start = s;
                    f.end = y();
                    n.push(new Ut({
                        start: t,
                        key: i,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new Gt({
                        start: t,
                        key: Q(),
                        value: X(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new Vt({
                        start: t,
                        key: Q(),
                        value: X(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new Bt({
                properties: n
            });
        });
        function Q() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!De[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = he();
                x("]");
                return n;

              default:
                w();
            }
        }
        function Z() {
            var e = _.token.value;
            f("name");
            return e;
        }
        function ee(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = fi;
                break;

              case "this":
                e = ui;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function ne(e) {
            if (e.name == "arguments" || e.name == "eval") s(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function te(e, n) {
            if (!g("name")) {
                if (!n) o("Name expected");
                return null;
            }
            var t = ee(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof Jt) {
                ne(t);
            }
            b();
            return t;
        }
        function ie(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = W("]", !c.strict, true, function() {
                    return re(e);
                });
                return new Ht({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var i = true, r = [], a = null;
                while (!g("punc", "}")) {
                    if (i) i = false; else x(",");
                    if (!c.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || ze(p(), "punc", ":")) {
                        var s = Q();
                        x(":");
                        r.push(new Yt({
                            start: o,
                            key: s,
                            value: re(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = ie(e);
                        break;
                    }
                    var f = te(e);
                    if (g("operator", "=")) {
                        b();
                        f = new wt({
                            start: f.start,
                            name: f,
                            value: he(),
                            end: y()
                        });
                    }
                    r.push(new Yt({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new It({
                    start: n,
                    properties: r,
                    rest: a,
                    end: y()
                });
            }
            return te(e);
        }
        function re(e) {
            var n = _.token;
            var t = ie(e);
            if (!g("operator", "=")) return t;
            b();
            return new wt({
                start: n,
                name: t,
                value: he(),
                end: y()
            });
        }
        function ae(e) {
            var n = _.input.context().read_template;
            var t = [];
            var i = [];
            while (n(t)) {
                b();
                i.push(ve());
                if (!g("punc", "}")) w();
            }
            b();
            return new li({
                expressions: i,
                strings: t,
                tag: e
            });
        }
        var oe = function(e, n) {
            var t = e.start;
            if (g("punc", ".")) {
                b();
                return oe(new Tt({
                    start: t,
                    expression: e,
                    property: Z(),
                    end: y()
                }), n);
            }
            if (g("punc", "[")) {
                b();
                var i = ve();
                x("]");
                return oe(new At({
                    start: t,
                    expression: e,
                    property: i,
                    end: y()
                }), n);
            }
            if (n && g("punc", "(")) {
                b();
                var r = new xt({
                    start: t,
                    expression: e,
                    args: W(")", !c.strict),
                    end: y()
                });
                return oe(r, true);
            }
            if (g("punc", "`")) {
                var a = ae(e);
                a.start = e.start;
                a.end = y();
                return oe(a, n);
            }
            if (e instanceof xt && !e.pure) {
                var t = e.start;
                var o = t.comments_before;
                var s = rn(t, "comments_before_length") ? t.comments_before_length : o.length;
                while (--s >= 0) {
                    var f = /[@#]__PURE__/.exec(o[s].value);
                    if (f) {
                        e.pure = f[0];
                        break;
                    }
                }
            }
            return e;
        };
        function se(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) o("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new Ct({
                    start: n,
                    expression: se(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) o("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var i = false;
                if (g("operator", "*")) {
                    b();
                    t = he(e);
                    i = true;
                } else if (g("punc") ? !Oe[_.token.value] : !l()) {
                    t = he(e);
                }
                return new jt({
                    start: n,
                    expression: t,
                    nested: i,
                    end: y()
                });
            }
            if (g("operator") && Fe[n.value]) {
                b();
                E();
                var r = fe($t, n, se(e));
                r.start = n;
                r.end = y();
                return r;
            }
            var a = G(true);
            while (g("operator") && $i[_.token.value] && !u(_.token)) {
                a = fe(zt, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function fe(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!pe(t)) s(n, "Invalid use of " + i + " operator");
                break;

              case "delete":
                if (t instanceof ai && _.input.has_directive("use strict")) s(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var ue = function(e, n, t) {
            var i = g("operator") ? _.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? zi[i] : null;
            if (r != null && r > n) {
                b();
                var a = ue(se(t), i == "**" ? r - 1 : r, t);
                return ue(new qt({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function ce(e) {
            return ue(se(e), 0, e);
        }
        var le = function(e) {
            var n = _.token;
            var t = ce(e);
            if (g("operator", "?")) {
                b();
                var i = he();
                x(":");
                return new Ft({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: he(e),
                    end: y()
                });
            }
            return t;
        };
        function pe(e) {
            return e instanceof St || e instanceof ai;
        }
        function de(e) {
            if (e instanceof Pt) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Dt) {
                    n = de(e.elements.pop().expression);
                    if (!(n instanceof Nt || pe(n))) return e;
                }
                var t = e.elements.map(de);
                return nn(t, function(e) {
                    return e instanceof wt || e instanceof Nt || e instanceof yi || pe(e);
                }) ? new Ht({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Mt) {
                var i = de(e.left);
                return i instanceof Nt || pe(i) ? new wt({
                    start: e.start,
                    name: i,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof Bt)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof Dt) {
                n = de(e.properties.pop().expression);
                if (!(n instanceof Nt || pe(n))) return e;
            }
            var r = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof Lt)) return e;
                var s = de(o.value);
                if (!(s instanceof wt || s instanceof Nt || pe(s))) {
                    return e;
                }
                r.push(new Yt({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new It({
                start: e.start,
                properties: r,
                rest: n,
                end: e.end
            });
        }
        function he(e) {
            var n = _.token;
            var t = le(e), i = _.token.value;
            if (g("operator") && Me[i]) {
                if (pe(t) || i == "=" && (t = de(t)) instanceof Nt) {
                    b();
                    return new Mt({
                        start: n,
                        left: t,
                        operator: i,
                        right: he(e),
                        end: y()
                    });
                }
                o("Invalid assignment");
            }
            return t;
        }
        function ve(e, n) {
            var t = _.token;
            var i = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    i.rest = ie(ei);
                    break;
                }
                i.push(he(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && ze(p(), "punc", "=>")) break;
            }
            return i.length == 1 && !i.rest ? i[0] : new Et({
                start: t,
                expressions: i,
                end: y()
            });
        }
        function me(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (c.expression) {
            E();
            var _e = ve();
            f("eof");
            return _e;
        }
        return function() {
            var e = _.token;
            var n = [];
            _.input.push_directives_stack();
            while (!g("eof")) n.push(h());
            _.input.pop_directives_stack();
            var t = y();
            var i = c.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new An({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function g(e, n, t, i) {
        this.eliminated = 0;
        this.exported = false;
        this.global = false;
        this.id = e;
        this.init = i;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    g.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = x(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this.defun;
            if (!e) return;
            var n = this.name;
            var t = e.variables.get(n) || e instanceof An && e.globals.get(n) || this.orig[0] instanceof Xt && Le(function(e) {
                return e.name == n;
            }, e.enclosed);
            if (t && t !== this) return t.redefined() || t;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.exported || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof ii || this.orig[0] instanceof Se || this.orig[0] instanceof ni || this.orig[0] instanceof ti);
        }
    };
    var Fi = en("delete ++ --");
    function Mi(e, n) {
        if (n instanceof Mt) return n.left === e && e;
        if (n instanceof wt) return n.name === e && e;
        if (n instanceof Nt) return e;
        if (n instanceof Yt) return e;
        if (n instanceof kn) return n.init === e && e;
        if (n instanceof Ot) return Fi[n.operator] && n.expression;
    }
    An.DEFMETHOD("figure_out_scope", function(c) {
        c = ge(c, {
            cache: null,
            ie8: false
        });
        var l = this;
        var s = null;
        var f = false;
        var t = 0;
        var u = l.parent_scope = null;
        var p = new Si(function(i, e) {
            if (i instanceof Gn) {
                var n = f;
                f = p.parent() instanceof gt;
                i.name.walk(p);
                f = n;
                a(function() {
                    if (i.extends) i.extends.walk(p);
                    i.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (i instanceof dt) {
                var n = f;
                f = p.parent() instanceof gt;
                e();
                f = n;
                return true;
            }
            if (i instanceof In) {
                var n = f;
                f = p.parent() instanceof gt;
                i.name.walk(p);
                f = n;
                a(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (i.rest) i.rest.walk(p);
                    hn(i, p);
                });
                return true;
            }
            if (i instanceof st) {
                i.init_vars(u);
                e();
                return true;
            }
            if (i instanceof ct) {
                a(function() {
                    hn(i, p);
                });
                if (i.bcatch) i.bcatch.walk(p);
                if (i.bfinally) i.bfinally.walk(p);
                return true;
            }
            if (i instanceof Sn) {
                var t = u;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (i instanceof dn) {
                a(e);
                return true;
            }
            if (i instanceof Wt) {
                i.scope = u;
            }
            if (i instanceof Te) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof ri) {
                u.def_variable(i).defun = s;
            } else if (i instanceof Xt) {
                var r = u.def_variable(i);
                r.defun = s;
                if (f) r.exported = true;
            } else if (i instanceof ni) {
                var r = s.def_function(i, p.parent());
                if (f) r.exported = true;
                o(s, u);
            } else if (i instanceof ei) {
                s.def_variable(i);
                o(s, u);
            } else if (i instanceof ti) {
                var r = s.def_function(i, i.name == "arguments" ? undefined : s);
                if (c.ie8) r.defun = s.parent_scope.resolve();
            } else if (i instanceof Qt) {
                var r = u.def_variable(i);
                if (f) r.exported = true;
            } else if (i instanceof Zt) {
                var r = s.def_variable(i, i instanceof Kt ? undefined : null);
                if (f) r.exported = true;
                o(s, u);
            }
            function a(e) {
                i.init_vars(u);
                var n = s;
                var t = u;
                if (i instanceof Tn) s = i;
                u = i;
                e();
                u = t;
                s = n;
            }
            function o(e, n) {
                if (e === n) return;
                i.mark_enclosed(c);
                var t = n.find_variable(i.name);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(c);
            }
        });
        l.make_def = function(e, n) {
            return new g(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new tn();
        var d = [];
        var p = new Si(function(e) {
            if (e instanceof lt) {
                if (!(e.argname instanceof Nt)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                hn(e, p);
                return true;
            }
            if (e instanceof Dn) {
                d.push(e);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                Mn(e, p);
                return true;
            }
            if (e instanceof tt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof Jt) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof ri) {
                    var t = n.redefined();
                    if (t) for (var i = e.scope; i; i = i.parent_scope) {
                        Ke(i.enclosed, t);
                        if (i === t.scope) break;
                    }
                } else if (e instanceof Xt) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                }
                if (e.name != "arguments") return true;
                var r = e instanceof Zt && p.parent();
                if (r instanceof _t && !r.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && h(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof ai) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof ri || f instanceof ei || f instanceof ti) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && h(a)) {
                    var r = p.parent();
                    if (Mi(e, r)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(r instanceof St && r.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var r = p.parent();
                    if (r.TYPE == "Call" && r.expression === e) {
                        var i = e.scope;
                        do {
                            i = i.resolve();
                            if (i.uses_eval) break;
                            i.uses_eval = true;
                        } while (i = i.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof In && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie8) l.walk(new Si(function(e) {
            if (e instanceof ri) {
                var n = e.thedef.defun;
                if (n.name instanceof ti && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof ti) {
                var t = e.thedef;
                if (!i(e, e.scope.parent_scope.resolve())) {
                    delete t.defun;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function h(e) {
            return e.orig[0] instanceof ei && !(e.orig[1] instanceof ei || e.orig[2] instanceof ei) && !zn(e.scope);
        }
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!nn(i.orig, function(e) {
                return !(e instanceof Xt || e instanceof Qt);
            })) return false;
            var r = n.find_variable(t);
            if (r) {
                var a = r.redefined();
                if (a) r = a;
            } else {
                r = l.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = i;
                e.thedef = r;
                e.reference(c);
            });
            if (r.undeclared) l.variables.set(t, r);
            return true;
        }
    });
    An.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function b(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new tn();
        e.variables = new tn();
        if (n) e.make_def = n.make_def;
    }
    function y(e, n) {
        b(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    dn.DEFMETHOD("init_vars", function(e) {
        b(this, e);
    });
    Tn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    Cn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        return this;
    });
    jn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    Dn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        this.uses_arguments = false;
        this.def_variable(new ei({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    Wt.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            Ke(t.enclosed, n);
            if (!e) {
                delete t._var_names;
            } else if (e.keep_fnames) {
                t.functions.each(function(e) {
                    Ke(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Wt.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    dn.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    dn.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof In) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    dn.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof $n) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function w(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function x(e, i) {
        var n = e.scope;
        var t = w(n, i);
        var r = n.cname_holes;
        var a = Object.create(null);
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (o.indexOf(n) < 0) {
                    for (var t in w(n, i)) {
                        a[t] = true;
                    }
                    o.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = E(r[f]);
            if (a[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = E(++n.cname);
            if (t[s] || P[s] || i.reserved.has[s]) continue;
            if (!a[s]) break;
            r.push(n.cname);
        }
        t[s] = true;
        return s;
    }
    Wt.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Te.DEFMETHOD("unmangleable", Ve);
    Wt.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function k(e) {
        e = ge(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Ke(e.reserved, "arguments");
        e.reserved.has = en(e.reserved);
        return e;
    }
    An.DEFMETHOD("mangle_names", function(a) {
        a = k(a);
        var o = -1;
        if (a.cache && a.cache.props) {
            var n = w(this, a);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var s = [];
        var f = new Si(function(n, e) {
            if (n instanceof _n) {
                var t = o;
                e();
                if (!a.v8 || !l(f)) o = t;
                return true;
            }
            if (n instanceof dn) {
                if (a.webkit && n instanceof gn && n.init instanceof vt) {
                    n.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof Qt)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                n.to_mangle = [];
                n.variables.each(function(e) {
                    if (!c(e)) n.to_mangle.push(e);
                });
                e();
                if (a.cache && n instanceof An) {
                    n.globals.each(u);
                }
                if (n instanceof Ln && f.has_directive("use asm")) {
                    var i = new ai(n.name);
                    i.scope = n;
                    i.reference(a);
                }
                n.to_mangle.forEach(u);
                return true;
            }
            if (n instanceof Te) {
                var r;
                do {
                    r = E(++o);
                } while (P[r]);
                n.mangled_name = r;
                return true;
            }
        });
        this.walk(f);
        s.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function c(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof Xt)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            s.push(n);
            n.references.forEach(r);
            if (e instanceof ri || e instanceof Xt) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
        function l(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof vn) return t instanceof An && !a.toplevel;
                if (t instanceof _n) return true;
            }
        }
    });
    An.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(P);
        t.reserved.forEach(r);
        this.globals.each(a);
        this.walk(new Si(function(e) {
            if (e instanceof dn) e.variables.each(a);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    An.DEFMETHOD("expand_names", function(i) {
        E.reset();
        E.sort();
        i = k(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(a);
        this.walk(new Si(function(e) {
            if (e instanceof dn) e.variables.each(a);
        }));
        function r() {
            var e;
            do {
                e = E(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    on.DEFMETHOD("tail_node", We);
    Et.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    An.DEFMETHOD("compute_char_frequency", function(e) {
        e = k(e);
        E.reset();
        var n = Wt.prototype.add_source_map;
        try {
            Wt.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) E.consider(this.name, -1);
            };
            if (e.properties) {
                Tt.prototype.add_source_map = function() {
                    E.consider(this.property, -1);
                };
                At.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            E.consider(this.print_to_string(), 1);
        } finally {
            Wt.prototype.add_source_map = n;
            delete Tt.prototype.add_source_map;
            delete At.prototype.add_source_map;
        }
        E.sort();
        function t(e) {
            if (e instanceof di) {
                E.consider(e.value, -1);
            } else if (e instanceof Ft) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Et) {
                t(e.tail_node());
            }
        }
    });
    var E = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, a;
        function o() {
            a = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = o;
        o();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Ci(e, n) {
        if (!(this instanceof Ci)) return new Ci(e, n);
        Ti.call(this, this.before, this.after);
        this.options = ge(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && rn(i, r)) {
                i[r.slice(1)] = qi(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        this.drop_fargs = this.options["keep_fargs"] ? Ve : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !Re(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = Ge;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return Re(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    Ci.prototype = new Ti();
    t(Ci.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.exported) return true;
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof An)) return false;
            var n = this.toplevel;
            return !nn(e.orig, function(e) {
                return n[e instanceof ni ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            e.hoist_exports(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var a = 0; a < n; a++) {
                e.figure_out_scope(r);
                if (a > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var o = 0;
                    e.walk(new Si(function() {
                        o++;
                    }));
                    on.info("pass {pass}: last_count: {min_count}, count: {count}", {
                        pass: a,
                        min_count: t,
                        count: o
                    });
                    if (o < t) {
                        t = o;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof Tn;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(on, function(e, n) {
            return e;
        });
        on.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        An.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var i = 0; i < n.length; i++) {
                var r = n[i];
                if (r instanceof gt) {
                    n[i] = r = r.body;
                    if (r instanceof dt) {
                        r.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(r.name);
                    }
                } else if (r instanceof yt) {
                    n.splice(i--, 1);
                    [].push.apply(t, r.properties);
                }
            }
            if (t.length) n.push(xe(yt, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof Jt)) return;
                var n = xe(oi, e, e);
                n.alias = n.name;
                t.push(n);
            }
        });
        Tn.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var a = new Ti(function(e) {
                if (t && e instanceof pn) {
                    return xe(et, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof et) {
                    return i ? i(e) : xe(pn, e, {
                        body: e.value || xe($t, e, {
                            operator: "void",
                            expression: xe(hi, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof Dn && e !== r) {
                    return e;
                }
                if (e instanceof vn) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(a);
                    }
                } else if (e instanceof at) {
                    e.body = e.body.transform(a);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(a);
                    }
                } else if (e instanceof Sn) {
                    e.body = e.body.transform(a);
                }
                return e;
            });
            r.transform(a);
        });
        function T(e, n) {
            var t = n.getProperty();
            if (t instanceof on) return;
            var i;
            if (e instanceof Pt) {
                var r = e.elements;
                if (t == "length") return le(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof Dn) {
                if (t == "length") {
                    e.length_read = true;
                    return le(e.argnames.length, e);
                }
            } else if (e instanceof Bt) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!Be(s)) return;
                    if (!i && a[o].key === t) i = a[o].value;
                }
            }
            return i instanceof ai && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof xi) return E.Boolean[n];
            if (e instanceof hi) return E.Number[n];
            if (e instanceof di) return E.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Pt) return E.Array[n];
            if (e instanceof Dn) return E.Function[n];
            if (e instanceof Bt) return E.Object[n];
            if (e instanceof mi) return E.RegExp[n] && !e.value.global;
        }
        function _e(e, n, t, i, r, a, o) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof Tt && l(i, s.property)) {
                return;
            }
            var f = Mi(t, s);
            if (f) return f;
            if (s instanceof Pt) return _e(e, n, s, s, r + 1);
            if (s instanceof qt) {
                if (!De[s.operator]) return;
                return _e(e, n, s, s, r + 1);
            }
            if (s instanceof xt) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(i instanceof $n) || !(s instanceof kt) && i.contains_this());
            }
            if (s instanceof Ft) {
                if (s.condition === t) return;
                return _e(e, n, s, s, r + 1);
            }
            if (s instanceof kn) return s.init === t;
            if (s instanceof Lt) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return _e(e, n, u, u, r + 2);
            }
            if (s instanceof St) {
                if (s.expression !== t) return;
                var c = T(i, s);
                return (!a || o) && _e(e, n, s, c, r + 1);
            }
            if (s instanceof Et) {
                if (s.tail_node() !== t) return;
                return _e(e, n, s, i, r + 1, a, o);
            }
        }
        function A(e) {
            return e instanceof Vn || e instanceof Dn;
        }
        function u(e) {
            return e instanceof Vn || e instanceof Ln || e instanceof Hn;
        }
        function ge(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function be(e) {
            return e.orig[0] instanceof ei || e.orig[1] instanceof ei;
        }
        function W(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof Tn) return true;
            } while (n = n.parent_scope);
        }
        function ye(e, n, t) {
            var i = e.definition();
            if (e.in_arg && be(i)) return false;
            return nn(i.orig, function(e) {
                if (e instanceof Xt || e instanceof Qt) {
                    return n && G(n, e);
                }
                return !(t && e instanceof ti);
            });
        }
        var D = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(on, Ue);
            function o(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof $n && t.init !== t.scope) && t.init;
                if (t.fixed instanceof In && !nn(t.references, function(e) {
                    var n = e.scope.resolve();
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof $n && (n = n.parent_scope.resolve()));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function l(n, t, e) {
                e.variables.each(function(e) {
                    o(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        v(n, e);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        v(n, e);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Ue;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof In && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (e.uses_arguments) e.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function u(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!_(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function p(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof In && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function d(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function h(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function v(e, n) {
                e.safe_ids[n.id] = {};
            }
            function m(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function _(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!rn(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (ge(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = xe(bi, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof In;
            }
            function g(e, n, t) {
                if (!(t || nn(n.orig, function(e) {
                    return !(e instanceof Xt);
                }))) return false;
                if (n.fixed === undefined) return t || nn(n.orig, function(e) {
                    return !(e instanceof Qt);
                });
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (!rn(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read && n.scope !== e.find_parent(Tn)) return false;
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return _(e, n) && nn(n.orig, function(e) {
                    return !(e instanceof ti);
                });
            }
            function b(e, n) {
                var t = xe(ai, e, e);
                t.fixed = n || xe(bi, e);
                return t;
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(be(n) && n.scope.uses_arguments);
            }
            function y(e) {
                if (!e) return false;
                return e.is_constant() || A(e) || e instanceof si;
            }
            function w(e, n, t) {
                if (t instanceof Mt) return t.operator == "=" && t.right === n;
                if (t instanceof xt) return t.expression !== n || t instanceof kt;
                if (t instanceof Zn) return t.value === n && n.scope !== e.scope;
                if (t instanceof _t) return t.value === n;
            }
            function x(e, n) {
                if (n instanceof Pt) return true;
                if (n instanceof qt) return De[n.operator];
                if (n instanceof Ft) return n.condition !== e;
                if (n instanceof Et) return n.tail_node() === e;
                if (n instanceof Dt) return true;
            }
            function k(e, n, t, i, r, a, o) {
                var s = e.parent(a);
                if (r && r.is_constant()) return;
                if (w(n, i, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(r && r.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    return;
                } else if (x(i, s)) {
                    k(e, n, t, s, s, a + 1, o);
                } else if (s instanceof Lt && s.value === i) {
                    var f = e.parent(a + 1);
                    k(e, n, t, f, f, a + 2, o);
                } else if (s instanceof St && s.expression === i) {
                    r = T(r, s);
                    k(e, n, t, s, r, a + 1, o + 1);
                    if (r) return;
                }
                if (a > 0) return;
                if (s instanceof xt && s.expression === i) return;
                if (s instanceof Et && s.tail_node() !== i) return;
                if (s instanceof pn) return;
                if (s instanceof Ot && !Fi[s.operator]) return;
                n.direct_access = true;
            }
            function E(e) {
                if (!(e instanceof At)) return;
                var n = e.expression;
                if (!(n instanceof ai)) return;
                var t = n.definition();
                if (!ge(t)) return;
                var i = e.property;
                if (i.is_constant()) i = i.value;
                if (!(i instanceof on) && !D.test(i)) return;
                t.reassigned++;
                (i instanceof on ? t.scope.argnames : [ t.scope.argnames[i] ]).forEach(function(e) {
                    if (e instanceof ei) e.definition().fixed = false;
                });
            }
            function S(a, e, n, o, t) {
                var s = new Si(function(i) {
                    if (i instanceof wt) {
                        f(i);
                        d(a);
                        i.value.walk(a);
                        h(a);
                        var r = o;
                        if (r) o = function() {
                            var e = r();
                            return Ae(e) ? ce(i, [ e, i.value ]) : i;
                        };
                        i.name.walk(s);
                        o = r;
                        return true;
                    }
                    if (i instanceof Ht) {
                        f(i);
                        var r = o;
                        i.elements.forEach(function(e, n) {
                            if (e instanceof yi) return f(e);
                            if (r) o = function() {
                                return xe(At, e, {
                                    expression: r(),
                                    property: xe(hi, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(s);
                        });
                        if (i.rest) {
                            if (r) o = e.option("rests") && function() {
                                var e = r();
                                return e instanceof Pt ? xe(Pt, i, {
                                    elements: e.elements.slice(i.elements.length)
                                }) : i;
                            };
                            i.rest.walk(s);
                        }
                        o = r;
                        return true;
                    }
                    if (i instanceof It) {
                        f(i);
                        var r = o;
                        i.properties.forEach(function(t) {
                            f(t);
                            if (t.key instanceof on) {
                                d(a);
                                t.key.walk(a);
                                h(a);
                            }
                            if (r) o = function() {
                                var e = t.key;
                                var n = At;
                                if (typeof e == "string") {
                                    if (Ai(e)) {
                                        n = Tt;
                                    } else {
                                        e = le(e, t);
                                    }
                                }
                                return xe(n, t, {
                                    expression: r(),
                                    property: e
                                });
                            };
                            t.value.walk(s);
                        });
                        if (i.rest) {
                            o = false;
                            i.rest.walk(s);
                        }
                        o = r;
                        return true;
                    }
                    t(i, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        i.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                n.walk(s);
            }
            function s(r, e, n) {
                var a = this;
                a.inlined = false;
                var o = r.parent();
                var t = qn(a) || Fn(a);
                var i = false;
                a.walk(new Si(function(e) {
                    if (t) return i = true;
                    if (e instanceof et) return t = true;
                    if (e instanceof Tn && e !== a) return true;
                }));
                if (i) d(r);
                l(r, n, a);
                var s = !a.uses_arguments || r.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var i = o.args[e];
                    S(r, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? i : o.args[e];
                        if (n instanceof Et && n.expressions.length < 2) n = n.expressions[0];
                        return n || xe(bi, o);
                    }, c);
                });
                var f = a.rest;
                if (f) S(r, n, f, n.option("rests") && function() {
                    return a.rest === f ? xe(Pt, a, {
                        elements: o.args.slice(a.argnames.length)
                    }) : f;
                }, c);
                Mn(a, r);
                var u = r.safe_ids;
                h(r);
                p(r, a);
                if (!i) r.safe_ids = u;
                return true;
                function c(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        v(r, t);
                        r.loop_ids[t.id] = r.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(Mt, function(r, e, a) {
                var o = this;
                var s = o.left;
                var n = s instanceof Nt || s instanceof ai;
                switch (o.operator) {
                  case "=":
                    if (s.equivalent_to(o.right) && !s.has_side_effects(a)) {
                        o.right.walk(r);
                        u(s);
                        o.__drop = true;
                        return true;
                    }
                    if (n) {
                        c();
                        return true;
                    }
                    E(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    s.walk(r);
                    d(r);
                    if (n) {
                        c();
                    } else {
                        E(s);
                        o.right.walk(r);
                    }
                    h(r);
                    return true;

                  default:
                    if (!n) {
                        E(s);
                        return;
                    }
                    var t = s.definition();
                    t.assignments++;
                    var i = t.fixed;
                    if (_e(a, r, o, o, 0)) {
                        t.fixed = false;
                        return;
                    }
                    var f = _(r, t);
                    o.right.walk(r);
                    if (f && !s.in_arg && g(r, t)) {
                        m(t, s);
                        v(r, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return xe(qt, o, {
                                operator: o.operator.slice(0, -1),
                                left: b(s, i),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !i || !i.assigns ? [] : i.assigns.slice();
                        s.fixed.assigns.push(o);
                    } else {
                        s.walk(r);
                        t.fixed = false;
                    }
                    return true;
                }
                function u(e) {
                    if (e instanceof Tt) {
                        u(e.expression);
                    } else if (e instanceof At) {
                        u(e.expression);
                        e.property.walk(r);
                    } else if (e instanceof ai) {
                        var n = e.definition();
                        m(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(r);
                    }
                }
                function c() {
                    o.right.walk(r);
                    S(r, a, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof ai)) {
                            E(e);
                            t();
                            return;
                        }
                        var i = e.definition();
                        i.assignments++;
                        if (n && !_e(a, r, o, o.right, 0) && !e.in_arg && g(r, i)) {
                            m(i, e);
                            v(r, i);
                            if (i.single_use && s instanceof Nt) i.single_use = false;
                            r.loop_ids[i.id] = r.in_loop;
                            k(r, i, e.scope, o, o.right, 0, 1);
                            e.fixed = i.fixed = n;
                            e.fixed.assigns = [ o ];
                        } else {
                            t();
                            i.fixed = false;
                        }
                    });
                }
            });
            e(qt, function(e) {
                if (!De[this.operator]) return;
                this.left.walk(e);
                d(e);
                this.right.walk(e);
                h(e);
                return true;
            });
            e(dn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
            });
            e(xt, function(n, e) {
                n.find_parent(Tn).may_call_this();
                var t = this.expression;
                if (t instanceof $n) {
                    var i = Se(this);
                    this.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Dt) i = false;
                    });
                    if (i) t.reduce_vars = s;
                    t.walk(n);
                    if (i) delete t.reduce_vars;
                    return true;
                } else if (t instanceof ai) {
                    var r = t.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) r.bool_fn++;
                    if (!(r.fixed instanceof In)) return;
                    var a = u(n, r);
                    if (!a) return;
                    e();
                    a.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof Mt && t.operator == "=" && t.left instanceof ai && n.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(Vn, function(n, e, t) {
                var i = this;
                i.variables.each(function(e) {
                    o(n, t, e);
                });
                if (i.extends) i.extends.walk(n);
                if (i.name) {
                    var r = i.name.definition();
                    var a = n.parent();
                    if (a instanceof gt || a instanceof bt) r.single_use = false;
                    if (g(n, r, true)) {
                        v(n, r);
                        n.loop_ids[r.id] = n.in_loop;
                        r.fixed = function() {
                            return i;
                        };
                        r.fixed.assigns = [ i ];
                        if (!K(r)) r.single_use = false;
                    } else {
                        r.fixed = false;
                    }
                }
                i.properties.filter(function(e) {
                    f(e);
                    if (e.key instanceof on) e.key.walk(n);
                    return e.value;
                }).forEach(function(e) {
                    if (e.static && (e.value instanceof Dn || !e.value.contains_this())) {
                        e.value.walk(n);
                    } else {
                        d(n);
                        e.value.walk(n);
                        h(n);
                    }
                });
                return true;
            });
            e(Ft, function(e) {
                this.condition.walk(e);
                d(e);
                this.consequent.walk(e);
                h(e);
                d(e);
                this.alternative.walk(e);
                h(e);
                return true;
            });
            e(wt, function(e) {
                this.name.walk(e);
                d(e);
                this.value.walk(e);
                h(e);
                return true;
            });
            e(yn, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                d(e);
                this.body.walk(e);
                if (I(this, e.parent())) {
                    h(e);
                    d(e);
                }
                this.condition.walk(e);
                h(e);
                e.in_loop = n;
                return true;
            });
            e(xn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                if (this.init) this.init.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                d(n);
                if (this.condition) this.condition.walk(n);
                this.body.walk(n);
                if (this.step) {
                    if (I(this, n.parent())) {
                        h(n);
                        d(n);
                    }
                    this.step.walk(n);
                }
                h(n);
                n.in_loop = i;
                return true;
            });
            e(kn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.object.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                d(n);
                var r = this.init;
                if (r instanceof dt) {
                    r.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof Jt) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, n);
                } else if (r instanceof Nt || r instanceof ai) {
                    r.mark_symbol(function(e) {
                        if (e instanceof ai) {
                            var n = e.definition();
                            m(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, n);
                } else {
                    r.walk(n);
                }
                this.body.walk(n);
                h(n);
                n.in_loop = i;
                return true;
            });
            e(at, function(e) {
                this.condition.walk(e);
                d(e);
                this.body.walk(e);
                h(e);
                if (this.alternative) {
                    d(e);
                    this.alternative.walk(e);
                    h(e);
                }
                return true;
            });
            e(_n, function(e) {
                d(e);
                this.body.walk(e);
                h(e);
                return true;
            });
            e(Dn, function(e, n, t) {
                var i = this;
                i.inlined = false;
                d(e);
                l(e, t, i);
                n();
                h(e);
                if (i.name) k(e, i.name.definition(), i, i.name, i, 0, 1);
                p(e, i);
                return true;
            });
            e(In, function(e, n, t) {
                var i = this;
                var r = i.name.definition();
                var a = e.parent();
                if (a instanceof gt || a instanceof bt) r.single_use = false;
                if (e.defun_visited[r.id]) return true;
                if (e.defun_ids[r.id] !== e.safe_ids) return true;
                e.defun_visited[r.id] = true;
                i.inlined = false;
                d(e);
                l(e, t, i);
                n();
                h(e);
                p(e, i);
                return true;
            });
            e(ot, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.expression.walk(n);
                var i = true;
                this.body.forEach(function(e) {
                    if (e instanceof ft) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        d(n);
                    }
                });
                if (!i) h(n);
                hn(this, n);
                return true;
            });
            e(st, function(e) {
                d(e);
                hn(this, e);
                h(e);
                return true;
            });
            e(ri, function() {
                this.definition().fixed = false;
            });
            e(Kt, function() {
                this.definition().fixed = false;
            });
            e(ai, function(e, n, t) {
                var i = this.definition();
                m(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof ni) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                if (i.fixed === false) {
                    var r = i.redefined();
                    if (r && W(i.scope, this.scope)) r.single_use = false;
                } else if (i.fixed === undefined || !_(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof ti) this.fixed = i.scope;
                    var a = this.fixed_value();
                    var o = je(e, i);
                    if (o) {
                        i.recursive_refs++;
                    } else if (a && c(t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = A(a) && !a.pinned() && (!i.in_loop || e.parent() instanceof xt) || !i.in_loop && i.scope === this.scope.resolve() && a.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (_e(t, e, this, a, 0, y(a), o)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    k(e, i, this.scope, this, a, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (i.fixed instanceof In && !((s = e.parent()) instanceof xt && s.expression === this)) {
                    var f = u(e, i);
                    if (f) f.walk(e);
                }
            });
            e(An, function(n, e, t) {
                this.globals.each(function(e) {
                    o(n, t, e);
                });
                d(n);
                l(n, t, this);
                e();
                h(n);
                p(n, this);
                return true;
            });
            e(ct, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                d(n);
                hn(this, n);
                h(n);
                if (this.bcatch) {
                    d(n);
                    this.bcatch.walk(n);
                    h(n);
                }
                if (this.bfinally) this.bfinally.walk(n);
                return true;
            });
            e(Ot, function(e, n) {
                var t = this;
                if (!$i[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof ai)) {
                    E(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var a = r.fixed;
                if (_(e, r) && !i.in_arg && g(e, r)) {
                    m(r, i);
                    v(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return xe(qt, t, {
                            operator: t.operator.slice(0, -1),
                            left: xe($t, t, {
                                operator: "+",
                                expression: b(i, a)
                            }),
                            right: xe(hi, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof $t) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return xe($t, t, {
                                operator: "+",
                                expression: b(i, a)
                            });
                        };
                        i.fixed.assigns = a && a.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(_t, function(i, e, n) {
                var r = this;
                if (r.value) {
                    r.value.walk(i);
                } else if (!(i.parent() instanceof vt)) {
                    return;
                }
                S(i, n, r.name, function() {
                    return r.value || xe(bi, r);
                }, function(e, n) {
                    var t = e.definition();
                    if (n && g(i, t, true)) {
                        v(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ r ];
                        if (e instanceof Xt && t.redefined() || !(ye(e) || K(t))) {
                            t.single_use = false;
                        }
                    } else {
                        t.fixed = false;
                    }
                });
                return true;
            });
            e(wn, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                d(e);
                n();
                h(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function f(e) {
            e._squeezed = false;
            e._optimized = false;
            delete e.fixed;
            if (e instanceof Tn) delete e._var_names;
        }
        An.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new Si(t.option("reduce_vars") ? function(e, n) {
                f(e);
                return e.reduce_vars(i, n, t);
            } : f);
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        Wt.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof on ? e : e();
        });
        ai.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            return e.orig.length == 1 && e.orig[0] instanceof ti;
        });
        on.DEFMETHOD("convert_symbol", Ue);
        function n(t, i) {
            return this.transform(new Ti(function(e, n) {
                if (e instanceof wt) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof Nt) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof Yt) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        }
        wt.DEFMETHOD("convert_symbol", n);
        Nt.DEFMETHOD("convert_symbol", n);
        function t(e, n) {
            var t = xe(e, this, this);
            n(t, this);
            return t;
        }
        Jt.DEFMETHOD("convert_symbol", t);
        ai.DEFMETHOD("convert_symbol", t);
        function i(n, t) {
            var i = new Si(function(e) {
                if (e instanceof wt) {
                    e.value.walk(t);
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof Yt) {
                    if (e.key instanceof on) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        }
        wt.DEFMETHOD("mark_symbol", i);
        Nt.DEFMETHOD("mark_symbol", i);
        function r(e) {
            return e(this);
        }
        Jt.DEFMETHOD("mark_symbol", r);
        ai.DEFMETHOD("mark_symbol", r);
        on.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        Nt.DEFMETHOD("match_symbol", function(n, t) {
            var i = false;
            var r = new Si(function(e) {
                if (i) return true;
                if (e instanceof wt) {
                    if (!t) return i = true;
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof Yt) {
                    if (!t && e.key instanceof on) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        });
        function g(e) {
            return e instanceof Rn || e instanceof Nn;
        }
        function fe(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        var ue = en("Infinity NaN undefined");
        function we(e, n) {
            if (e instanceof si) return true;
            if (e instanceof St) {
                e = e.expression;
                if (e instanceof ai) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return we(e, n);
            }
            if (e instanceof ai) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && ue[t.name];
            }
            return false;
        }
        function xe(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function ce(e, n) {
            if (n.length == 1) return n[0];
            return xe(Et, e, {
                expressions: n.reduce(b, [])
            });
        }
        function le(e, n) {
            switch (typeof e) {
              case "string":
                return xe(di, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return xe(gi, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? xe($t, n, {
                        operator: "-",
                        expression: xe(hi, n, {
                            value: -e
                        })
                    }) : xe(hi, n, {
                        value: e
                    });
                }
                return e < 0 ? xe($t, n, {
                    operator: "-",
                    expression: xe(wi, n)
                }) : xe(wi, n);

              case "boolean":
                return xe(e ? Ei : ki, n);

              case "undefined":
                return xe(bi, n);

              default:
                if (e === null) {
                    return xe(_i, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return xe(mi, n, {
                        value: e
                    });
                }
                throw new Error(Qe("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function pe(e, n) {
            return n instanceof St || Te(n) && n.name == "eval";
        }
        function ke(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && pe(e, i);
            } else if (n instanceof li) {
                r = n.tag === t && pe(e, i);
            } else if (n instanceof $t) {
                r = n.operator == "delete" || n.operator == "typeof" && Te(i);
            }
            return r ? ce(t, [ xe(hi, t, {
                value: 0
            }), i ]) : i;
        }
        function b(e, n) {
            if (n instanceof Et) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function $(e) {
            return e instanceof ht || e instanceof Gn || e instanceof vt;
        }
        function y(t) {
            if (t instanceof In) {
                var e = t.name.definition();
                return e.scope === t.name.scope || nn(e.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t.name.scope) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !$(t);
        }
        function z(e) {
            if (e === null) return [];
            if (e instanceof mn) return nn(e.body, y) ? e.body : [ e ];
            if (e instanceof cn) return [];
            if (ln(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function de(e) {
            if (e === null) return true;
            if (e instanceof cn) return true;
            if (e instanceof mn) return e.body.length == 0;
            return false;
        }
        function x(e) {
            return nn(e.body, function(e) {
                return de(e) || e instanceof Ln || e instanceof mt && nn(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function q(e) {
            if (e instanceof gn) {
                return e.body instanceof mn ? e.body : e;
            }
            return e;
        }
        function Ee(e) {
            while (e instanceof St) e = e.expression;
            return e;
        }
        function he(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof St);
            return e instanceof $n ? !zn(e) : he(e);
        }
        function Se(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof kt)) return true;
            var t = false;
            n.walk(new Si(function(e) {
                if (t) return true;
                if (e instanceof ci) return t = true;
                if (e instanceof Tn && e !== n) return true;
            }));
            return !t;
        }
        function Te(e) {
            return e instanceof ai && e.definition().undeclared;
        }
        var a = en("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        ai.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && a[this.name];
        });
        function w(e) {
            return nn(e.definitions, function(e) {
                return !e.value;
            });
        }
        function F(e) {
            return e instanceof Ln || e instanceof mt && w(e);
        }
        function c(e, f) {
            var de, he, ve;
            t();
            var me, n = 10;
            do {
                me = false;
                r(e);
                if (f.option("dead_code")) {
                    o(e, f);
                }
                if (f.option("if_return")) {
                    a(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    _(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (me && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof lt) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof pt) {
                        n++;
                    } else if (e instanceof gn) {
                        de = true;
                    } else if (e instanceof Tn) {
                        ve = e;
                        break;
                    } else if (e instanceof ct) {
                        if (!he) he = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, d) {
                if (ve.pinned()) return o;
                var h;
                var a = Object.create(null);
                var v = [];
                var s = Object.create(null);
                var t;
                var f = o.length;
                var l = new Ti(function(e, n) {
                    if (q) return e;
                    if (!z) {
                        if (e !== u[c]) return e;
                        c++;
                        if (c < u.length) return H(e, l);
                        z = true;
                        _ = (m ? J : G)(e, 0);
                        if (_ === e) q = true;
                        return e;
                    }
                    var t = l.parent();
                    if (I(e, t)) {
                        q = true;
                        return e;
                    }
                    if (!g && B(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof _t && t.value === e) return e;
                    var i;
                    if (!(e instanceof Jt) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!C || g && (i || !A || !$)) {
                            if (!i && !m) q = true;
                            return e;
                        }
                        if (Mi(e, t)) {
                            if (m && !i) {
                                M = true;
                                F++;
                            }
                            return e;
                        } else if (m) {
                            if (!i) F++;
                            return e;
                        } else {
                            F++;
                        }
                        me = q = true;
                        on.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (p.TYPE == "Binary") return xe(Mt, p, {
                            operator: "=",
                            left: p.right.left,
                            right: xe(Ft, p, {
                                condition: p.operator == "&&" ? p.left : p.left.negate(d),
                                consequent: p.right.right,
                                alternative: e
                            })
                        });
                        if (p instanceof zt) {
                            if (b instanceof ai) b.definition().fixed = false;
                            return xe($t, p, p);
                        }
                        if (p instanceof _t) {
                            var r = p.name.definition();
                            if (r.references.length - r.replaced == 1 && !d.exposed(r)) {
                                r.replaced++;
                                return ke(d, t, e, p.value);
                            }
                            return xe(Mt, p, {
                                operator: "=",
                                left: xe(ai, p.name, p.name),
                                right: p.value
                            });
                        }
                        p.write_only = false;
                        return p;
                    }
                    if (R(e, t) || k(e)) {
                        _ = e;
                        if (e instanceof Tn) q = true;
                    }
                    if (e instanceof On) {
                        var a = C;
                        C = false;
                        n(e, l);
                        C = a;
                        return N(e);
                    }
                    if (e instanceof Nt) {
                        var a = C;
                        C = false;
                        n(e, l);
                        C = a;
                        return N(e);
                    }
                    if (e instanceof wt) {
                        e.name = e.name.transform(l);
                        var a = C;
                        C = false;
                        e.value = e.value.transform(l);
                        C = a;
                        return N(e);
                    }
                    if (e instanceof dn && !(e instanceof Tn) && !(e.variables && e.variables.all(function(e) {
                        return !T.has(e.name);
                    }))) {
                        var a = C;
                        C = false;
                        if (!H(e, l)) n(e, l);
                        C = a;
                        return N(e);
                    }
                    return H(e, l);
                }, N);
                var i = new Ti(function(e) {
                    if (q) return e;
                    if (!z) {
                        if (e !== u[c]) return e;
                        c++;
                        switch (u.length - c) {
                          case 0:
                            z = true;
                            if (M) return e;
                            if (e instanceof _t) return e;
                            j.replaced++;
                            var n = i.parent();
                            if (n instanceof Et && n.tail_node() !== e) {
                                m.replaced++;
                                return Xe.skip;
                            }
                            return D;

                          case 1:
                            if (!M && e.body === p) {
                                z = true;
                                j.replaced++;
                                m.replaced++;
                                return null;
                            }

                          default:
                            return H(e, i);
                        }
                    }
                    if (e instanceof ai && e.name == j.name) {
                        if (!--F) q = true;
                        if (Mi(e, i.parent())) return e;
                        j.replaced++;
                        var t = D.clone();
                        m.references.push(t);
                        return t;
                    }
                    if (e instanceof ft || e instanceof Tn) return e;
                }, oe);
                while (--f >= 0) {
                    if (f == 0 && d.option("unused")) U();
                    var u = [];
                    V(o[f]);
                    while (v.length > 0) {
                        u = v.pop();
                        var c = 0;
                        var p = u[u.length - 1];
                        var m = null;
                        var _ = null;
                        var g = null;
                        var b = Q(p);
                        var y = b && b.has_side_effects(d);
                        var w = b && !y && !we(b, d);
                        var x = ne(p);
                        if (!w && !x) continue;
                        var r = p.name instanceof ei;
                        var k = Ve;
                        if (p.may_throw(d)) {
                            if (r && qn(ve)) continue;
                            k = he ? function(e) {
                                return e.has_side_effects(d);
                            } : pe;
                        }
                        var E = false;
                        var S = false;
                        var T = re(p);
                        var A = se(b);
                        var D = Z(p);
                        if (!y) y = fe();
                        var O = he || !A ? function(e) {
                            return e instanceof Nt;
                        } : Ve;
                        var $ = ue(p);
                        var z = r;
                        var q = false;
                        var F = 0;
                        var M = false;
                        var C = !h || !z;
                        if (!C) {
                            for (var e = p.arg_index + 1; !q && e < h.length; e++) {
                                if (h[e]) h[e].transform(l);
                            }
                            C = true;
                        }
                        for (var n = f; !q && n < o.length; n++) {
                            o[n].transform(l);
                        }
                        if (m) {
                            var j = b.definition();
                            var P = j.references.length - j.replaced;
                            if (p instanceof Mt) P--;
                            if (!F || P > F) {
                                v.push(u);
                                t = true;
                                continue;
                            }
                            q = false;
                            c = 0;
                            z = r;
                            for (var n = f; !q && n < o.length; n++) {
                                if (!o[n].transform(i)) o.splice(n--, 1);
                            }
                            if (p instanceof _t) {
                                F = !d.exposed(j) && j.references.length == j.replaced;
                            }
                            m.single_use = false;
                        }
                        if (F && !ae(p)) o.splice(f, 1);
                    }
                }
                function N(e) {
                    if (q) return e;
                    if (_ === e) q = true;
                    if (g === e) g = null;
                    return e;
                }
                function H(e, n) {
                    if (!(e instanceof dn)) {
                        if (!(e instanceof Jn && !e.static)) return;
                        if (e.key instanceof on) e.key = e.key.transform(n);
                        return e;
                    }
                    if (e instanceof Tn) return e;
                    if (e instanceof kn) {
                        e.object = e.object.transform(n);
                        q = true;
                        return e;
                    }
                    if (e instanceof ot) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !q && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof ut) {
                                if (!z) {
                                    if (i !== u[c]) continue;
                                    c++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!$) break;
                                x = false;
                            }
                        }
                        q = true;
                        return e;
                    }
                }
                function Y(e, n) {
                    if (n instanceof Mt) return n.operator == "=" && n.left === e;
                    if (n instanceof wt) return n.name === e;
                    if (n instanceof Ht) return true;
                    if (n instanceof Yt) return n.value === e;
                }
                function I(e, n) {
                    if (e === D) return true;
                    if (n instanceof xn) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof Mt) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof xt) {
                        if (!(b instanceof St)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(D instanceof $n && !D.contains_this());
                    }
                    if (e instanceof Vn) return !d.has_directive("use strict");
                    if (e instanceof fn) return true;
                    if (e instanceof Ln) return r && b.name === e.name.name;
                    if (e instanceof Yt) return e.key instanceof on;
                    if (e instanceof bn) return true;
                    if (e instanceof tt) return true;
                    if (e instanceof ai) {
                        if (e.is_declared(d)) {
                            if (e.fixed_value()) return false;
                            if (ye(e)) {
                                return !(n instanceof St && n.expression === e) && ge(e.definition());
                            }
                        } else if (Y(e, n)) {
                            return false;
                        }
                        if (!$) return true;
                        x = false;
                        return false;
                    }
                    if (e instanceof ct) return true;
                    if (e instanceof Sn) return true;
                    return false;
                }
                function B(e, n) {
                    if (n instanceof Mt) return n.left !== e && De[n.operator.slice(0, -1)];
                    if (n instanceof qt) return n.left !== e && De[n.operator];
                    if (n instanceof ut) return n.expression !== e;
                    if (n instanceof Ft) return n.condition !== e;
                    return n instanceof at && n.condition !== e;
                }
                function R(e, n) {
                    if (e instanceof Ct) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !Ce(e.right);
                    if (e instanceof xt) {
                        var t, i = e.expression;
                        if (i instanceof ai) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof Dn)) return true;
                        if (t && je(d, t)) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = C;
                        C = false;
                        var a = _;
                        var o = g;
                        if (!nn(i.argnames, function(e) {
                            if (e instanceof wt) {
                                e.value.transform(l);
                                if (q) return false;
                                e = e.name;
                            }
                            return !(e instanceof Nt);
                        })) {
                            q = true;
                        } else if (zn(i) && i.value) {
                            i.value.transform(l);
                        } else for (var s = 0; !q && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof et) {
                                if (f.value) f.value.transform(l);
                                break;
                            }
                            f.transform(l);
                        }
                        g = o;
                        _ = a;
                        C = r;
                        delete i.collapse_scanning;
                        if (!q) return false;
                        q = false;
                        return true;
                    }
                    if (e instanceof Zn) {
                        if (he) {
                            if (he.bfinally) return true;
                            if (he.bcatch && e instanceof nt) return true;
                        }
                        return y || b instanceof St || le(b);
                    }
                    if (e instanceof Hn) {
                        return d.option("ie8") && e.name && T.has(e.name.name);
                    }
                    if (e instanceof si) return ce(e, n);
                    if (e instanceof St) {
                        var u = e.expression;
                        return y || u instanceof ai && ge(u.definition()) || !m && (he || !A) && u.may_throw_on_access(d);
                    }
                    if (e instanceof Dt) return true;
                    if (e instanceof ai) {
                        if (ce(e, n)) return !Y(e, n);
                        if (y && le(e)) return true;
                        var t = e.definition();
                        return (he || t.scope.resolve() !== ve) && !ye(e);
                    }
                    if (e instanceof li) return e.tag && !Pe(d, e.tag);
                    if (e instanceof _t) {
                        if (O(e.name)) return true;
                        return (e.value || n instanceof vt) && e.name.match_symbol(function(e) {
                            return e instanceof Jt && (T.has(e.name) || y && le(e));
                        }, true);
                    }
                    if (e instanceof jt) return true;
                    var c = Mi(e.left, e);
                    if (!c) return false;
                    if (c instanceof St) return true;
                    if (O(c)) return true;
                    return c.match_symbol(function(e) {
                        return e instanceof ai && (T.has(e.name) || E && d.exposed(e.definition()));
                    }, true);
                }
                function L(e, n) {
                    if (!n) return !(e instanceof Wt);
                    if (e instanceof wt) {
                        return n.has_side_effects(d) || e.value.has_side_effects(d) || L(e.name, Ae(n) && e.value);
                    }
                    if (e instanceof Nt) {
                        if (e.rest && L(e.rest)) return true;
                        if (e instanceof Ht) {
                            if (!(n instanceof Pt || n.is_string(d))) return true;
                            return !nn(e.elements, function(e) {
                                return !L(e);
                            });
                        }
                        if (e instanceof It) {
                            if (!n.is_defined(d)) return true;
                            return !nn(e.properties, function(e) {
                                if (e instanceof on && e.has_side_effects(d)) return false;
                                return !L(e.value);
                            });
                        }
                    }
                }
                function U() {
                    var e, r = d.self();
                    if (r instanceof $n && !Fn(r) && !r.uses_arguments && !r.pinned() && (e = d.parent()) instanceof xt && e.expression === r && Se(e) && nn(e.args, function(e) {
                        return !(e instanceof Dt);
                    })) {
                        var a = d.has_directive("use strict");
                        if (a && !Re(a, r.body)) a = false;
                        var o = qn(r) ? function(e) {
                            return e instanceof Wt && e.name == "await";
                        } : function(e) {
                            return e instanceof Ct && !n.find_parent(Tn);
                        };
                        var s = null;
                        var n = new Si(function(e, n) {
                            if (!c) return true;
                            if (o(e) || e instanceof jt) {
                                c = null;
                                return true;
                            }
                            if (e instanceof si && (a || !s)) {
                                c = null;
                                return true;
                            }
                            if (e instanceof ai && r.variables.has(e.name)) {
                                var t = e.definition().scope;
                                if (t !== ve) while (t = t.parent_scope) {
                                    if (t === ve) return true;
                                }
                                c = null;
                            }
                            if (e instanceof Tn && !zn(e)) {
                                var i = s;
                                s = e;
                                n();
                                s = i;
                                return true;
                            }
                        });
                        h = e.args.slice();
                        var t = h.length;
                        var i = Object.create(null);
                        for (var f = r.argnames.length; --f >= 0; ) {
                            var u = r.argnames[f];
                            var c = h[f];
                            var l;
                            if (u instanceof wt) {
                                l = u.value;
                                u = u.name;
                                h[t + f] = l;
                            }
                            if (u instanceof Nt) {
                                if (!L(u, c)) continue;
                                v.length = 0;
                                break;
                            }
                            if (u.name in i) continue;
                            i[u.name] = true;
                            if (l) c = !c || Ae(c) ? l : null;
                            if (!c && !l) {
                                c = xe(bi, u).transform(d);
                            } else if (c instanceof Dn && c.pinned()) {
                                c = null;
                            } else if (c) {
                                c.walk(n);
                            }
                            if (!c) continue;
                            var p = xe(_t, u, {
                                name: u,
                                value: c
                            });
                            p.name_index = f;
                            p.arg_index = l ? t + f : f;
                            v.unshift([ p ]);
                        }
                    }
                }
                function V(e, n) {
                    u.push(e);
                    if (e instanceof Pt) {
                        e.elements.forEach(function(e) {
                            V(e, n);
                        });
                    } else if (e instanceof Mt) {
                        if (!(e.left instanceof Nt)) v.push(u.slice());
                        V(e.left);
                        V(e.right);
                        if (e.left instanceof ai) {
                            a[e.left.name] = (a[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof Ct) {
                        V(e.expression, n);
                    } else if (e instanceof qt) {
                        var t = De[e.operator];
                        if (n && t && e.operator != "??" && e.right instanceof Mt && e.right.operator == "=" && !(e.right.left instanceof Nt)) {
                            v.push(u.slice());
                        }
                        V(e.left, !t && n);
                        V(e.right, n);
                    } else if (e instanceof xt) {
                        V(e.expression);
                        e.args.forEach(V);
                    } else if (e instanceof ut) {
                        V(e.expression);
                    } else if (e instanceof Ft) {
                        V(e.condition);
                        V(e.consequent, n);
                        V(e.alternative, n);
                    } else if (e instanceof dt) {
                        e.definitions.forEach(V);
                    } else if (e instanceof Tt) {
                        V(e.expression);
                    } else if (e instanceof bn) {
                        V(e.condition);
                        if (!(e.body instanceof vn)) {
                            V(e.body);
                        }
                    } else if (e instanceof Zn) {
                        if (e.value) V(e.value);
                    } else if (e instanceof xn) {
                        if (e.init) V(e.init, true);
                        if (e.condition) V(e.condition);
                        if (e.step) V(e.step, true);
                        if (!(e.body instanceof vn)) {
                            V(e.body);
                        }
                    } else if (e instanceof kn) {
                        V(e.object);
                        if (!(e.body instanceof vn)) {
                            V(e.body);
                        }
                    } else if (e instanceof at) {
                        V(e.condition);
                        if (!(e.body instanceof vn)) {
                            V(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof vn)) {
                            V(e.alternative);
                        }
                    } else if (e instanceof Bt) {
                        e.properties.forEach(function(e) {
                            u.push(e);
                            if (e.key instanceof on) V(e.key);
                            if (e instanceof Lt) V(e.value, n);
                            u.pop();
                        });
                    } else if (e instanceof Et) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            V(e, n < i);
                        });
                    } else if (e instanceof pn) {
                        V(e.body, true);
                    } else if (e instanceof Dt) {
                        V(e.expression);
                    } else if (e instanceof At) {
                        V(e.expression);
                        V(e.property);
                    } else if (e instanceof ot) {
                        V(e.expression);
                        e.body.forEach(V);
                    } else if (e instanceof Ot) {
                        if ($i[e.operator]) {
                            v.push(u.slice());
                        } else {
                            V(e.expression);
                        }
                    } else if (e instanceof _t) {
                        if (e.name instanceof Zt) {
                            if (e.value) {
                                var r = e.name.definition();
                                if (r.references.length > r.replaced) {
                                    v.push(u.slice());
                                }
                            } else {
                                s[e.name.name] = (s[e.name.name] || 0) + 1;
                            }
                        }
                        if (e.value) V(e.value);
                    } else if (e instanceof jt) {
                        if (e.expression) V(e.expression);
                    }
                    u.pop();
                }
                function G(e, n) {
                    var t = l.parent(n);
                    if (t instanceof Pt) return e;
                    if (t instanceof Mt) return e;
                    if (t instanceof Ct) return e;
                    if (t instanceof qt) return e;
                    if (t instanceof xt) return e;
                    if (t instanceof ut) return e;
                    if (t instanceof Ft) return e;
                    if (t instanceof dt) return X(t, n + 1);
                    if (t instanceof Zn) return e;
                    if (t instanceof at) return e;
                    if (t instanceof gn) return e;
                    if (t instanceof Rt) return e;
                    if (t instanceof St) return e;
                    if (t instanceof Et) {
                        return (t.tail_node() === e ? G : X)(t, n + 1);
                    }
                    if (t instanceof pn) return X(t, n + 1);
                    if (t instanceof Dt) return e;
                    if (t instanceof ot) return e;
                    if (t instanceof Ot) return e;
                    if (t instanceof _t) return e;
                    if (t instanceof jt) return e;
                    return null;
                }
                function W(e, n, t) {
                    var i;
                    do {
                        i = e;
                        e = l.parent(++t);
                    } while (e instanceof Mt && e.operator.slice(0, -1) == n || e instanceof qt && e.operator == n);
                    return i;
                }
                function J(e, n) {
                    var t = l.parent(n);
                    if (t instanceof Pt) return J(t, n + 1);
                    if (t instanceof Mt) {
                        if (k(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof ai && (b.name == e.name || m.name == e.name);
                        })) return e;
                        var i;
                        if (t.left === e || !De[i = t.operator.slice(0, -1)]) {
                            return J(t, n + 1);
                        }
                        return W(t, i, n);
                    }
                    if (t instanceof qt) {
                        var i;
                        if (t.left === e || !De[i = t.operator]) {
                            return J(t, n + 1);
                        }
                        return W(t, i, n);
                    }
                    if (t instanceof xt) return t;
                    if (t instanceof ut) {
                        if (t.expression !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof Ft) {
                        if (t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof dt) return X(t, n + 1);
                    if (t instanceof yn) return e;
                    if (t instanceof Zn) return X(t, n + 1);
                    if (t instanceof xn) {
                        if (t.init !== e && t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof kn) {
                        if (t.init !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof at) {
                        if (t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof Rt) {
                        var r = l.parent(n + 1);
                        return nn(r.properties, function(e) {
                            return e instanceof Lt;
                        }) ? J(r, n + 2) : r;
                    }
                    if (t instanceof St) return J(t, n + 1);
                    if (t instanceof Et) {
                        return (t.tail_node() === e ? J : X)(t, n + 1);
                    }
                    if (t instanceof pn) return X(t, n + 1);
                    if (t instanceof Dt) return J(t, n + 1);
                    if (t instanceof ot) {
                        if (t.expression !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof Ot) {
                        if (t.operator == "delete") return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof _t) return t.name.match_symbol(function(e) {
                        return e instanceof Jt && (b.name == e.name || m.name == e.name);
                    }) ? e : J(t, n + 1);
                    if (t instanceof wn) {
                        if (t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof jt) return J(t, n + 1);
                    return null;
                }
                function X(a, o) {
                    var s = l.parent(o);
                    if (R(a, s)) return a;
                    if (B(a, s)) return a;
                    if (s instanceof Pt) return X(s, o + 1);
                    if (s instanceof Mt) return r(s.left);
                    if (s instanceof Ct) return a;
                    if (s instanceof qt) return X(s, o + 1);
                    if (s instanceof xt) return X(s, o + 1);
                    if (s instanceof ut) return X(s, o + 1);
                    if (s instanceof Ft) return X(s, o + 1);
                    if (s instanceof dt) return X(s, o + 1);
                    if (s instanceof Zn) return X(s, o + 1);
                    if (s instanceof at) return X(s, o + 1);
                    if (s instanceof gn) return a;
                    if (s instanceof Rt) {
                        var e = l.parent(o + 1);
                        return nn(e.properties, function(e) {
                            return e instanceof Lt;
                        }) ? X(e, o + 2) : e;
                    }
                    if (s instanceof St) {
                        var n = s.expression;
                        if (n === a) return X(s, o + 1);
                        var t = Ee(n);
                        if (!(t instanceof ai)) return X(s, o + 1);
                        var i = T.get(t.name);
                        return !i || nn(i, function(e) {
                            return !(e instanceof St);
                        }) ? X(s, o + 1) : a;
                    }
                    if (s instanceof Et) return X(s, o + 1);
                    if (s instanceof pn) return X(s, o + 1);
                    if (s instanceof Dt) return a;
                    if (s instanceof ot) return X(s, o + 1);
                    if (s instanceof Ot) return X(s, o + 1);
                    if (s instanceof _t) return r(s.name);
                    if (s instanceof jt) return a;
                    return null;
                    function r(e) {
                        if (k(s)) return a;
                        if (e !== a && e instanceof Nt) {
                            var n = C;
                            C = false;
                            var t = _;
                            var i = g;
                            var r = l.stack;
                            l.stack = [ s ];
                            e.transform(l);
                            l.stack = r;
                            g = i;
                            _ = t;
                            C = n;
                            if (q) {
                                q = false;
                                return a;
                            }
                        }
                        return X(s, o + 1);
                    }
                }
                function K(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof ai)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (ge(n)) return;
                    return m = n;
                }
                function Q(e) {
                    if (e instanceof Mt) {
                        var n, t = e.left;
                        if (e.operator == "=" && t instanceof ai && (n = t.definition()).references[0] === t && !(ve.uses_arguments && be(n)) && !d.exposed(n)) {
                            var i = n.references.length - n.replaced;
                            if (i > 1) K(e.right);
                        }
                        return t;
                    }
                    if (e instanceof qt) return e.right.left;
                    if (e instanceof Ot) return e.expression;
                    if (e instanceof _t) {
                        var n = e.name.definition();
                        if (n.const_redefs) return;
                        if (!Re(e.name, n.orig)) return;
                        if (ve.uses_arguments && be(n)) return;
                        var r = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (a[n.name] || 0);
                        if (r > 1 && !(e.name instanceof ei)) {
                            K(e.value);
                            return xe(ai, e.name, e.name);
                        }
                        if (K(e.value) || i == 1 && !d.exposed(n)) {
                            return xe(ai, e.name, e.name);
                        }
                        return;
                    }
                }
                function Z(e) {
                    if (e instanceof Mt) return e.right;
                    if (e instanceof qt) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof _t) return e.value;
                }
                function ee(e) {
                    if (e instanceof Pt) return false;
                    if (e instanceof qt && De[e.operator]) {
                        return ee(e.left) && ee(e.right);
                    }
                    if (e instanceof xt) return false;
                    if (e instanceof Ft) {
                        return ee(e.consequent) && ee(e.alternative);
                    }
                    if (e instanceof Bt) return false;
                    return !e.has_side_effects(d);
                }
                function ne(n) {
                    if (n instanceof Mt && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Si(function(e) {
                        if (e instanceof ai) t[e.definition().id] = true;
                    });
                    while (n instanceof Mt && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof si) return o;
                    if (n instanceof ai) {
                        var i = n.evaluate(d);
                        if (i === n) return o;
                        return te(i, o);
                    }
                    if (n.is_truthy()) return te(true, Ve);
                    if (n.is_constant()) {
                        var r = n.evaluate(d);
                        if (!(r instanceof on)) return te(r, o);
                    }
                    if (!(b instanceof ai)) return false;
                    if (!ee(n)) return false;
                    var a;
                    n.walk(new Si(function(e) {
                        if (a) return true;
                        if (e instanceof ai && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function te(i, r) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (i && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof on)) return !t == !i;
                            }
                        }
                        return r(e);
                    };
                }
                function ie(e) {
                    if (e instanceof ai) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Mt) return e.operator == "=" && ie(e.right);
                    return e instanceof St || e instanceof si;
                }
                function re(i) {
                    var r = new tn();
                    if (i instanceof _t) r.add(i.name.name, b);
                    var a = ve.uses_arguments && !d.has_directive("use strict");
                    var o = ve instanceof An;
                    var s = new Si(function(e) {
                        var n;
                        if (e instanceof ai) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof si) {
                            n = e;
                        }
                        if (n) r.add(e.name, _e(d, s, e, n, 0));
                        if (a && e instanceof At) {
                            ve.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    r.add(e.name, true);
                                }
                            });
                            a = false;
                        }
                        if (!o) return;
                        if (e.TYPE == "Call") {
                            if (S) return;
                            var t = e.expression;
                            if (t instanceof St) return;
                            if (t instanceof $n && !t.contains_this()) return;
                            S = true;
                        } else if (e instanceof St && ie(e.expression)) {
                            if (e === b && !(i instanceof Ot)) {
                                S = true;
                            } else {
                                E = true;
                            }
                        }
                    });
                    i.walk(s);
                    return r;
                }
                function ae(e) {
                    var n = e.name_index;
                    if (n >= 0) {
                        var t = ve.argnames[n];
                        if (t instanceof wt) {
                            t.value = xe(hi, t, {
                                value: 0
                            });
                            t.name.definition().fixed = false;
                        } else {
                            var i = d.parent().args;
                            if (i[n]) {
                                i[n] = xe(hi, i[n], {
                                    value: 0
                                });
                                t.definition().fixed = false;
                            }
                        }
                        return true;
                    }
                    var r = u.length - 1;
                    if (u[r - 1].body === u[r]) r--;
                    var a = new Ti(function(e, n, t) {
                        if (z) return e;
                        if (e !== u[c]) return e;
                        c++;
                        if (c <= r) return H(e, a);
                        z = true;
                        if (e instanceof _t) {
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (m) m.replaced++;
                            e = e.clone();
                            e.value = null;
                            return e;
                        }
                        return t ? Xe.skip : null;
                    }, oe);
                    q = false;
                    z = false;
                    c = 0;
                    return o[f].transform(a);
                }
                function oe(e) {
                    if (e instanceof Et) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return ke(d, this.parent(), e, e.expressions[0]);
                    }
                }
                function se(e) {
                    var n = Ee(e);
                    return n instanceof ai && n.definition().scope === ve && !(de && (T.has(n.name) && T.get(n.name)[0] !== e || p instanceof Ot || p instanceof Mt && p.operator != "="));
                }
                function fe() {
                    if (p instanceof Ot) return false;
                    return D.has_side_effects(d);
                }
                function ue(e) {
                    if (e instanceof Ot) return false;
                    if (y) return false;
                    if (m) return true;
                    if (!(b instanceof ai)) return false;
                    var n;
                    if (e instanceof _t) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function ce(e, n) {
                    var t = T.get(e.name);
                    if (!t || nn(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function le(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof ni) return false;
                    if (n.scope !== ve) return true;
                    if (S && d.exposed(n)) return true;
                    return !nn(n.references, function(e) {
                        return e.scope.resolve() === ve;
                    });
                }
                function pe(e, n) {
                    if (e instanceof Mt) return pe(e.left, true);
                    if (e instanceof Ot) return pe(e.expression, true);
                    if (e instanceof _t) return e.value && pe(e.value);
                    if (n) {
                        if (e instanceof Tt) return pe(e.expression, true);
                        if (e instanceof At) return pe(e.expression, true);
                        if (e instanceof ai) return e.definition().scope !== ve;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof mn) {
                        if (nn(i.body, y)) {
                            me = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof un) {
                        if (Re(i.value, n)) {
                            me = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof cn) {
                        me = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function a(i, r) {
                var a = r.self();
                var e = r.parent();
                var t = x(function(e) {
                    return e instanceof Dn;
                });
                var n = t && e && e.TYPE == "Call";
                var o = b(i);
                for (var s = i.length; --s >= 0; ) {
                    var f = i[s];
                    var u = D(s);
                    var c = i[u];
                    if (t && !c && f instanceof et) {
                        if (!f.value) {
                            me = true;
                            i.splice(s, 1);
                            continue;
                        }
                        var l = f.value.tail_node();
                        if (l instanceof $t && l.operator == "void") {
                            me = true;
                            var p;
                            if (l === f.value) {
                                p = l.expression;
                            } else {
                                p = f.value.clone();
                                p.expressions[p.length - 1] = l.expression;
                            }
                            i[s] = xe(pn, f, {
                                body: p
                            });
                            continue;
                        }
                    }
                    if (f instanceof at) {
                        var d = M(f.body);
                        if (S(d)) {
                            if (d.label) Ze(d.label.thedef.references, d);
                            me = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = A(f.body, d);
                            f.body = xe(mn, f, {
                                body: z(f.alternative).concat(T())
                            });
                            f.alternative = xe(mn, f, {
                                body: p
                            });
                            i[s] = f;
                            i[s] = f.transform(r);
                            continue;
                        }
                        if (d && !f.alternative && f.body instanceof mn && c instanceof Qn) {
                            var h = f.condition.negate(r);
                            if (h.print_to_string().length <= f.condition.print_to_string().length) {
                                me = true;
                                f = f.clone();
                                f.condition = h;
                                i[u] = f.body;
                                f.body = c;
                                i[s] = f;
                                i[s] = f.transform(r);
                                continue;
                            }
                        }
                        var v = M(f.alternative);
                        if (S(v)) {
                            if (v.label) Ze(v.label.thedef.references, v);
                            me = true;
                            f = f.clone();
                            f.body = xe(mn, f.body, {
                                body: z(f.body).concat(T())
                            });
                            var p = A(f.alternative, v);
                            f.alternative = xe(mn, f.alternative, {
                                body: p
                            });
                            i[s] = f;
                            i[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (d && !v) {
                                R(f.condition, null, xe(mn, a, {
                                    body: i.slice(s + 1)
                                }));
                            }
                            if (!d && v) {
                                R(f.condition, xe(mn, a, {
                                    body: i.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof at && f.body instanceof et) {
                        var m = f.body.value;
                        var _ = f.body.in_bool || c instanceof et && c.in_bool;
                        if (!m && !f.alternative && (t && !c || c instanceof et && !c.value)) {
                            me = true;
                            i[s] = xe(pn, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof et) {
                            me = true;
                            f = f.clone();
                            f.alternative = c;
                            i.splice(s, 1, f.transform(r));
                            i.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && t && (_ || m && o)) {
                            me = true;
                            f = f.clone();
                            f.alternative = xe(et, f, {
                                value: null
                            });
                            i.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var g = i[O(s)];
                        if (r.option("sequences") && t && !f.alternative && (!g && n || g instanceof at && g.body instanceof et) && D(u) == i.length && c instanceof pn) {
                            me = true;
                            f = f.clone();
                            f.alternative = xe(mn, c, {
                                body: [ c, xe(et, c, {
                                    value: null
                                }) ]
                            });
                            i.splice(s, 1, f.transform(r));
                            i.splice(u, 1);
                            continue;
                        }
                    }
                }
                function b(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof at && i.body instanceof et) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function y(e) {
                    return !e || e instanceof $t && e.operator == "void";
                }
                function w(e, n) {
                    var t = e.lastIndexOf(n);
                    if (t < 0) return false;
                    while (++t < e.length) {
                        if (!F(e[t])) return false;
                    }
                    return true;
                }
                function x(e) {
                    var n = a, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof at && (t = n));
                    } while ((n instanceof mn || n instanceof Tn) && w(n.body, t));
                }
                function k(n) {
                    return x(function(e) {
                        return e === n;
                    });
                }
                function E(e) {
                    if (e instanceof et) return t && y(e.value);
                    if (!(e instanceof tt)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof rt) return k(q(n));
                    if (n instanceof gn) return false;
                    return k(n);
                }
                function S(e) {
                    if (!E(e)) return false;
                    for (var n = i.length; --n > s; ) {
                        var t = i[n];
                        if (t instanceof Gn) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof ht || t instanceof vt) {
                            if (!nn(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof Jt && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function T() {
                    var n = [];
                    var t = false;
                    var e = i.splice(s + 1).filter(function(e) {
                        if (e instanceof In) {
                            n.push(e);
                            return false;
                        }
                        if ($(e)) t = true;
                        return true;
                    });
                    [].push.apply(t ? e : i, n);
                    return e;
                }
                function A(e, n) {
                    var t = z(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) i.push(xe(pn, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function D(e) {
                    for (var n = e + 1; n < i.length; n++) {
                        if (!F(i[n])) break;
                    }
                    return n;
                }
                function O(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!F(i[n])) break;
                    }
                    return n;
                }
            }
            function o(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, a = 0, o = n.length; r < o; r++) {
                    var s = n[r];
                    if (s instanceof tt) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof it && !(f instanceof gn) && q(f) === i || s instanceof rt && q(f) === i) {
                            if (s.label) Ze(s.label.thedef.references, s);
                        } else {
                            n[a++] = s;
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (M(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = a;
                me = a != o;
                if (e) e.forEach(function(e) {
                    k(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = ce(t[0], t);
                    n[i++] = xe(pn, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof pn) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) b(t, f);
                    } else if (F(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != o) me = true;
            }
            function p(e, n) {
                if (!(e instanceof mn)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof mt && w(r)) {
                        n.push(r);
                    } else if (t || $(r)) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    me = true;
                    var n = r.body;
                    return ce(n, [ n, e ]);
                }
                var i = 0, r;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (r) {
                        if (o instanceof Zn) {
                            if (o.value || !g(ve)) {
                                o.value = t(o.value || xe(bi, o)).optimize(n);
                            }
                        } else if (o instanceof xn) {
                            if (!(o.init instanceof dt)) {
                                var s = false;
                                r.body.walk(new Si(function(e) {
                                    if (s || e instanceof Tn) return true;
                                    if (e instanceof qt && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = t(o.init); else {
                                        o.init = r.body;
                                        i--;
                                        me = true;
                                    }
                                }
                            }
                        } else if (o instanceof En) {
                            if (!$(o.init)) o.object = t(o.object);
                        } else if (o instanceof at) {
                            o.condition = t(o.condition);
                        } else if (o instanceof ot) {
                            o.expression = t(o.expression);
                        } else if (o instanceof Sn) {
                            o.expression = t(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof at) {
                        var f = [];
                        var u = p(o.body, f);
                        var c = p(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(xe(at, o, {
                                condition: o.condition,
                                body: u || xe(cn, o.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            a += l;
                            i += l + 1;
                            r = null;
                            me = true;
                            continue;
                        }
                    }
                    e[i++] = o;
                    r = o instanceof pn ? o : null;
                }
                e.length = i;
            }
            function c(e) {
                if (e instanceof Mt) return [ e ];
                if (e instanceof Et) return e.expressions.slice();
            }
            function l(e, n, t) {
                var i = c(n);
                if (!i) return;
                var r = false;
                for (var a = i.length - 1; --a >= 0; ) {
                    var o = i[a];
                    if (!(o instanceof Mt)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof ai)) continue;
                    var s = i.slice(a + 1);
                    if (!m(o.left, o.right, s)) continue;
                    r = true;
                    i = i.slice(0, a + 1).concat(s);
                }
                if (e instanceof dt) {
                    t = t || 0;
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var f = e.definitions[a];
                        if (!f.value) continue;
                        if (m(f.name, f.value, i)) r = true;
                        if (h(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof mt && v(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function d(e, n) {
                if (!(e instanceof pn)) return;
                if (w(n)) return;
                var t = c(e.body);
                if (!t) return;
                var i = [];
                if (!v(i, t.reverse(), 0)) return;
                n.definitions = i.reverse().concat(n.definitions);
                return t.reverse();
            }
            function h(e, n, t) {
                if (!f.option("conditionals")) return;
                if (e.name instanceof Nt) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var a = Z(f, r, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function v(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof Mt)) break;
                    if (r.operator != "=") break;
                    var a = r.left;
                    if (!(a instanceof ai)) break;
                    if (Te(a)) break;
                    if (a.scope.resolve() !== ve) break;
                    var o = a.definition();
                    if (o.scope !== ve) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = xe(Zt, a, a);
                    e.push(xe(_t, r, {
                        name: s,
                        value: r.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function m(e, n, t) {
                if (!(n instanceof Bt)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof Mt)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof St)) break;
                    var a = r.left.expression;
                    if (!(a instanceof ai)) break;
                    if (e.name != a.name) break;
                    if (!r.right.is_constant_expression(ve)) break;
                    var o = r.left.property;
                    if (o instanceof on) {
                        o = o.evaluate(f);
                    }
                    if (o instanceof on) break;
                    o = "" + o;
                    var s = o == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return typeof e.key == "string" && e.key != o;
                    } : function(e) {
                        if (e instanceof Gt || e instanceof Vt) {
                            return typeof e.key == "string" && e.key != o;
                        }
                        return true;
                    };
                    if (!nn(n.properties, s)) break;
                    n.properties.push(xe(Lt, r, {
                        key: o,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function _(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var a = e[t];
                    if (i instanceof dt) {
                        if (a && a.TYPE == i.TYPE) {
                            a.definitions = a.definitions.concat(i.definitions);
                            me = true;
                        } else if (r && r.TYPE == i.TYPE && w(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            me = true;
                        } else if (i instanceof mt) {
                            var o = d(a, i);
                            if (o) {
                                if (o.length) {
                                    a.body = ce(a, o);
                                    t++;
                                }
                                me = true;
                            } else {
                                t++;
                            }
                            e[t] = r = i;
                        } else {
                            e[++t] = i;
                        }
                        continue;
                    } else if (i instanceof Zn) {
                        i.value = f(i.value);
                    } else if (i instanceof xn) {
                        var o = l(a, i.init);
                        if (o) {
                            me = true;
                            i.init = o.length ? ce(i.init, o) : null;
                        } else if (a instanceof mt && (!i.init || i.init.TYPE == a.TYPE)) {
                            if (i.init) {
                                a.definitions = a.definitions.concat(i.init.definitions);
                            }
                            r = i.init = a;
                            e[t] = u(i);
                            me = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && w(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            me = true;
                        } else if (i.init instanceof mt) {
                            r = i.init;
                            o = d(a, i.init);
                            if (o) {
                                me = true;
                                if (o.length == 0) {
                                    e[t] = u(i);
                                    continue;
                                }
                                a.body = ce(a, o);
                            }
                        }
                    } else if (i instanceof kn) {
                        if (r && r.TYPE == i.init.TYPE) {
                            var s = r.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(ai, function(e, n) {
                                s.push(xe(_t, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            r.definitions = s;
                            me = true;
                        }
                        i.object = f(i.object);
                    } else if (i instanceof at) {
                        i.condition = f(i.condition);
                    } else if (i instanceof pn) {
                        var o = l(a, i.body);
                        if (o) {
                            me = true;
                            if (!o.length) continue;
                            i.body = ce(i.body, o);
                        }
                    } else if (i instanceof ot) {
                        i.expression = f(i.expression);
                    } else if (i instanceof Sn) {
                        i.expression = f(i.expression);
                    }
                    e[++t] = r ? u(i) : i;
                }
                e.length = t + 1;
                function f(e) {
                    var n = l(a, e, 1);
                    if (!n) return e;
                    me = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return ce(e, n);
                }
                function u(e) {
                    return e.transform(new Ti(function(e, n, t) {
                        if (e instanceof dt) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof kn && i.init === e) return e;
                            if (!w(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            me = true;
                            if (i instanceof xn && i.init === e) return null;
                            return t ? Xe.skip : xe(cn, e);
                        }
                        if (e instanceof gt) return e;
                        if (e instanceof Tn) return e;
                        if (!ln(e)) return e;
                    }));
                }
            }
        }
        function k(r, a, o) {
            if (!(a instanceof dt || a instanceof In)) {
                on.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            }
            var s;
            a.walk(new Si(function(e, n) {
                if (e instanceof dt) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        on.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        f(e);
                    }
                    return true;
                }
                if (e instanceof In) {
                    f(e);
                    return true;
                }
                if (e instanceof Tn) return true;
                if (e instanceof dn) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(xe(mn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = i;
                    return true;
                }
            }));
            function f(e) {
                if (s) {
                    s.push(e);
                    if (!y(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Ae(e, n) {
            return e.is_undefined || e instanceof bi || e instanceof $t && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(on, Ve);
            e(Pt, Ge);
            e(Mt, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(Dn, Ge);
            e(Bt, Ge);
            e(mi, Ge);
            e(Et, function() {
                return this.tail_node().is_truthy();
            });
            e(ai, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = Ve;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(on, Ge);
            e(Pt, Ve);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof pi) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(Mt, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(qt, function() {
                return n(this.operator, this.left, this.right);
            });
            e(pi, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(Dn, Ve);
            e(Bt, Ve);
            e(mi, Ve);
            e(Et, function() {
                return this.tail_node().is_negative_zero();
            });
            e(ai, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = Ge;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e($t, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            on.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function i(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(on, i);
            e(Pt, Ve);
            e(Mt, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof ai)) return true;
                if (n instanceof qt && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(qt, function(e) {
                return De[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(Vn, Ve);
            e(Ft, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(pi, Ve);
            e(Tt, function(e) {
                if (!i(e)) return false;
                var n = this.expression;
                if (n instanceof ai) n = n.fixed_value();
                return !(this.property == "prototype" && A(n));
            });
            e(Dn, Ve);
            e(_i, Ge);
            e(Bt, function(e) {
                return i(e) && !nn(this.properties, function(e) {
                    return e instanceof Lt;
                });
            });
            e(si, function(e) {
                return i(e) && !this.scope.new;
            });
            e(Et, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(ai, function(e) {
                if (this.is_undefined) return true;
                if (!i(e)) return false;
                if (Te(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var n = this.definition();
                if (ge(n) && !n.scope.rest && nn(n.scope.argnames, function(e) {
                    return e instanceof ei;
                })) return n.scope.uses_arguments > 2;
                var t = this.fixed_value();
                if (!t) return true;
                this._dot_throw = Ge;
                if (t._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = Ve;
                return false;
            });
            e($t, function() {
                return this.operator == "void";
            });
            e(zt, Ve);
            e(bi, Ge);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(on, Ve);
            e(Pt, Ge);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(Mt, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(qt, function(e) {
                return t(e, this.operator, this);
            });
            e(Ft, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(pi, Ge);
            e(yi, Ve);
            e(Dn, Ge);
            e(Bt, Ge);
            e(Et, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(ai, function(e) {
                if (this.is_undefined) return false;
                if (Te(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = Ve;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e($t, function() {
                return this.operator != "void";
            });
            e(zt, Ge);
            e(bi, Ve);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(on, Ve);
            e(Mt, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = en("in instanceof == != === !== < <= >= >");
            e(qt, function(e) {
                return n[this.operator] || De[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(xi, Ge);
            var t = en("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(xt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Tt && (t[n.property] || n.property == "test" && n.expression instanceof mi);
            });
            e(Ft, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(kt, Ve);
            e(Et, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(ai, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = Ve;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = en("! delete");
            e($t, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(on, Ve);
            var n = en("- * / % ** & | ^ << >> >>>");
            e(Mt, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(qt, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = en([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(xt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Tt && (t[n.property] || Te(n.expression) && n.expression.name == "Math");
            });
            e(Ft, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(kt, Ve);
            e(hi, Ge);
            e(Et, function(e) {
                return this.tail_node().is_number(e);
            });
            e(ai, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = Ve;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = en("+ - ~ ++ --");
            e(Ot, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(on, Ve);
            e(Mt, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(qt, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = en([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(xt, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Tt && t[n.property];
            });
            e(Ft, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Et, function(e) {
                return this.tail_node().is_string(e);
            });
            e(di, Ge);
            e(ai, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = Ve;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(li, function(e) {
                return !this.tag || Pe(e, this.tag);
            });
            e($t, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var De = en("&& || ??");
        (function(e) {
            function r(e, n) {
                if (e instanceof on) return e.clone(true);
                if (Array.isArray(e)) return xe(Pt, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (rn(e, i)) {
                        t.push(xe(Lt, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return xe(Bt, n, {
                        properties: t
                    });
                }
                return le(e, n);
            }
            function o(e) {
                on.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            An.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: a.option("ie8")
                });
                return this.transform(new Ti(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof St)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (Mi(i, r)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(on, Ue);
            e(Tt, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(Jt, function(e) {
                if (!this.definition().global) return;
                if (rn(e.option("global_defs"), this.name)) o(this);
            });
            e(ai, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (rn(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function ve(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function p(e, n, t) {
            return ve(xe(pn, e, {
                body: e
            }), xe(pn, n, {
                body: n
            }), t).body;
        }
        function me(e, n, t, i) {
            return (an(e) ? p : ve)(n, t, i);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = en(n[e]);
            });
            return t;
        }
        function o(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof un)) return t;
            }
        }
        function d() {
            if (this.value) return xe(et, this.value, {
                value: this.value
            });
            return o(this.body);
        }
        Cn.DEFMETHOD("first_statement", d);
        jn.DEFMETHOD("first_statement", d);
        Dn.DEFMETHOD("first_statement", function() {
            return o(this.body);
        });
        Dn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof wt) break;
            }
            return n;
        });
        function Oe(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = le(t, n).optimize(e);
            return me(e, n, t, e.eval_threshold);
        }
        var h = [ "constructor", "toString", "valueOf" ];
        var E = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(h),
            Boolean: h,
            Function: h,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(h),
            Object: h,
            RegExp: [ "exec", "test" ].concat(h),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(h)
        });
        var S = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            e(on, Ve);
            e(pi, Ge);
            e(mi, Ve);
            var n = en("! ~ - + void");
            e($t, function() {
                return n[this.operator] && this.expression instanceof pi;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            on.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var m = new Si(function(e) {
                if (e instanceof Mt) u(e.left);
                if (e instanceof Ot && $i[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof Ht) {
                    e.elements.forEach(u);
                } else if (e instanceof It) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof St) {
                    u(e.expression);
                } else if (e instanceof ai) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(sn, function() {
                throw new Error(Qe("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(On, We);
            e(vi, We);
            e(Vn, We);
            e(on, We);
            e(pi, function() {
                return this.value;
            });
            e(Mt, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof ai)) return this;
                    if (!rn(r, "_eval")) {
                        if (!r.fixed) return this;
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!rn(r, "_eval") && r instanceof ai && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = xe(qt, this, {
                        operator: o.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                r.walk(m);
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                u(r);
                return f;
            });
            e(Et, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var a = 0, o = r.length - 1; a < o; a++) {
                    r[a].walk(m);
                }
                var s = r[o];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(Dn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Pt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof yi) return this;
                        var s = o._eval(e, n, t, i);
                        if (o === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(Bt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof Lt)) return this;
                        var s = o.key;
                        if (s instanceof on) {
                            s = s._eval(e, n, t, i);
                            if (s === o.key) return this;
                        }
                        if (s == "toString" || s == "valueOf") return this;
                        r[s] = o.value._eval(e, n, t, i);
                        if (r[s] === o.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = en("! typeof void");
            e($t, function(e, n, t, i) {
                var r = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (r instanceof Dn || r instanceof ai && r.fixed_value() instanceof Dn)) {
                    return typeof function() {};
                }
                var o = r instanceof ai && r.definition();
                if (!f[a] && !(o && o.fixed)) i++;
                r.walk(m);
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                    if (rn(r, "_eval")) s = +(a[0] + 1) + +s;
                    u(r);
                    return s;
                }
                return this;
            });
            e(zt, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof ai)) {
                    if (!n) return this;
                } else if (!rn(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof ai && r.definition().fixed)) i++;
                r.walk(m);
                var o = r._eval(e, n, t, i);
                if (o === r) return this;
                u(r);
                return +o;
            });
            var c = en("&& || === !==");
            e(qt, function(e, n, t, i) {
                if (!c[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var a = n && !(r && typeof r == "object");
                var o = this.right._eval(e, a, t, i);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && o;
                    break;

                  case "||":
                    s = r || o;
                    break;

                  case "??":
                    s = r == null ? o : r;
                    break;

                  case "|":
                    s = r | o;
                    break;

                  case "&":
                    s = r & o;
                    break;

                  case "^":
                    s = r ^ o;
                    break;

                  case "+":
                    s = r + o;
                    break;

                  case "-":
                    s = r - o;
                    break;

                  case "*":
                    s = r * o;
                    break;

                  case "/":
                    s = r / o;
                    break;

                  case "%":
                    s = r % o;
                    break;

                  case "<<":
                    s = r << o;
                    break;

                  case ">>":
                    s = r >> o;
                    break;

                  case ">>>":
                    s = r >>> o;
                    break;

                  case "==":
                    s = r == o;
                    break;

                  case "===":
                    s = r === o;
                    break;

                  case "!=":
                    s = r != o;
                    break;

                  case "!==":
                    s = r !== o;
                    break;

                  case "<":
                    s = r < o;
                    break;

                  case "<=":
                    s = r <= o;
                    break;

                  case ">":
                    s = r > o;
                    break;

                  case ">=":
                    s = r >= o;
                    break;

                  case "**":
                    s = Math.pow(r, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && rn(o, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(Sn) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Ft, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var a = r ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, i);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new Si(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof Tn) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(ai, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var a;
                if (rn(r, "_eval")) {
                    a = r._eval();
                } else {
                    this._eval = We;
                    a = r._eval(e, n, t, i);
                    delete this._eval;
                    if (a === r) return this;
                    r._eval = function() {
                        return a;
                    };
                    t.push(r);
                }
                return a && typeof a == "object" && !o(this, i) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = en("global ignoreCase multiline source");
            e(St, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var a = this.expression;
                    if (!Te(a)) {
                        r = a._eval(e, n, t, i + 1);
                        if (r == null || r === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof on) {
                        o = o._eval(e, n, t, i);
                        if (o === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        r = _[a.name];
                    } else if (r instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof r == "object") {
                        if (!rn(r, o)) return this;
                    } else if (typeof r == "function") switch (o) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.length();

                      default:
                        return this;
                    }
                    return r[o];
                }
                return this;
            });
            function g(e, n, t, i, r) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, i, r);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(xt, function(i, r, a, o) {
                var e = this.expression;
                var n = e instanceof ai ? e.fixed_value() : e;
                if (n instanceof Cn || n instanceof Ln || n instanceof Hn) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(i)) return this;
                    var s = g(this.args, i, r, a, o);
                    if (!nn(n.argnames, function(e, n) {
                        if (e instanceof wt) {
                            if (!s) return false;
                            if (s[n] !== undefined) return false;
                            var t = e.value._eval(i, r, a, o);
                            if (t === e.value) return false;
                            s[n] = t;
                            e = e.name;
                        }
                        return !(e instanceof Nt);
                    })) return this;
                    if (n.rest instanceof Nt) return this;
                    if (!s && !r) return this;
                    var t = n.first_statement();
                    if (!(t instanceof et)) {
                        if (r) {
                            n.walk(m);
                            var f = false;
                            n.evaluating = true;
                            hn(n, new Si(function(e) {
                                if (f) return true;
                                if (e instanceof et) {
                                    if (e.value && e.value._eval(i, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof Tn && e !== n) return true;
                            }));
                            delete n.evaluating;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || nn(n.argnames, function(e, n) {
                        return v(e, s[n]);
                    }) && !(n.rest && !v(n.rest, s.slice(n.argnames.length))) || r) {
                        n.evaluating = true;
                        u = u._eval(i, r, a, o);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (i.option("unsafe") && e instanceof St) {
                    var l = e.property;
                    if (l instanceof on) {
                        l = l._eval(i, r, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (Te(p)) {
                        var d = S[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(i, r, a, o + 1);
                        if (u == null || u === p) return this;
                        var h = E[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof mi)) return this;
                    }
                    var s = g(this.args, i, r, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        on.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e, n) {
                    if (e instanceof wt) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var i = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return i;
                        };
                        c.push(e);
                    });
                    return true;
                }
            });
            e(kt, We);
            e(li, function(e, n, t, i) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Pe(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var r = g(this.expressions, e, n, t, i);
                if (!r) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < r.length; s++) {
                    o += r[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = We;
                return this;
                function f(e) {
                    return e.replace(/\\(u\{[^}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                        var t = Di(n);
                        if (typeof t != "string") a = true;
                        return t;
                    });
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return xe($t, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = a(e);
                if (t) {
                    var r = xe(pn, n, {
                        body: n
                    });
                    return ve(i, r) === r ? n : i;
                }
                return ve(i, n);
            }
            e(on, function() {
                return a(this);
            });
            e(sn, function() {
                throw new Error("Cannot negate a statement");
            });
            e(qt, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return a(this);
            });
            e(Wn, function() {
                return a(this);
            });
            e(Ft, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e($n, function() {
                return a(this);
            });
            e(Et, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return ce(this, n);
            });
            e($t, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var v = en("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        xt.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (Te(n) && v[n.name]) return true;
                if (n instanceof Tt && Te(n.expression)) {
                    var t = S[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        on.DEFMETHOD("is_call_pure", Ve);
        xt.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Tt)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof Pt) {
                i = E.Array;
            } else if (t.is_boolean(e)) {
                i = E.Boolean;
            } else if (t.is_number(e)) {
                i = E.Number;
            } else if (t instanceof mi) {
                i = E.RegExp;
            } else if (t.is_string(e)) {
                i = E.String;
                if (r == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = E.Object;
            }
            return i && i[r];
        });
        function m(e) {
            while ((e = e.tail_node()) instanceof ai) {
                e = e.fixed_value();
                if (!e) return true;
            }
            return !(e instanceof Pt || e.TYPE == "Binary" && !De[e.operator] || e instanceof pi || e instanceof Dn || e instanceof Bt && nn(e.properties, function(e) {
                return !(e instanceof Gt || e instanceof Dt);
            }) || e instanceof si || e instanceof Ot);
        }
        (function(e) {
            function t(e, n, t) {
                return !nn(e, t ? function(e) {
                    return e instanceof Dt ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                return !e.expression.is_string(n) || e.expression.has_side_effects(n);
            }
            e(on, Ge);
            e(Pt, function(e) {
                return t(this.elements, e, n);
            });
            e(Mt, function(e) {
                var n = this.left;
                if (!(n instanceof St)) return true;
                var t = n.expression;
                return !(t instanceof si) || !t.scope.new || n instanceof At && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(qt, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !Ce(this.right);
            });
            e(vn, function(e) {
                return t(this.body, e);
            });
            e(xt, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(ut, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(Vn, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof ai) n = n.fixed_value();
                    if (!u(n)) return true;
                }
                return t(this.properties, e);
            });
            e(Jn, function(e) {
                return this.key instanceof on && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(Ft, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(pi, Ve);
            e(dt, function(e) {
                return t(this.definitions, e);
            });
            e(Ht, function(e) {
                return t(this.elements, e);
            });
            e(Yt, function(e) {
                return this.key instanceof on && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(It, function(e) {
                return t(this.properties, e);
            });
            e(Tt, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(cn, Ve);
            e(at, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(_n, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Dn, Ve);
            e(Bt, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return m(t) || t.has_side_effects(n);
                });
            });
            e(si, Ve);
            e(Rt, function(e) {
                return this.key instanceof on && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Et, function(e) {
                return t(this.expressions, e);
            });
            e(pn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(At, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(ot, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(Jt, Ve);
            e(ai, function(e) {
                return !this.is_declared(e) || !ye(this, e);
            });
            e(li, function(e) {
                return this.tag && !Pe(e, this.tag) || t(this.expressions, e);
            });
            e(ct, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Ot, function(e) {
                return Fi[this.operator] || this.expression.has_side_effects(e);
            });
            e(_t, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(on, Ge);
            e(pi, Ve);
            e(cn, Ve);
            e(Dn, Ve);
            e(si, Ve);
            e(Jt, Ve);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(Pt, function(e) {
                return n(this.elements, e);
            });
            e(Mt, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof ai) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(qt, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !Ce(this.right);
            });
            e(vn, function(e) {
                return n(this.body, e);
            });
            e(xt, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof Dn) || n(this.expression.body, e);
            });
            e(ut, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(Ft, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(dt, function(e) {
                return n(this.definitions, e);
            });
            e(Tt, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(at, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(_n, function(e) {
                return this.body.may_throw(e);
            });
            e(Bt, function(e) {
                return n(this.properties, e);
            });
            e(Rt, function(e) {
                return this.key instanceof on && this.key.may_throw(e) || this.value.may_throw(e);
            });
            e(et, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Et, function(e) {
                return n(this.expressions, e);
            });
            e(pn, function(e) {
                return this.body.may_throw(e);
            });
            e(At, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(ot, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(ai, function(e) {
                return !this.is_declared(e);
            });
            e(ct, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Ot, function(e) {
                if (this.operator == "typeof" && this.expression instanceof ai) return false;
                return this.expression.may_throw(e);
            });
            e(_t, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(on, Ve);
            e(Pt, function() {
                return t(this.elements);
            });
            e(qt, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression() && (this.operator != "in" || Ce(this.right));
            });
            e(Vn, function(e) {
                var n = this.extends;
                if (n && !u(n)) return false;
                return t(this.properties, e);
            });
            e(Jn, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(pi, Ge);
            e(Dn, function(r) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Si(function(e, n) {
                    if (!o) return true;
                    if (e instanceof dn) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof ai) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Re(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e.name);
                            if (t.undeclared ? !i : i === t) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof si) {
                        if (zn(a) && nn(s, function(e) {
                            return !(e instanceof Tn) || zn(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(Bt, function() {
                return t(this.properties);
            });
            e(Rt, function() {
                return typeof this.key == "string" && this.value.is_constant_expression();
            });
            e(Ot, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function M(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(sn, Je);
            e(Qn, We);
            function n() {
                var e = this.body.length;
                return e > 0 && M(this.body[e - 1]);
            }
            e(mn, n);
            e(st, n);
            e(at, function() {
                return this.alternative && M(this.body) && M(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var _ = en([ "use asm", "use strict" ]);
        e(un, function(e, n) {
            if (n.option("directives") && (!_[e.value] || n.has_directive(e.value) !== e)) {
                return xe(cn, e);
            }
            return e;
        });
        e(fn, function(e, n) {
            if (n.option("drop_debugger")) return xe(cn, e);
            return e;
        });
        e(_n, function(e, n) {
            if (n.option("dead_code") && e.body instanceof it && n.loopcontrol_target(e.body) === e.body) {
                return xe(cn, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(vn, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function J(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? Xe.skip : xe(cn, e);

              case 1:
                var i = e.body[0];
                if (!y(i)) return e;
                if (n instanceof gn && i instanceof In) return e;
                return i;
            }
            return e;
        }
        e(mn, function(e, n) {
            e.body = c(e.body, n);
            return J(e, n.parent());
        });
        function O(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof Ht)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = null;
        }
        e(Dn, function(e, n) {
            O(e, n);
            e.body = c(e.body, n);
            return e;
        });
        function C(e, n) {
            if (!n.option("arrows")) return e;
            O(e, n);
            var t = c(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var i = t[0];
                if (i instanceof et) {
                    e.body.length = 0;
                    e.value = i.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(Cn, C);
        e(jn, C);
        e(Hn, function(n, e) {
            O(n, e);
            n.body = c(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var i = 0; i < n.body.length; i++) {
                var r = n.body[i];
                if (r instanceof un) continue;
                if (r instanceof et) {
                    if (i != n.body.length - 1) break;
                    var a = r.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof ai) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof Ln || o instanceof Hn)) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!nn(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof Kn || t instanceof Ut) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!nn(n.argnames, function(e) {
                        return e instanceof ei;
                    })) break;
                    if (!nn(a.args, function(e) {
                        return !(e instanceof Dt);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof ai)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(ei, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var j = en("arguments await yield");
        Tn.DEFMETHOD("merge_variables", function(o) {
            if (!o.option("merge_vars")) return;
            var d, h, v = {}, m = this;
            var s = [], f = [], u = 0;
            var _ = new tn();
            var g = Object.create(null);
            var c = Object.create(null);
            var b = new Si(function(r, e) {
                if (r instanceof Mt) {
                    var n = r.left;
                    var t = r.right;
                    if (n instanceof Nt) {
                        t.walk(b);
                        var i = new Si(function(e) {
                            if (e instanceof Nt) return;
                            if (e instanceof wt) {
                                x();
                                e.value.walk(b);
                                k();
                                e.name.walk(i);
                            } else if (e instanceof Yt) {
                                if (e.key instanceof on) {
                                    x();
                                    v.block = e;
                                    e.key.walk(b);
                                    e.value.walk(i);
                                    k();
                                } else {
                                    e.value.walk(i);
                                }
                            } else if (e instanceof ai) {
                                E(e);
                            } else {
                                e.walk(b);
                            }
                            return true;
                        });
                        n.walk(i);
                        return true;
                    }
                    if (De[r.operator.slice(0, -1)]) {
                        n.walk(b);
                        x();
                        t.walk(b);
                        if (n instanceof ai) E(n);
                        k();
                        return true;
                    }
                    if (n instanceof ai) {
                        if (r.operator != "=") E(n, true);
                        t.walk(b);
                        E(n);
                        return true;
                    }
                    return;
                }
                if (r instanceof qt) {
                    if (!De[r.operator]) return;
                    r.left.walk(b);
                    x();
                    r.right.walk(b);
                    k();
                    return true;
                }
                if (r instanceof it) {
                    var a = b.loopcontrol_target(r);
                    if (!(a instanceof gn)) S(a);
                    return true;
                }
                if (r instanceof xt) {
                    var o = r.expression;
                    var s = o.tail_node();
                    if (!(s instanceof $n)) return;
                    if (o !== s) o.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(b);
                    });
                    r.args.forEach(function(e) {
                        e.walk(b);
                    });
                    s.walk(b);
                    return true;
                }
                if (r instanceof Ft) {
                    r.condition.walk(b);
                    x();
                    r.consequent.walk(b);
                    k();
                    x();
                    r.alternative.walk(b);
                    k();
                    return true;
                }
                if (r instanceof rt) {
                    var a = b.loopcontrol_target(r);
                    if (a instanceof yn) S(a);
                    return true;
                }
                if (r instanceof yn) {
                    x();
                    v.block = r;
                    v.loop = true;
                    var f = v;
                    r.body.walk(b);
                    if (v.inserted === r) v = f;
                    r.condition.walk(b);
                    k();
                    return true;
                }
                if (r instanceof xn) {
                    if (r.init) r.init.walk(b);
                    x();
                    v.block = r;
                    v.loop = true;
                    if (r.condition) r.condition.walk(b);
                    r.body.walk(b);
                    if (r.step) r.step.walk(b);
                    k();
                    return true;
                }
                if (r instanceof kn) {
                    r.object.walk(b);
                    x();
                    v.block = r;
                    v.loop = true;
                    r.init.walk(b);
                    r.body.walk(b);
                    k();
                    return true;
                }
                if (r instanceof at) {
                    r.condition.walk(b);
                    x();
                    r.body.walk(b);
                    k();
                    if (r.alternative) {
                        x();
                        r.alternative.walk(b);
                        k();
                    }
                    return true;
                }
                if (r instanceof _n) {
                    x();
                    v.block = r;
                    var f = v;
                    r.body.walk(b);
                    if (v.inserted === r) v = f;
                    k();
                    return true;
                }
                if (r instanceof Tn) {
                    x();
                    v.block = r;
                    if (r === m) h = v;
                    if (r instanceof Dn) {
                        if (r.name) g[r.name.definition().id] = false;
                        var i = r.uses_arguments && !b.has_directive("use strict") ? function(e) {
                            if (e instanceof ei) g[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof ei) E(e);
                        };
                        var u = new Si(function(e) {
                            if (e instanceof Jt) g[e.definition().id] = false;
                            if (!(e instanceof ai)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e.name) === n)) {
                                g[n.id] = false;
                                g[t.id] = false;
                            } else {
                                var i = v;
                                k();
                                E(e, true);
                                v = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(i, u);
                        });
                        if (r.rest) r.rest.mark_symbol(i, u);
                    }
                    Mn(r, b);
                    k();
                    return true;
                }
                if (r instanceof ot) {
                    r.expression.walk(b);
                    var f = v;
                    r.body.forEach(function(e) {
                        if (e instanceof ft) return;
                        e.expression.walk(b);
                        if (f === v) x();
                    });
                    v = f;
                    r.body.forEach(function(e) {
                        x();
                        v.block = r;
                        var n = v;
                        hn(e, b);
                        if (v.inserted === r) v = n;
                        k();
                    });
                    return true;
                }
                if (r instanceof Xt || r instanceof Qt) {
                    g[r.definition().id] = false;
                    return true;
                }
                if (r instanceof ai) {
                    E(r, true);
                    return true;
                }
                if (r instanceof ct) {
                    var c = d;
                    d = r;
                    var f = v;
                    hn(r, b);
                    v = f;
                    if (r.bcatch) {
                        if (r.bcatch.argname) r.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof ri) {
                                var n = e.definition();
                                g[n.id] = false;
                                if (n = n.redefined()) g[n.id] = false;
                            }
                        }, b);
                        if (r.bfinally || (d = c)) {
                            hn(r.bcatch, b);
                        } else {
                            x();
                            hn(r.bcatch, b);
                            k();
                        }
                    }
                    d = c;
                    v = f;
                    if (r.bfinally) r.bfinally.walk(b);
                    return true;
                }
                if (r instanceof Ot) {
                    if (!$i[r.operator]) return;
                    var l = r.expression;
                    if (!(l instanceof ai)) return;
                    E(l, true);
                    return true;
                }
                if (r instanceof _t) {
                    var p = r.value;
                    if (p) {
                        p.walk(b);
                    } else {
                        p = v.block instanceof kn && v.block.init === b.parent();
                    }
                    r.name.mark_symbol(p ? function(e) {
                        if (!(e instanceof Jt)) return;
                        if (e instanceof Zt) {
                            E(e);
                        } else {
                            g[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof Jt)) return;
                        var n = e.definition().id;
                        if (!(e instanceof Zt)) {
                            g[n] = false;
                        } else if (!(n in g)) {
                            _.add(n, e);
                        } else if (g[n]) {
                            g[n].push(e);
                        }
                        return true;
                    }, b);
                    return true;
                }
                if (r instanceof wn) {
                    x();
                    v.block = r;
                    v.loop = true;
                    e();
                    k();
                    return true;
                }
            });
            b.directives = Object.create(o.directives);
            m.walk(b);
            var e = Object.create(null);
            while (s.length && f.length) {
                var n = s.pop();
                var t = n.definition;
                if (!(t.id in c)) continue;
                if (!g[t.id]) continue;
                var i = {
                    start: g[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = g[t.id].end;
                var r = [];
                do {
                    var a = f.pop();
                    if (!a) continue;
                    if (a.index > n.index) continue;
                    var l = a.definition.id;
                    var p = g[l];
                    if (!p) continue;
                    if (i.start.block !== p.start.block || !A(i, p) || i.start.loop && !A(p, i) || !nn(p, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(a);
                        continue;
                    }
                    var y = [], w = [];
                    p.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof ai) {
                            w.push(e);
                        } else {
                            y.push(e);
                        }
                    });
                    t.orig = y.concat(t.orig);
                    t.references = w.concat(t.references);
                    t.fixed = a.definition.fixed && t.fixed;
                    e[l] = t;
                    break;
                } while (f.length);
                if (r.length) f = f.concat(r);
            }
            function x() {
                v = Object.create(v);
            }
            function k() {
                v = Object.getPrototypeOf(v);
            }
            function E(e, n) {
                var t = e.definition(), i, r = v;
                if (d) {
                    x();
                    r = v;
                    k();
                }
                if (t.id in g) {
                    var a = g[t.id];
                    if (!a) return;
                    if (a.start.block !== r.block) return g[t.id] = false;
                    a.push(e);
                    a.end = r;
                    if (t.id in c) {
                        f[c[t.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((i = m.variables.get(t.name)) !== t) {
                    if (i && h === r) g[i.id] = false;
                    return g[t.id] = false;
                } else if (o.exposed(t) || j[e.name]) {
                    return g[t.id] = false;
                } else {
                    var a = _.get(t.id) || [];
                    a.push(e);
                    g[t.id] = a;
                    if (!n) {
                        a.start = r;
                        return s.push({
                            index: u++,
                            definition: t
                        });
                    }
                    if (r.block !== m) return g[t.id] = false;
                    a.start = h;
                }
                c[t.id] = f.length;
                f.push({
                    index: u++,
                    definition: t
                });
            }
            function S(e) {
                var n = [];
                while (true) {
                    if (rn(v, "block")) {
                        var t = v.block;
                        if (t instanceof _n) t = t.body;
                        if (t === e) break;
                    }
                    n.push(v);
                    k();
                }
                v.inserted = v.block;
                x();
                while (n.length) {
                    var i = n.pop();
                    x();
                    if (rn(i, "block")) v.block = i.block;
                    if (rn(i, "loop")) v.loop = i.loop;
                }
            }
            function T(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function A(e, n) {
                return T(e.start, e.end) || T(e.start, n.start);
            }
        });
        function $e(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = xe(yi, e);
            }
        }
        function X(e, n) {
            var t = xe(Wn, e, e);
            t.name = n ? null : xe(ii, e.name, e.name);
            return t;
        }
        function ze(e, n) {
            var t;
            switch (e.CTOR) {
              case Bn:
                t = Pn;
                break;

              case Rn:
                t = Nn;
                break;

              case Ln:
                t = Hn;
                break;

              case Un:
                t = Yn;
                break;
            }
            var i = xe(t, e, e);
            i.name = n ? null : xe(ti, e.name, e.name);
            return i;
        }
        Tn.DEFMETHOD("drop_unused", function(S) {
            if (!S.option("unused")) return;
            var T = this;
            var A = !(T instanceof An) || S.toplevel.funcs;
            var D = !(T instanceof An) || S.toplevel.vars;
            var O = /keep_assign/.test(S.option("unused")) ? Ve : function(e, n) {
                var t, i = false;
                if (e instanceof Mt) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof Ot) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(S.option("pure_getters"))) {
                    while (t instanceof St && !t.expression.may_throw_on_access(S)) {
                        if (t instanceof At) n.unshift(t.property);
                        t = t.expression;
                        i = true;
                    }
                }
                if (!(t instanceof ai)) return;
                var r = t.definition();
                if (o[r.id]) return;
                if (S.exposed(r)) return;
                if (!ye(t, S, i)) return;
                return t;
            };
            var $ = Object.create(null);
            var o = Object.create(null);
            var d = function(e) {
                d = o(T, 0, Ue);
                return d(e);
                function o(e, n, i) {
                    var t = S.parent(n);
                    if (!t) return i;
                    if (t instanceof Yt) {
                        var r = S.parent(n + 1);
                        if (t.key === e) {
                            var a = S.parent(n + 2);
                            if (a instanceof Dn) {
                                return o(a, n + 3, a.argnames.indexOf(r) >= 0 ? function(e) {
                                    var n = i(e);
                                    if (n) return n;
                                    n = a.variables.get(e);
                                    if (n) {
                                        var t = n.orig[0];
                                        if (t instanceof ei || t instanceof ti) return n;
                                    }
                                } : function(e) {
                                    return i(e) || a.variables.get(e);
                                });
                            }
                        }
                        return o(r, n + 2, i);
                    }
                    return o(t, n + 1, t.variables ? function(e) {
                        return i(e) || t.variables.get(e);
                    } : i);
                }
            };
            var z = Object.create(null);
            var h = [];
            var q = Object.create(null);
            var v = Object.create(null);
            var m = Object.create(null);
            var F = Object.create(null);
            if (T instanceof An && S.top_retain) {
                T.variables.each(function(e) {
                    if (S.top_retain(e) && !(e.id in q)) {
                        q[e.id] = true;
                        h.push(e);
                    }
                });
            }
            var _ = new tn();
            var g = new tn();
            var M = this;
            var b = new Si(function(a, e) {
                if (a instanceof Dn && a.uses_arguments && !b.has_directive("use strict")) {
                    a.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in q)) {
                            q[n.id] = true;
                            h.push(n);
                        }
                    });
                }
                if (a === T) return;
                if (M === T) {
                    if (a instanceof Gn) {
                        var t = a.name.definition();
                        if ((!A || t.exported) && !(t.id in q)) {
                            q[t.id] = true;
                            h.push(t);
                        }
                        if (a.extends) a.extends.walk(b);
                        var i = false;
                        if (b.parent() instanceof bt) {
                            i = true;
                            o[t.id] = true;
                        }
                        a.properties.forEach(function(e) {
                            if (e.key instanceof on) e.key.walk(b);
                            if (!e.value) return;
                            if (i || e instanceof Xn && e.static) {
                                var n = M;
                                M = a;
                                e.value.walk(b);
                                M = n;
                            } else {
                                g.add(t.id, e.value);
                            }
                        });
                        return true;
                    }
                    if (a instanceof In) {
                        var t = a.name.definition();
                        if ((!A || t.exported) && !(t.id in q)) {
                            q[t.id] = true;
                            h.push(t);
                        }
                        g.add(t.id, a);
                        if (b.parent() instanceof bt) {
                            o[t.id] = true;
                        } else {
                            return true;
                        }
                    }
                    if (a instanceof dt) {
                        a.definitions.forEach(function(i) {
                            var r = i.value && (i.name instanceof Nt || i.value.has_side_effects(S));
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof Jt)) return;
                                var n = e.definition();
                                F[n.id] = (F[n.id] || 0) + 1;
                                if (a instanceof mt && n.orig[0] instanceof ri) {
                                    var t = n.redefined();
                                    if (t) F[t.id] = (F[t.id] || 0) + 1;
                                }
                                if (!(n.id in q) && (!D || n.exported || (a instanceof ht ? n.redefined() : n.const_redefs) || !(a instanceof mt || K(n)))) {
                                    q[n.id] = true;
                                    h.push(n);
                                }
                                if (i.value) {
                                    if (!r) g.add(n.id, i.value);
                                    _.add(n.id, i);
                                }
                                return true;
                            }, b);
                            if (r) i.value.walk(b);
                        });
                        return true;
                    }
                    if (a instanceof ei) {
                        var t = a.definition();
                        F[t.id] = (F[t.id] || 0) + 1;
                        _.add(t.id, a);
                        return true;
                    }
                    if (a instanceof Kt) {
                        var t = a.definition();
                        if (!(t.id in q) && (!D || !K(t))) {
                            q[t.id] = true;
                            h.push(t);
                        }
                        return true;
                    }
                } else if (a instanceof ui && M instanceof Gn) {
                    var t = M.name.definition();
                    if (!(t.id in q)) {
                        q[t.id] = true;
                        h.push(t);
                    }
                }
                return r(a, e, true);
            });
            b.directives = Object.create(S.directives);
            T.walk(b);
            b = new Si(r);
            for (var e = 0; e < h.length; e++) {
                var n = g.get(h[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(b);
                });
            }
            Object.keys($).forEach(function(e) {
                var t = $[e];
                if (!t) {
                    delete $[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Ke(n, e);
                    });
                    return n;
                }, []);
                var n = (_.get(e) || []).filter(function(n) {
                    return Le(n instanceof Ot ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Ot) return false;
                        return i(e) === i(n);
                    }, t);
                });
                if (t.length == n.length) {
                    $[e] = n;
                } else {
                    delete $[e];
                }
            });
            var C = S.option("keep_fnames") ? Ve : S.option("ie8") ? function(e) {
                return !S.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in q)) return true;
                if (e.orig.length < 2) return false;
                if (e.orig[1] instanceof ei) return true;
                return nn(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            var j = [];
            var P = [];
            var N = [];
            var H = [];
            var Y = new Ti(function(i) {
                if (i instanceof wt) return l(Y, i);
                if (i instanceof Nt && i.rest) i.rest = i.rest.transform(Y);
                if (i instanceof Ht) {
                    var e = !i.rest;
                    for (var n = i.elements.length; --n >= 0; ) {
                        var t = i.elements[n].transform(Y);
                        if (t) {
                            i.elements[n] = t;
                            e = false;
                        } else if (e) {
                            i.elements.pop();
                        } else {
                            i.elements[n] = xe(yi, i.elements[n]);
                        }
                    }
                    return i;
                }
                if (i instanceof It) {
                    var r = [];
                    i.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof on) {
                            e.key = e.key.transform(I);
                            n = e.key.has_side_effects(S);
                        }
                        if ((n || i.rest) && c(e.value)) {
                            e.value = e.value.transform(I);
                            r.push(e);
                        } else {
                            var t = e.value.transform(Y);
                            if (!t && i.rest) {
                                if (e.value instanceof Ht) {
                                    t = xe(Ht, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = xe(It, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                r.push(e);
                            }
                        }
                    });
                    i.properties = r;
                    return i;
                }
                if (i instanceof Jt) return i.definition().id in q ? i : null;
            });
            var I = new Ti(function(v, n, e) {
                var m = I.parent();
                if (D) {
                    var t = [], i = O(v, t);
                    if (i) {
                        var r = i.definition();
                        var a = r.id in q;
                        var o;
                        if (v instanceof Mt) {
                            if (!a || v.left === i && U(r, v) < 0) {
                                o = V(v);
                                if (v.write_only === true) {
                                    o = o.drop_side_effect_free(S) || xe(hi, v, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!a || v.expression === i && U(r, v) < 0) {
                            o = xe(hi, v, {
                                value: 0
                            });
                        }
                        if (o) {
                            if (m instanceof Et && m.tail_node() !== v) {
                                o = o.drop_side_effect_free(S);
                            }
                            if (o) t.push(o);
                            switch (t.length) {
                              case 0:
                                return Xe.skip;

                              case 1:
                                return ke(S, m, v, t[0].transform(I));

                              default:
                                return ce(v, t.map(function(e) {
                                    return e.transform(I);
                                }));
                            }
                        }
                    } else if (v instanceof zt && v.expression instanceof ai && U(v.expression.definition(), v) < 0) {
                        return xe($t, v, {
                            operator: "+",
                            expression: v.expression
                        });
                    }
                }
                if (v instanceof xt) N.push(v);
                if (M !== T) return;
                if (A && v !== T && v instanceof Gn) {
                    var r = v.name.definition();
                    if (!(r.id in q)) {
                        B(v.name, "Dropping unused class {name}");
                        r.eliminated++;
                        n(v, I);
                        if (m instanceof bt) return X(v, true);
                        var s = v.drop_side_effect_free(S, true);
                        if (s === v) s = X(v, true);
                        if (s) return xe(pn, v, {
                            body: s
                        });
                        return e ? Xe.skip : xe(cn, v);
                    }
                }
                if (v instanceof Wn && v.name && C(v.name.definition())) {
                    P.push(v);
                }
                if (v instanceof Dn) {
                    if (A && v !== T && v instanceof In) {
                        var r = v.name.definition();
                        if (!(r.id in q)) {
                            B(v.name, "Dropping unused function {name}");
                            r.eliminated++;
                            if (m instanceof bt) {
                                E();
                                return ze(v, true);
                            }
                            return e ? Xe.skip : xe(cn, v);
                        }
                    }
                    if (v instanceof $n && v.name && C(v.name.definition())) {
                        P.push(v);
                    }
                    if (!(v instanceof On)) {
                        if (v.rest) {
                            v.rest = v.rest.transform(Y);
                            if (!(v.uses_arguments && !I.has_directive("use strict")) && (v.rest instanceof Ht && v.rest.elements.length == 0 || v.rest instanceof It && v.rest.properties.length == 0)) {
                                v.rest = null;
                            }
                        }
                        var f = v.argnames;
                        var u = S.drop_fargs(v, m) && !v.rest;
                        var c = u ? -1 : v.length();
                        for (var l = f.length; --l >= 0; ) {
                            var i = f[l];
                            if (!(i instanceof ei)) {
                                var p = i.transform(Y);
                                if (p) {
                                    u = false;
                                } else if (u) {
                                    B(i.name, "Dropping unused default argument {name}");
                                    f.pop();
                                } else if (l > c) {
                                    B(i.name, "Dropping unused default argument assignment {name}");
                                    i.name.__unused = true;
                                    f[l] = i.name;
                                } else {
                                    B(i.name, "Dropping unused default argument value {name}");
                                    i.value = xe(hi, i, {
                                        value: 0
                                    });
                                }
                                continue;
                            }
                            var r = i.definition();
                            if (r.id in q) {
                                u = false;
                                if (U(r, i) < 0) i.__unused = null;
                            } else if (u) {
                                B(i, "Dropping unused function argument {name}");
                                f.pop();
                            } else {
                                i.__unused = true;
                            }
                        }
                        H.push(v);
                    }
                }
                if (v instanceof lt && v.argname instanceof Nt) {
                    v.argname.transform(Y);
                }
                if (v instanceof dt && !(m instanceof kn && m.init === v)) {
                    var _ = [], g = [], b = [];
                    var y = [];
                    var w = 0;
                    var x = v instanceof mt;
                    v.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(I);
                        var e = t.value;
                        if (t.name instanceof Nt) {
                            var n = G(t.name, e, function(e) {
                                if (!D) return e;
                                if (e.definition().id in q) return e;
                                if (d(e)) return e;
                                if (x && !ye(e)) return e;
                                return null;
                            });
                            if (n) {
                                h();
                            } else {
                                e = e.drop_side_effect_free(S);
                                if (e) y.push(e);
                            }
                            return;
                        }
                        var i = t.name.definition();
                        var r = x ? ye(t.name) : K(i);
                        if (!r || !D || i.id in q) {
                            if (e && U(i, t) < 0) {
                                var a = e.write_only;
                                e = e.drop_side_effect_free(S);
                                if (t.value !== e) {
                                    if (e) {
                                        on.warn("Side effects in last use of variable {name} [{file}:{line},{col}]", R(t.name));
                                        y.push(e);
                                    }
                                    e = null;
                                    j.push(t);
                                } else if (e.write_only !== a) {
                                    e.write_only = a;
                                }
                            }
                            var o;
                            if (!e && !(v instanceof vt)) {
                                if (m instanceof gt) {
                                    h();
                                } else if (r && F[i.id] > 1) {
                                    on.info("Dropping declaration of variable {name} [{file}:{line},{col}]", R(t.name));
                                    F[i.id]--;
                                    i.eliminated++;
                                } else {
                                    g.push(t);
                                }
                            } else if (S.option("functions") && !S.option("ie8") && v instanceof mt && F[i.id] == 1 && i.assignments == 0 && e instanceof $n && !ge(i) && !zn(e) && c(e, i.references) && l(e) && (o = p(e, t.name.name)) !== false) {
                                on.warn("Declaring {name} as function [{file}:{line},{col}]", R(t.name));
                                var s;
                                switch (e.CTOR) {
                                  case Pn:
                                    s = Bn;
                                    break;

                                  case Nn:
                                    s = Rn;
                                    break;

                                  case Hn:
                                    s = Ln;
                                    break;

                                  case Yn:
                                    s = Un;
                                    break;
                                }
                                var f = xe(s, t, e);
                                f.name = xe(ni, t.name, t.name);
                                var u = t.name.scope.resolve().def_function(f.name);
                                if (o) o.forEach(function(e) {
                                    e.name = u.name;
                                    e.thedef = u;
                                    e.reference();
                                });
                                _.push(f);
                            } else {
                                if (r && F[i.id] > 1 && !(m instanceof gt) && i.orig.indexOf(t.name) > i.eliminated) {
                                    F[i.id]--;
                                    w++;
                                }
                                h();
                            }
                        } else if (d(t.name)) {
                            e = e && e.drop_side_effect_free(S);
                            if (e) y.push(e);
                            if (F[i.id] > 1) {
                                on.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", R(t.name));
                                F[i.id]--;
                                i.eliminated++;
                            } else {
                                t.value = null;
                                g.push(t);
                            }
                        } else {
                            e = e && !e.single_use && e.drop_side_effect_free(S);
                            if (e) {
                                on.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", R(t.name));
                                y.push(e);
                            } else {
                                B(t.name, "Dropping unused variable {name}");
                            }
                            i.eliminated++;
                        }
                        function c(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return nn(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function l(e) {
                            if (S.has_directive("use strict") || !(e instanceof Hn)) {
                                return m instanceof Tn;
                            }
                            return m instanceof vn || m instanceof xn && m.init === v || m instanceof at;
                        }
                        function p(e, n) {
                            if (!e.name) return null;
                            var t = e.name.definition();
                            if (t.orig.length > 1) return null;
                            if (t.assignments > 0) return false;
                            if (t.name == n) return t;
                            if (n == "await" && qn(e)) return false;
                            if (n == "yield" && Fn(e)) return false;
                            return nn(t.references, function(e) {
                                return e.scope.find_variable(n) === i;
                            }) && t;
                        }
                        function d(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof ri && n.scope.resolve() === e.scope.resolve();
                        }
                        function h() {
                            if (y.length > 0) {
                                if (b.length == 0) {
                                    _.push(xe(pn, v, {
                                        body: ce(v, y)
                                    }));
                                } else if (e) {
                                    y.push(e);
                                    t.value = ce(e, y);
                                } else {
                                    t.value = xe($t, t, {
                                        operator: "void",
                                        expression: ce(t, y)
                                    });
                                }
                                y = [];
                            }
                            b.push(t);
                        }
                    });
                    switch (g.length) {
                      case 0:
                        if (b.length == 0) break;
                        if (b.length == w) {
                            [].unshift.apply(y, b.map(function(e) {
                                on.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", R(e.name));
                                var n = e.name.definition();
                                var t = xe(ai, e.name, e.name);
                                n.references.push(t);
                                var i = xe(Mt, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = U(n, e);
                                if (r >= 0) $[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (b.length == 0) {
                            var d = g[0].name.definition().id;
                            if (d in z) {
                                v.definitions = g;
                                z[d].init = v;
                                break;
                            }
                        }

                      default:
                        v.definitions = g.concat(b);
                        _.push(v);
                    }
                    if (y.length > 0) {
                        _.push(xe(pn, v, {
                            body: ce(v, y)
                        }));
                    }
                    return L(_, v, e);
                }
                if (v instanceof Mt) {
                    n(v, I);
                    if (v.left instanceof Nt) {
                        var h = G(v.left, v.right, function(e) {
                            return e;
                        });
                        if (!h) return v.right;
                        v.left = h;
                    }
                    return v;
                }
                if (v instanceof _n && v.body instanceof xn) {
                    n(v, I);
                    if (v.body instanceof mn) {
                        var k = v.body;
                        v.body = k.body.pop();
                        k.body.push(v);
                        return e ? Xe.splice(k.body) : k;
                    }
                    return v;
                }
                if (v instanceof Tn) {
                    E();
                    return v;
                }
                if (v instanceof Kt) {
                    if (!S.option("imports") || v.definition().id in q) return v;
                    return e ? Xe.skip : null;
                }
                function E() {
                    var e = M;
                    M = v;
                    n(v, I);
                    M = e;
                }
            }, function(e, n) {
                if (e instanceof mn) return J(e, I.parent(), n);
                if (e instanceof xn) {
                    var t;
                    if (e.init instanceof mn) {
                        t = e.init;
                        e.init = t.body.pop();
                        t.body.push(e);
                    }
                    if (e.init instanceof Ln) {
                        if (!t) {
                            t = xe(mn, e, {
                                body: [ e ]
                            });
                        }
                        t.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof pn) {
                        e.init = e.init.body;
                    } else if (de(e.init)) {
                        e.init = null;
                    }
                    return !t ? e : n ? Xe.splice(t.body) : t;
                }
                if (e instanceof En) {
                    if (!D || !S.option("loops")) return;
                    if (!de(e.body)) return;
                    var i = k(e);
                    if (!i) return;
                    var r = i.definition();
                    if (r.id in q) return;
                    B(i, "Dropping unused loop variable {name}");
                    if (z[r.id] === e) delete z[r.id];
                    var a = [];
                    var o = e.object.drop_side_effect_free(S);
                    if (o) {
                        on.warn("Side effects in object of for-in loop [{file}:{line},{col}]", o.start);
                        a.push(xe(pn, e, {
                            body: o
                        }));
                    }
                    if (e.init instanceof dt && r.orig[0] instanceof ri) {
                        a.push(e.init);
                    }
                    return L(a, e, n);
                }
                if (e instanceof Et) {
                    if (e.expressions.length > 1) return;
                    return ke(S, I.parent(), e, e.expressions[0]);
                }
            });
            I.push(S.parent());
            T.transform(I);
            if (T instanceof Dn && T.body.length == 1 && T.body[0] instanceof un && T.body[0].value == "use strict") {
                T.body.length = 0;
            }
            j.forEach(function(e) {
                e.value = null;
            });
            P.forEach(function(e) {
                e.name = null;
            });
            N.forEach(function(e) {
                Me(e, S, H);
            });
            function B(e, n) {
                on[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", R(e));
            }
            function R(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function i(e) {
                return e[e instanceof Mt ? "right" : "value"];
            }
            function L(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? Xe.skip : xe(cn, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? Xe.splice(e) : xe(mn, n, {
                        body: e
                    });
                }
            }
            function y(e, n) {
                if (e.scope !== T) return false;
                if (!e.fixed || !n.fixed) $[e.id] = false;
                return $[e.id] !== false;
            }
            function w(e, n) {
                if (!$[e.id]) $[e.id] = [];
                if (n.fixed.assigns) Ke($[e.id], n.fixed.assigns);
            }
            function U(e, n) {
                var t = $[e.id];
                return t && t.indexOf(n);
            }
            function x(e, n, t) {
                if (e.id in q) return;
                if (n && t) {
                    q[e.id] = true;
                    h.push(e);
                } else {
                    v[e.id] = n;
                    m[e.id] = t;
                }
            }
            function V(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof qt && De[n.operator])) return n;
                if (!(n.left instanceof ai)) return n;
                if (!(e.left instanceof ai)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(S)) return n;
                if (y(t, n.left)) w(t, n.left);
                return n.right;
            }
            function k(e) {
                var n = e.init;
                if (n instanceof dt) {
                    n = n.definitions[0].name;
                    return n instanceof Jt && n;
                }
                while (n instanceof St) n = n.expression.tail_node();
                if (n instanceof ai) return n;
            }
            function r(e, n, t) {
                if (e instanceof Mt && e.left instanceof ai) {
                    var i = e.left.definition();
                    if (i.scope === T) _.add(i.id, e);
                }
                if (e instanceof Ot && e.expression instanceof ai) {
                    var i = e.expression.definition();
                    if (i.scope === T) _.add(i.id, e);
                }
                var r, a = [], o = O(e, a);
                if (o && T.variables.get(o.name) === (r = o.definition()) && !(ge(r) && !nn(T.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof ei) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    a.forEach(function(e) {
                        e.walk(b);
                    });
                    if (e instanceof Mt) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(S)) return;
                        var s = V(e);
                        if (t && e.write_only === true && r.scope === T && !s.has_side_effects(S)) {
                            g.add(r.id, s);
                        } else {
                            s.walk(b);
                        }
                        if (e.left === o) {
                            if (!e.write_only) {
                                x(r, true, m[r.id]);
                            }
                        } else {
                            var f = o.fixed_value();
                            if (!f || !f.is_constant()) {
                                x(r, v[r.id], true);
                            }
                        }
                    }
                    if (y(r, o) && Mi(o, e) !== o) w(r, o);
                    return true;
                }
                if (e instanceof En) {
                    if (e.init instanceof ai && M === T) {
                        var u = e.init.definition().id;
                        if (!(u in z)) z[u] = e;
                    }
                    if (!D || !S.option("loops")) return;
                    if (!de(e.body)) return;
                    if (e.init.has_side_effects(S)) return;
                    var o = k(e);
                    if (!o) return;
                    var i = o.definition();
                    if (i.scope !== T) {
                        var c = d(o.name);
                        if (c === i || c && c.redefined() === i) return;
                    }
                    e.object.walk(b);
                    return true;
                }
                if (e instanceof ai) {
                    r = e.definition();
                    if (!(r.id in q)) {
                        q[r.id] = true;
                        h.push(r);
                    }
                    if (W(r.scope, e.scope)) {
                        var l = r.redefined();
                        if (l && !(l.id in q)) {
                            q[l.id] = true;
                            h.push(l);
                        }
                    }
                    if (y(r, e)) w(r, e);
                    return true;
                }
                if (e instanceof Tn) {
                    var p = M;
                    M = e;
                    n();
                    M = p;
                    return true;
                }
            }
            function c(e) {
                return (e instanceof wt ? e.name : e) instanceof Jt;
            }
            function l(e, n) {
                n.value = n.value.transform(I);
                var t = n.name.transform(e);
                if (!t) {
                    var i = n.value.drop_side_effect_free(S);
                    if (!i) return null;
                    t = n.name;
                    if (t instanceof Nt) {
                        t = t.clone();
                        t[t instanceof Ht ? "elements" : "properties"] = [];
                        if (!(i instanceof Pt || i.is_string(S) || t instanceof It && (i instanceof Bt || i.is_boolean(S) || i.is_number(S)))) {
                            i = xe(Pt, i, {
                                elements: [ i ]
                            });
                        }
                        n.name = t;
                    } else {
                        B(t, "Side effects in default value of unused variable {name}");
                    }
                    n.value = i;
                }
                return n;
            }
            function G(e, s, f) {
                var u = new Ti(function(i) {
                    if (i instanceof wt) {
                        if (S.option("default_values") && s && s.is_defined(S)) {
                            i = i.name;
                        } else {
                            return l(u, i);
                        }
                    }
                    if (i instanceof Ht) {
                        var e = s;
                        if (s instanceof ai) s = s.fixed_value();
                        var r = s instanceof Pt && s.elements;
                        var t = [];
                        i.elements.forEach(function(e, n) {
                            s = r && r[n];
                            if (s instanceof Dt) s = r = null;
                            if (e instanceof yi) return;
                            e = e.transform(u);
                            if (e) t[n] = e;
                        });
                        if (i.rest) {
                            if (S.option("rests")) {
                                s = r && xe(Pt, e, {
                                    elements: r.slice(i.elements.length)
                                });
                                i.rest = i.rest.transform(u);
                            } else {
                                i.rest = i.rest.transform(I);
                            }
                        }
                        s = e;
                        if (i.rest) {
                            t.length = i.elements.length;
                        } else if (r && t.length == 0) {
                            return null;
                        }
                        $e(i, t);
                        i.elements = t;
                        return i;
                    }
                    if (i instanceof It) {
                        var e = s;
                        if (s instanceof ai) s = s.fixed_value();
                        var r;
                        if (s instanceof Bt) {
                            r = Object.create(null);
                            for (var n = 0; n < s.properties.length; n++) {
                                var a = s.properties[n];
                                if (typeof a.key != "string") {
                                    r = null;
                                    break;
                                }
                                r[a.key] = a.value;
                            }
                        }
                        var o = [];
                        i.properties.forEach(function(e) {
                            var n;
                            if (e.key instanceof on) {
                                e.key = e.key.transform(I);
                                s = null;
                                n = e.key.has_side_effects(S);
                            } else {
                                s = r && r[e.key];
                                n = false;
                            }
                            if ((n || i.rest) && c(e.value)) {
                                e.value = e.value.transform(I);
                                o.push(e);
                            } else {
                                var t = e.value.transform(u);
                                if (!t && i.rest) {
                                    if (e.value instanceof Ht) {
                                        t = xe(Ht, e.value, {
                                            elements: []
                                        });
                                    } else {
                                        t = xe(It, e.value, {
                                            properties: []
                                        });
                                    }
                                }
                                if (t) {
                                    e.value = t;
                                    o.push(e);
                                }
                            }
                        });
                        if (i.rest) {
                            if (S.option("rests")) {
                                s = r && xe(Bt, e, {
                                    properties: []
                                });
                                i.rest = i.rest.transform(u);
                            } else {
                                i.rest = i.rest.transform(I);
                            }
                        }
                        s = e;
                        if (o.length == 0 && !i.rest && s && !s.may_throw_on_access(S)) {
                            return null;
                        }
                        i.properties = o;
                        return i;
                    }
                    return f(i);
                });
                return e.transform(u);
            }
        });
        Tn.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Si(function(e) {
                    if (n > 1) return true;
                    if (e instanceof gt) return true;
                    if (e instanceof Tn && e !== u) return true;
                    if (e instanceof mt) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = Object.create(null);
            var l = [];
            var p = [];
            var d = new tn(), h = 0;
            var v = new Ti(function(e, n, t) {
                if (e === u) return;
                if (e instanceof un) {
                    l.push(e);
                    return t ? Xe.skip : xe(cn, e);
                }
                if (e instanceof In) {
                    if (!s) return e;
                    var i = v.parent();
                    if (i instanceof gt) return e;
                    if (i instanceof bt) return e;
                    if (i !== u && o.has_directive("use strict")) return e;
                    p.push(e);
                    return t ? Xe.skip : xe(cn, e);
                }
                if (e instanceof mt) {
                    if (!f) return e;
                    var i = v.parent();
                    if (i instanceof gt) return e;
                    if (!nn(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof Zt && !c[n.name] && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        d.set(e.name.name, e);
                        ++h;
                    });
                    var r = e.to_assignments();
                    if (i instanceof kn && i.init === e) {
                        if (r) return r;
                        var a = e.definitions[0].name;
                        return xe(ai, a, a);
                    }
                    if (i instanceof xn && i.init === e) return r;
                    if (!r) return t ? Xe.skip : xe(cn, e);
                    return xe(pn, e, {
                        body: r
                    });
                }
                if (e instanceof Tn) return e;
                if (e instanceof Xt) {
                    c[e.name] = true;
                    return e;
                }
            });
            u.transform(v);
            if (h > 0) {
                var m = [];
                if (u instanceof Dn) u.each_argname(function(e) {
                    d.del(e.name);
                });
                d.each(function(e, n) {
                    e = e.clone();
                    e.value = null;
                    m.push(e);
                    d.set(n, e);
                });
                if (m.length > 0) {
                    _(u.body);
                    m = xe(mt, u, {
                        definitions: m
                    });
                    p.push(m);
                }
            }
            u.body = l.concat(p, u.body);
            function _(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof pn) {
                        var t = n.body, i, r;
                        if (t instanceof Mt && t.operator == "=" && (i = t.left) instanceof Wt && d.has(i.name)) {
                            var a = d.get(i.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof Et) o = o.clone();
                            a.value = o;
                            Ze(m, a);
                            m.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof Et && (r = t.expressions[0]) instanceof Mt && r.operator == "=" && (i = r.left) instanceof Wt && d.has(i.name)) {
                            var a = d.get(i.name);
                            if (a.value) break;
                            a.value = r.right;
                            Ze(m, a);
                            m.push(a);
                            n.body = ce(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof cn) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof mn && !_(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function P(n, t) {
            n.walk(new Si(function(e) {
                if (e instanceof et) {
                    t(e);
                    return true;
                }
                if (e instanceof Tn && e !== n) return true;
            }));
        }
        function N(e) {
            var i = Object.create(null);
            P(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof ai) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function H(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function Y(e, i) {
            P(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? ce(e.value, [ n, xe(hi, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof on)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? ce(e.value, [ n, xe(hi, e.value, {
                            value: 1
                        }) ]) : xe(hi, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        Tn.DEFMETHOD("process_boolean_returns", Ue);
        Ln.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = N(this);
            if (!H(this.name.definition(), n, e)) return;
            if (e.parent() instanceof bt) return;
            Y(this, e);
        });
        Hn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = N(this);
            if (this.name && !H(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof Mt) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof ai)) return;
                if (!H(i.definition(), n, e)) return;
            } else if (t instanceof xt && t.expression !== this) {
                var r = t.expression;
                if (r instanceof ai) r = r.fixed_value();
                if (!(r instanceof Dn)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i instanceof wt) i = i.name;
                if (i instanceof ei && !H(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            Y(this, e);
        });
        dn.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        Tn.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof Jt) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (Re(n, i)) return;
                do {
                    Ke(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var r = t;
            for (var a = 0; !nn(i, function(e) {
                return !e.var_names()[r];
            }); a++) r = t + "$" + a;
            var o = xe(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(o);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names()[r] = true;
            });
            return o;
        });
        Tn.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof An && e.top_retain || Ve;
            var u = Object.create(null);
            f.transform(new Ti(function(i, e) {
                if (i instanceof Mt) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new tn();
                    var a = [];
                    var o = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        o.push(xe(_t, i, {
                            name: n,
                            value: null
                        }));
                        var t = xe(ai, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(xe(Mt, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, xe(mt, i, {
                        definitions: o
                    }));
                    return ce(i, a);
                }
                if (i instanceof Tn) return i === f ? undefined : i;
                if (i instanceof _t) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new tn();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(xe(_t, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return Xe.splice(n);
                }
                function s(e, n) {
                    var t = f.make_var(Zt, e, e.name + "_" + n);
                    r.set(n, t.definition());
                    return t;
                }
            }));
            f.transform(new Ti(function(i, e) {
                if (i instanceof qt) return a("right");
                if (i instanceof St) {
                    if (!(i.expression instanceof ai)) return;
                    var n = u[i.expression.definition().id];
                    if (!n) return;
                    var t = n.get(i.getProperty());
                    var r = xe(ai, i, {
                        name: t.name,
                        scope: i.expression.scope,
                        thedef: t
                    });
                    r.reference();
                    return r;
                }
                if (i instanceof Ot) {
                    if (Fi[i.operator]) return;
                    return a("expression");
                }
                function a(e) {
                    var n = i[e];
                    if (!(n instanceof ai)) return;
                    if (!(n.definition().id in u)) return;
                    var t = i.clone();
                    t[e] = xe(Bt, n, {
                        properties: []
                    });
                    return t;
                }
            }));
            function t(e, n, t) {
                if (!(e instanceof Wt)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof Bt && n.properties.length > 0 && nn(n.properties, Be) && nn(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && ye(e);
            }
        });
        function qe(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return nn(t.references, function(e) {
                return !(e instanceof ai);
            });
        }
        (function(e) {
            function d(e, n, t, i) {
                var r = e.length;
                var a = [], o = false;
                for (var s = 0; s < r; s++) {
                    var f = e[s];
                    var u;
                    if (i && f instanceof Dt) {
                        u = i(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function h(e, n, t) {
                var i = e.expression;
                if (!i.is_string(n)) return e;
                return i.drop_side_effect_free(n, t);
            }
            function v(e) {
                return e instanceof Dt ? xe(Pt, e, {
                    elements: [ e ]
                }) : e;
            }
            e(on, We);
            e(On, Je);
            e(Pt, function(e, n) {
                var t = d(this.elements, e, n, h);
                if (!t) return null;
                if (t === this.elements && nn(t, function(e) {
                    return e instanceof Dt;
                })) return this;
                return ce(this, t.map(v));
            });
            e(Mt, function(e) {
                var n = this.left;
                if (n instanceof St) {
                    var t = n.expression;
                    if (t instanceof Mt && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                var i = this.right;
                if (De[this.operator.slice(0, -1)]) {
                    this.write_only = !i.has_side_effects(e);
                } else {
                    this.write_only = true;
                    if (Ee(n).is_constant_expression(e.find_parent(Tn))) {
                        return i.drop_side_effect_free(e);
                    }
                }
                return this;
            });
            e(Ct, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!re(e, n)) return this;
                var t = this.clone();
                t.expression = n.drop_side_effect_free(e) || xe(hi, this, {
                    value: 0
                });
                return t;
            });
            e(qt, function(e, n) {
                var t = this.left;
                var i = this.right;
                var r = this.operator;
                if (r == "in" && !Ce(i)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || xe(hi, t, {
                        value: 0
                    });
                    return o;
                }
                var s = i.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (De[r] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== i) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (r == "??") return o;
                    var f = xe(qt, this, {
                        operator: r == "&&" ? "||" : "&&",
                        left: t.negate(e, n),
                        right: o.right
                    });
                    return n ? p(o, f) : ve(o, f);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return ce(this, [ a, s ]);
            });
            e(xt, function(t, e) {
                var n = this;
                if (n.is_expr_pure(t)) {
                    if (n.pure) on.warn("Dropping __PURE__ call [{file}:{line},{col}]", n.start);
                    var i = d(n.args, t, e, h);
                    return i && ce(n, i.map(v));
                }
                var r = n.expression;
                if (n.is_call_pure(t)) {
                    var a = n.args.slice();
                    a.unshift(r.expression);
                    a = d(a, t, e, h);
                    return a && ce(n, a.map(v));
                }
                if (t.option("yields") && Fn(r)) {
                    var o = n.clone();
                    o.expression = xe(Hn, r, r);
                    o.expression.body = [];
                    var s = o.transform(t);
                    if (s !== o) return s.drop_side_effect_free(t, e);
                }
                var f = false;
                if (t.option("arrows") && zn(r)) {
                    if (!r.value) {
                        f = true;
                    } else if (!qn(r) || re(t, r.value)) {
                        r.value = r.value.drop_side_effect_free(t);
                    }
                } else if (r instanceof Pn || r instanceof Hn) {
                    if (r.name) {
                        var u = r.name.definition();
                        f = u.references.length == u.replaced;
                    } else {
                        f = true;
                    }
                }
                if (f) {
                    var c = qn(r);
                    r.process_expression(false, function(e) {
                        var n = e.value;
                        if (n) {
                            if (c && !re(t, n)) return e;
                            n = n.drop_side_effect_free(t, true);
                        }
                        if (!n) return xe(cn, e);
                        return xe(pn, e, {
                            body: n
                        });
                    });
                    P(r, function(e) {
                        var n = e.value;
                        if (n) {
                            if (c && !re(t, n)) return;
                            e.value = n.drop_side_effect_free(t);
                        }
                    });
                    n = n.clone();
                    n.expression = r.clone();
                    if (r._squeezed) n.expression._squeezed = true;
                }
                if (n instanceof kt) {
                    var l = r;
                    if (l instanceof ai) l = l.fixed_value();
                    if (l instanceof Dn) {
                        l.new = true;
                        var p = nn(l.body, function(e) {
                            return !e.has_side_effects(t);
                        });
                        delete l.new;
                        if (p) {
                            var a = n.args.slice();
                            a.unshift(r);
                            a = d(a, t, e, h);
                            return a && ce(n, a.map(v));
                        }
                        if (!l.contains_this()) return xe(xt, n, n);
                    }
                }
                return n;
            });
            e(Vn, function(e, n) {
                var t = [], i = [];
                var r = this.properties;
                for (var a = 0; a < r.length; a++) {
                    var o = r[a];
                    if (o.key instanceof on) t.push(o.key);
                    if (o instanceof Xn && o.static && o.value && !(o.value instanceof Dn)) {
                        if (o.value.contains_this()) return this;
                        i.push(o.value);
                    }
                }
                var s = this.extends;
                if (s) {
                    if (s instanceof ai) s = s.fixed_value();
                    s = !u(s);
                    if (!s) t.unshift(this.extends);
                }
                t = d(t, e, n);
                if (t) n = false;
                i = d(i, e, n);
                if (!t) {
                    if (!s && !i) return null;
                    t = [];
                }
                if (s) {
                    var f = X(this, true);
                    f.properties = [];
                    if (t.length) f.properties.push(xe(Kn, this, {
                        key: ce(this, t),
                        value: xe(Hn, this, {
                            argnames: [],
                            body: []
                        }).init_vars(f)
                    }));
                    t = [ f ];
                }
                if (i) t.push(xe(xt, this, {
                    expression: xe(Cn, this, {
                        argnames: [],
                        body: [],
                        value: ce(this, i)
                    }).init_vars(this.parent_scope),
                    args: []
                }));
                return ce(this, t);
            });
            e(Ft, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof Hn) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof Hn) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? xe(qt, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = xe(qt, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : ce(this, i);
            });
            e(pi, Je);
            e(Tt, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(Hn, function(e) {
                return qe(this, e) ? null : this;
            });
            e($n, Je);
            e(Bt, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Dt) {
                        t.push(e);
                    } else {
                        if (e.key instanceof on) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var i = d(t, e, n, function(e, n, t) {
                    var i = e.expression;
                    return m(i) ? e : i.drop_side_effect_free(n, t);
                });
                if (!i) return null;
                if (i === t && !nn(i, function(e) {
                    return !(e instanceof Dt);
                })) return this;
                return ce(this, i.map(function(e) {
                    return e instanceof Dt ? xe(Bt, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(si, Je);
            e(Et, function(e, n) {
                var t = d(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r = t[i];
                if (e.option("awaits") && i > 0 && r instanceof Ct && r.expression.is_constant()) {
                    t = t.slice(0, -1);
                    i--;
                    r.expression = t[i];
                    t[i] = r;
                }
                var a, o, s;
                if (e.option("conditionals") && i > 0 && (a = t[i - 1]) instanceof Mt && a.operator == "=" && (s = a.left) instanceof ai && (o = Z(e, s.definition(), a.right, r))) {
                    a = a.clone();
                    a.right = o;
                    t = t.slice(0, -2);
                    t.push(a.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : ce(this, t);
            });
            e(At, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return ce(this, [ t, i ]);
            });
            e(ai, function(e) {
                return this.is_declared(e) && ye(this, e) ? null : this;
            });
            e(li, function(e, n) {
                if (this.tag && !Pe(e, this.tag)) return this;
                var t = this.expressions;
                if (t.length == 0) return null;
                return ce(this, t).drop_side_effect_free(e, n);
            });
            e(Ot, function(e, n) {
                var t = this.expression;
                if (Fi[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof ai && ye(t, e)) {
                    return null;
                }
                var i = t.drop_side_effect_free(e, n);
                if (n && i && he(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(pn, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    on.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return xe(cn, e);
                }
                if (i !== t) {
                    return xe(pn, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(wn, function(e, n) {
            return n.option("loops") ? xe(xn, e, e).optimize(n) : e;
        });
        function I(n, e, t) {
            if (!t) t = tt;
            var i = false;
            var r = new Si(function(e) {
                if (i || e instanceof Tn) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof _n) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(yn, function(t, e) {
            if (!e.option("loops")) return t;
            var n = t.condition.is_truthy() || t.condition.evaluate(e, true);
            if (!(n instanceof on)) {
                if (n && !I(t, e.parent(), rt)) return xe(xn, t, {
                    body: xe(mn, t.body, {
                        body: [ t.body, xe(pn, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!I(t, e.parent())) return xe(mn, t.body, {
                    body: [ t.body, xe(pn, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof mn && !I(t, e.parent(), rt)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a instanceof at && !a.alternative && a.body instanceof it && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = xe(qt, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (a instanceof pn) {
                        if (o(a.body)) break;
                        t.condition = ce(t, [ a.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!F(a)) {
                        break;
                    }
                }
                t.body = J(t.body, e.parent());
            }
            if (t.body instanceof cn) return xe(xn, t, t).optimize(e);
            if (t.body instanceof pn) return xe(xn, t, {
                condition: ce(t.condition, [ t.body.body, t.condition ]),
                body: xe(cn, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Si(function(e) {
                    if (n) return true;
                    if (e instanceof ai) {
                        if (!Re(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function B(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof it || e instanceof rt && s(e) || e instanceof Zn)) {
                var i = [];
                if (ln(n.init)) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(xe(pn, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof Zn;
                if (n.condition && r) {
                    i.push(xe(at, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(xe(pn, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                k(t, n.body, i);
                return xe(mn, n, {
                    body: i
                });
            }
            if (e instanceof at) {
                var a = o(e.body);
                if (a instanceof it && !s(a)) {
                    if (n.condition) {
                        n.condition = xe(qt, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = z(e.alternative);
                    k(t, e.body, i);
                    return f(i);
                }
                a = o(e.alternative);
                if (a instanceof it && !s(a)) {
                    if (n.condition) {
                        n.condition = xe(qt, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = z(e.body);
                    k(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function o(e) {
                return e instanceof mn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof mn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = xe(mn, n.body, {
                        body: e
                    }).transform(t);
                }
                return B(n, t);
            }
        }
        e(xn, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof on) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = le(t, e.condition);
                    e.condition = ve(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (ln(e.init)) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(xe(pn, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(xe(pn, e.condition, {
                            body: e.condition
                        }));
                        k(n, e.body, r);
                        return xe(mn, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof on)) {
                    e.body = xe(mn, e.body, {
                        body: [ xe(pn, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return B(e, n);
        });
        e(kn, function(e, t) {
            if (t.option("varify") && $(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof Nt || n instanceof Qt) && !n.match_symbol(function(e) {
                    if (e instanceof Jt) {
                        var n = e.definition();
                        return !oe(n) || U(t, n);
                    }
                }, true)) {
                    e.init = V(e.init);
                }
            }
            return e;
        });
        function R(e, n, t) {
            if (!(e instanceof qt)) return;
            if (!(e.left instanceof di)) {
                switch (e.operator) {
                  case "&&":
                    R(e.left, n);
                    R(e.right, n);
                    break;

                  case "||":
                    R(f(e.left), t);
                    R(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof $t)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!Te(i)) return;
            var r;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = a ? t : n;
                break;

              case "!=":
                r = a ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var o = i.definition();
            var s = new Si(function(e) {
                if (e instanceof Tn) {
                    var n = s.parent();
                    if (n instanceof xt && n.expression === e) return;
                    return true;
                }
                if (e instanceof ai && e.definition() === o) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof qt)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(at, function(e, f) {
            if (de(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof on)) {
                var t = e.condition;
                e.condition = le(n, t);
                e.condition = ve(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof on) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    on.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [ xe(pn, e.condition, {
                        body: e.condition
                    }) ];
                    k(f, e.body, i);
                    if (e.alternative) i.push(e.alternative);
                    return xe(mn, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof on)) {
                    on.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [ xe(pn, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) k(f, e.alternative, i);
                    return xe(mn, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var a = e.condition.print_to_string().length;
            var o = r.print_to_string().length;
            var s = o < a;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || xe(cn, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = m(e.body, i, c, l);
            var d = m(e.alternative, i, c, l);
            if (p && d) {
                if (c.length > 0) i.push(xe(mt, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(xe(pn, e.condition, {
                        body: d.length > 0 ? xe(qt, e, {
                            operator: "||",
                            left: e.condition,
                            right: ce(e.alternative, d)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (d.length == 0) {
                    if (a === o && !s && e.condition instanceof qt && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(xe(pn, e, {
                        body: xe(qt, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: ce(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(xe(pn, e, {
                        body: xe(Ft, e, {
                            condition: e.condition,
                            consequent: ce(e.body, p),
                            alternative: ce(e.alternative, d)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return xe(mn, e, {
                    body: i
                }).optimize(f);
            }
            if (de(e.body)) {
                e = xe(at, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof Zn && e.alternative instanceof Zn && e.body.TYPE == e.alternative.TYPE) {
                var h = xe(e.body.CTOR, e, {
                    value: xe(Ft, e, {
                        condition: e.condition,
                        consequent: e.body.value || xe(bi, e.body).transform(f),
                        alternative: e.alternative.value || xe(bi, e.alternative).transform(f)
                    })
                });
                if (h instanceof et) {
                    h.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return h;
            }
            if (e.body instanceof at && !e.body.alternative && !e.alternative) {
                e = xe(at, e, {
                    condition: xe(qt, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (M(e.body)) {
                if (e.alternative) {
                    var v = e.alternative;
                    e.alternative = null;
                    return xe(mn, e, {
                        body: [ e, v ]
                    }).optimize(f);
                }
            }
            if (M(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return xe(mn, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) R(e.condition, e.body, e.alternative);
            return e;
            function m(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof mn) {
                    var r = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof In) {
                            n.push(o);
                        } else if (o instanceof cn) {
                            continue;
                        } else if (o instanceof pn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(o.body);
                        } else if (o instanceof mt) {
                            if (!f.option("sequences") && r.length > 0) return;
                            o.remove_initializers(f, t);
                            o.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof In) {
                    n.push(e);
                    return [];
                }
                if (e instanceof cn) return [];
                if (e instanceof pn) return [ e.body ];
                if (e instanceof mt) {
                    var r = [];
                    e.remove_initializers(f, t);
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    if (!e.value) return;
                    r.push(xe(Mt, e, {
                        operator: "=",
                        left: e.name.convert_symbol(ai, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(ot, function(i, t) {
            if (!t.option("switches")) return i;
            var e;
            var n = i.expression.evaluate(t);
            if (!(n instanceof on)) {
                var r = i.expression;
                i.expression = le(n, r);
                i.expression = ve(i.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return i;
            if (n instanceof on) {
                n = i.expression.evaluate(t, true);
            }
            var a = [];
            var o = [];
            var s;
            var f;
            for (var u = 0, c = i.body.length; u < c && !f; u++) {
                e = i.body[u];
                if (e instanceof ft) {
                    var l = o[o.length - 1];
                    if (s || b(e.body[0], t) && (!l || M(l))) {
                        w(e, l);
                        continue;
                    } else {
                        s = e;
                    }
                } else if (!(n instanceof on)) {
                    var p = e.expression.evaluate(t);
                    if (!(p instanceof on) && p !== n) {
                        w(e, o[o.length - 1]);
                        continue;
                    }
                    if (p instanceof on) p = e.expression.evaluate(t, true);
                    if (p === n) {
                        f = e;
                        if (s) {
                            var d = o.indexOf(s);
                            o.splice(d, 1);
                            w(s, o[d - 1]);
                            s = null;
                        }
                    }
                }
                if (M(e)) {
                    var l = o[o.length - 1];
                    if (M(l) && l.body.length == e.body.length && xe(mn, l, l).equivalent_to(xe(mn, e, e))) {
                        l.body = [];
                    }
                }
                o.push(e);
            }
            while (u < c) w(i.body[u++], o[o.length - 1]);
            while (e = o[o.length - 1]) {
                var h = e.body[e.body.length - 1];
                if (b(h, t)) e.body.pop();
                if (e === s) {
                    if (!x(e)) break;
                } else if (e.expression.has_side_effects(t)) {
                    break;
                } else if (s) {
                    if (!x(s)) break;
                    if (o[o.length - 2] !== s) break;
                    s.body = s.body.concat(e.body);
                    e.body = [];
                } else if (!x(e)) break;
                w(e);
                if (o.pop() === s) s = null;
            }
            if (o.length == 0) {
                return xe(mn, i, {
                    body: a.concat(xe(pn, i.expression, {
                        body: i.expression
                    }))
                }).optimize(t);
            }
            o[0].body = a.concat(o[0].body);
            i.body = o;
            if (t.option("conditionals")) switch (o.length) {
              case 1:
                if (!y(o[0])) break;
                var p = o[0].expression;
                var v = o[0].body.slice();
                if (o[0] !== s && o[0] !== f) return xe(at, i, {
                    condition: xe(qt, i, {
                        operator: "===",
                        left: i.expression,
                        right: p
                    }),
                    body: xe(mn, i, {
                        body: v
                    }),
                    alternative: null
                }).optimize(t);
                if (p) v.unshift(xe(pn, p, {
                    body: p
                }));
                v.unshift(xe(pn, i.expression, {
                    body: i.expression
                }));
                return xe(mn, i, {
                    body: v
                }).optimize(t);

              case 2:
                if (!Re(s, o) || !y(o[1])) break;
                var v = o[0].body.slice();
                var m = v.length && b(v[v.length - 1], t);
                if (m) v.pop();
                if (!nn(v, y)) break;
                var _ = o[1].body.length && xe(mn, o[1], o[1]);
                var g = xe(at, i, {
                    condition: xe(qt, i, o[0] === s ? {
                        operator: "!==",
                        left: i.expression,
                        right: o[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: o[0].expression
                    }),
                    body: xe(mn, o[0], {
                        body: v
                    }),
                    alternative: m && _ || null
                });
                if (!m && _) g = xe(mn, i, {
                    body: [ g, _ ]
                });
                return g.optimize(t);
            }
            return i;
            function b(e, n) {
                return e instanceof it && n.loopcontrol_target(e) === i;
            }
            function y(e) {
                var n = false;
                var t = new Si(function(e) {
                    if (n || e instanceof Dn || e instanceof pn) return true;
                    if (b(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function w(e, n) {
                if (n && !M(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    k(t, e, a);
                }
            }
        });
        e(ct, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (x(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof ri && !ye(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        k(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof mt)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(xe(mn, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(xe(mn, e.bfinally, e.bfinally).optimize(n));
                    }
                    return xe(mn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && x(e.bfinally)) {
                    var t = xe(mn, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return xe(mn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function L(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof Jt) t.push(xe(_t, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        ht.DEFMETHOD("remove_initializers", L(function(e, n) {
            return xe(bi, n).optimize(e);
        }));
        vt.DEFMETHOD("remove_initializers", L(Je));
        mt.DEFMETHOD("remove_initializers", L(Je));
        dt.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, n) {
                var t = n.name.definition();
                if (n.value) {
                    var i = xe(ai, n.name, n.name);
                    e.push(xe(Mt, n, {
                        operator: "=",
                        left: i,
                        right: n.value
                    }));
                    t.references.push(i);
                }
                t.eliminated++;
                t.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return ce(this, e);
        });
        function K(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof ti ? 3 : 2);
        }
        function U(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names()[n.name]) return true;
            }
        }
        function V(e) {
            return xe(mt, e, {
                definitions: e.definitions.map(function(e) {
                    return xe(_t, e, {
                        name: e.name.convert_symbol(Zt, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function G(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return K(t) && oe(t) && !U(e, t);
        }
        function Q(e, n) {
            return n.option("varify") && nn(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof Jt) return !G(n, e);
                }, true);
            }) ? V(e) : e;
        }
        e(ht, Q);
        e(vt, Q);
        function Fe(e, n) {
            var t = e.expression;
            if (!(t instanceof Et)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return ce(e, i);
        }
        function Me(e, t, n) {
            var i = e.expression;
            var r = i instanceof ai ? i.fixed_value() : i;
            if (!(r instanceof Dn)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (n && n.indexOf(r) < 0) return;
            var a = e.args;
            if (!nn(a, function(e) {
                return !(e instanceof Dt);
            })) return;
            var o = r.argnames;
            var s = r === i && !r.name;
            if (r.rest) {
                if (!(s && t.option("rests"))) return;
                var f = o.length;
                a = a.slice(0, f);
                while (a.length < f) a.push(xe(bi, e).optimize(t));
                a.push(xe(Pt, e, {
                    elements: e.args.slice(f)
                }));
                o = o.concat(r.rest);
                r.rest = null;
            } else {
                a = a.slice();
                o = o.slice();
            }
            var u = 0, c = 0;
            var l = s && t.option("default_values");
            var p = s && t.drop_fargs(r, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof Ht) {
                    return e.elements.length == 0 && !e.rest && n instanceof Pt;
                }
                if (e instanceof It) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.__unused;
            } : Ve;
            var d = [];
            for (var h = 0; h < a.length; h++) {
                var v = o[h];
                if (l && v instanceof wt && a[h].is_defined(t)) {
                    o[h] = v = v.name;
                }
                if (!v || "__unused" in v) {
                    var m = a[h].drop_side_effect_free(t);
                    if (p(v)) {
                        if (v) o.splice(h, 1);
                        a.splice(h, 1);
                        if (m) d.push(m);
                        h--;
                        continue;
                    } else if (m) {
                        d.push(m);
                        a[u++] = ce(e, d);
                        d = [];
                    } else if (v) {
                        if (d.length) {
                            a[u++] = ce(e, d);
                            d = [];
                        } else {
                            a[u++] = xe(hi, a[h], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (p(v, a[h])) {
                    var m = a[h].drop_side_effect_free(t);
                    o.splice(h, 1);
                    a.splice(h, 1);
                    if (m) d.push(m);
                    h--;
                    continue;
                } else {
                    d.push(a[h]);
                    a[u++] = ce(e, d);
                    d = [];
                }
                c = u;
            }
            for (;h < o.length; h++) {
                if (p(o[h])) o.splice(h--, 1);
            }
            r.argnames = o;
            a.length = c;
            e.args = a;
            if (!d.length) return;
            var _ = ce(e, d);
            a.push(a.length < o.length ? xe($t, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        e(xt, function(l, u) {
            var o = l.expression;
            if (u.option("sequences")) {
                if (o instanceof St) {
                    var e = Fe(o, u);
                    if (e !== o) {
                        var n = l.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(u);
                    }
                } else if (!pe(u, o.tail_node())) {
                    var e = Fe(l, u);
                    if (e !== l) return e.optimize(u);
                }
            }
            if (u.option("unused")) Me(l, u);
            if (u.option("unsafe")) {
                if (Te(o)) switch (o.name) {
                  case "Array":
                    if (l.args.length == 1) {
                        var t = l.args[0];
                        if (t instanceof hi) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var a = 0; a < i; a++) r[a] = xe(yi, l);
                            return xe(Pt, l, {
                                elements: r
                            });
                        } catch (e) {
                            on.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: l.start.file,
                                line: l.start.line,
                                col: l.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(u) && !t.is_string(u)) break;
                    }
                    return xe(Pt, l, {
                        elements: l.args
                    });

                  case "Object":
                    if (l.args.length == 0) return xe(Bt, l, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (l.args.length == 0) return xe(di, l, {
                        value: ""
                    });
                    if (l.args.length == 1) return xe(qt, l, {
                        operator: "+",
                        left: xe(di, l, {
                            value: ""
                        }),
                        right: l.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (l.args.length == 0) return xe(hi, l, {
                        value: 0
                    });
                    if (l.args.length == 1) return xe($t, l, {
                        operator: "+",
                        expression: xe(qt, l, {
                            operator: "+",
                            left: xe(di, l, {
                                value: ""
                            }),
                            right: l.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (l.args.length == 0) return xe(ki, l).optimize(u);
                    if (l.args.length == 1) return xe($t, l, {
                        operator: "!",
                        expression: xe($t, l, {
                            operator: "!",
                            expression: l.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var s = [];
                    if (nn(l.args, function(e) {
                        var n = e.evaluate(u);
                        s.unshift(n);
                        return e !== n;
                    })) try {
                        return me(u, l, xe(mi, l, {
                            value: RegExp.apply(RegExp, s)
                        }));
                    } catch (e) {
                        on.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: l,
                            file: l.start.file,
                            line: l.start.line,
                            col: l.start.col
                        });
                    }
                    break;
                } else if (o instanceof Tt) switch (o.property) {
                  case "toString":
                    var f = o.expression;
                    if (l.args.length == 0 && !(f.may_throw_on_access(u) || f instanceof fi)) {
                        return xe(qt, l, {
                            operator: "+",
                            left: xe(di, l, {
                                value: ""
                            }),
                            right: f
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof Pt && l.args.length < 2) e: {
                        var c = l.args[0];
                        if (o.expression.elements.length == 0 && !(c instanceof Dt)) {
                            return c ? ce(l, [ c, xe(di, l, {
                                value: ""
                            }) ]).optimize(u) : xe(di, l, {
                                value: ""
                            });
                        }
                        if (c) {
                            c = c.evaluate(u);
                            if (c instanceof on) break e;
                        }
                        var r = [];
                        var p = [];
                        for (var a = 0; a < o.expression.elements.length; a++) {
                            var d = o.expression.elements[a];
                            var h = d.evaluate(u);
                            if (h !== d) {
                                p.push(h);
                            } else if (d instanceof Dt) {
                                break e;
                            } else {
                                if (p.length > 0) {
                                    r.push(xe(di, l, {
                                        value: p.join(c)
                                    }));
                                    p.length = 0;
                                }
                                r.push(d);
                            }
                        }
                        if (p.length > 0) r.push(xe(di, l, {
                            value: p.join(c)
                        }));
                        if (r.length == 1) {
                            if (r[0].is_string(u)) return r[0];
                            return xe(qt, r[0], {
                                operator: "+",
                                left: xe(di, l, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (c == "") {
                            var t;
                            if (r[0].is_string(u) || r[1].is_string(u)) {
                                t = r.shift();
                            } else {
                                t = xe(di, l, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return xe(qt, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(u);
                        }
                        var v = l.clone();
                        v.expression = v.expression.clone();
                        v.expression.expression = v.expression.expression.clone();
                        v.expression.expression.elements = r;
                        return me(u, l, v);
                    }
                    break;

                  case "charAt":
                    if (l.args.length < 2) {
                        var v = xe(qt, l, {
                            operator: "||",
                            left: xe(At, l, {
                                expression: o.expression,
                                property: l.args.length ? xe(qt, l.args[0], {
                                    operator: "|",
                                    left: xe(hi, l, {
                                        value: 0
                                    }),
                                    right: l.args[0]
                                }) : xe(hi, l, {
                                    value: 0
                                })
                            }).optimize(u),
                            right: xe(di, l, {
                                value: ""
                            })
                        });
                        v.is_string = Ge;
                        return v.optimize(u);
                    }
                    break;

                  case "apply":
                    if (l.args.length == 2 && l.args[1] instanceof Pt) {
                        var m = l.args[1].elements.slice();
                        m.unshift(l.args[0]);
                        return xe(xt, l, {
                            expression: xe(Tt, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: m
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var _ = o.expression;
                    if (_ instanceof ai) {
                        _ = _.fixed_value();
                    }
                    if (_ instanceof Dn && !_.contains_this()) {
                        return (l.args.length ? ce(this, [ l.args[0], xe(xt, l, {
                            expression: o.expression,
                            args: l.args.slice(1)
                        }) ]) : xe(xt, l, {
                            expression: o.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && Te(o) && o.name == "Function") {
                if (l.args.length == 0) return xe(Hn, l, {
                    argnames: [],
                    body: []
                }).init_vars(o.scope);
                if (nn(l.args, function(e) {
                    return e instanceof di;
                })) {
                    try {
                        var g = "n(function(" + l.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + l.args[l.args.length - 1].value + "})";
                        var b = qi(g);
                        var y = {
                            ie8: u.option("ie8")
                        };
                        b.figure_out_scope(y);
                        var w = new Ci(u.options);
                        b = b.transform(w);
                        b.figure_out_scope(y);
                        b.compute_char_frequency(y);
                        b.mangle_names(y);
                        var x;
                        b.walk(new Si(function(e) {
                            if (x) return true;
                            if (e instanceof Dn) {
                                x = e;
                                return true;
                            }
                        }));
                        var g = ji();
                        mn.prototype._codegen.call(x, g);
                        l.args = [ xe(di, l, {
                            value: x.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), xe(di, l.args[l.args.length - 1], {
                            value: g.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return l;
                    } catch (e) {
                        if (e instanceof Oi) {
                            on.warn("Error parsing code passed to new Function [{file}:{line},{col}]", l.args[l.args.length - 1].start);
                            on.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var k = o instanceof ai ? o.fixed_value() : o;
            var E = u.parent(), S = u.self();
            var T = k instanceof Dn && (!qn(k) || u.option("awaits") && E instanceof Ct) && (!Fn(k) || u.option("yields") && S instanceof jt && S.nested);
            var A = T && k.first_statement();
            var D = 0, O = false;
            var $ = !nn(l.args, function(e) {
                return !(e instanceof Dt);
            });
            var z = T && nn(k.argnames, function(e, n) {
                if (D == 1 && l.args[n] instanceof Dt) D = 2;
                if (e instanceof wt) {
                    if (!D) D = 1;
                    var t = D == 1 && l.args[n];
                    if (t && !Ae(t)) D = 2;
                    if (R(e.value)) return false;
                    e = e.name;
                }
                if (e instanceof Nt) {
                    O = true;
                    if (R(e)) return false;
                }
                return true;
            }) && !(k.rest instanceof Nt && R(k.rest));
            var q = z && u.option("inline") && !l.is_expr_pure(u);
            if (q && A instanceof et) {
                var h = A.value;
                if (o === k && !k.name && (!h || h.is_constant_expression()) && G(k)) {
                    return ce(l, U(h)).optimize(u);
                }
            }
            if (T) {
                var F, h, M = false;
                if (q && !k.uses_arguments && !k.pinned() && !(k.name && k instanceof $n) && (o === k || !je(u, F = o.definition()) && k.is_constant_expression(fe(u))) && !$ && (h = J(A)) && !k.contains_this()) {
                    var C = o === k || F.single_use && F.references.length - F.replaced == 1;
                    if (K()) {
                        var m = l.args.slice();
                        var j = [];
                        m.push(h.clone(true).transform(new Ti(function(e) {
                            if (e instanceof ai) {
                                var n = e.definition();
                                if (k.variables.get(e.name) !== n) {
                                    j.push(e);
                                    return e;
                                }
                                var t = X(n);
                                var i = m[t];
                                if (!i) return xe(bi, l);
                                m[t] = null;
                                var r = this.parent();
                                return r ? ke(u, r, e, i) : i;
                            }
                        })));
                        var P = k.inlined;
                        if (o !== k) k.inlined = true;
                        var v = ce(l, m.filter(function(e) {
                            return e;
                        })).optimize(u);
                        k.inlined = P;
                        v = ke(u, E, S, v);
                        if (C || ve(v, l) === v) {
                            j.forEach(function(e) {
                                e.scope = o === k ? k.parent_scope : o.scope;
                                e.reference();
                                if (C) {
                                    e.definition().replaced++;
                                } else {
                                    e.definition().single_use = false;
                                }
                            });
                            return v;
                        } else if (!v.has_side_effects(u)) {
                            l.drop_side_effect_free = Je;
                        }
                    }
                    var N, H, Y, I;
                    if (C && ne()) {
                        k._squeezed = true;
                        if (o !== k) k.parent_scope = o.scope;
                        var v = ce(l, se()).optimize(u);
                        return ke(u, E, S, v);
                    }
                }
                if (u.option("side_effects") && z && nn(k.body, de) && (k === o ? qe(k, u) : !D && !O && !k.rest) && !(zn(k) && k.value) && G(k)) {
                    return ce(l, U()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (o instanceof St) {
                    var B = o.expression;
                    while (B.expression) {
                        B = B.expression;
                    }
                    if (Te(B) && B.name == "console") {
                        return xe(bi, l).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && E instanceof pn && he(S)) {
                return l.negate(u, true);
            }
            return Oe(u, l);
            function R(e) {
                var n = false;
                e.walk(new Si(function(e) {
                    if (n) return true;
                    if (e instanceof ai && k.variables.get(e.name) === e.definition()) {
                        return n = true;
                    }
                }));
                return n;
            }
            function L(e) {
                return xe(Tt, e, {
                    expression: xe(Pt, e, {
                        elements: []
                    }),
                    property: "e"
                });
            }
            function U(e) {
                var n = l.args.slice();
                var t = D > 1 || O || k.rest;
                if (t || $) n = [ xe(Pt, l, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Ti(function(i, e) {
                        if (i instanceof wt) return xe(wt, i, {
                            name: i.name.transform(o) || L(i),
                            value: i.value
                        });
                        if (i instanceof Ht) {
                            var t = [];
                            i.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            $e(i, t);
                            return xe(Ht, i, {
                                elements: t
                            });
                        }
                        if (i instanceof It) {
                            var r = [], a = [];
                            i.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    a.push(n instanceof on ? n : le(n, e));
                                    r.push(xe(Yt, e, {
                                        key: ce(i, a),
                                        value: t
                                    }));
                                    a = [];
                                } else if (n instanceof on) {
                                    a.push(n);
                                }
                            });
                            if (a.length) r.push(xe(Yt, i, {
                                key: ce(i, a),
                                value: L(i)
                            }));
                            return xe(It, i, {
                                properties: r
                            });
                        }
                        if (i instanceof ei) return null;
                    });
                    var i = [];
                    k.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) i[n] = e;
                    });
                    var r = k.rest && k.rest.transform(o);
                    if (r) i.length = k.argnames.length;
                    $e(k, i);
                    n[0] = xe(Mt, l, {
                        operator: "=",
                        left: xe(Ht, k, {
                            elements: i,
                            rest: r
                        }),
                        right: n[0]
                    });
                } else k.argnames.forEach(function(e) {
                    if (e instanceof wt) n.push(e.value);
                });
                n.push(e || xe(bi, l));
                return n;
            }
            function V() {
                var e = [];
                var n = I || u.find_parent(Tn);
                if (qn(n)) e.push("await");
                if (Fn(n)) e.push("yield");
                return e.length && en(e);
            }
            function G(e) {
                var t = V();
                if (!t) return true;
                var i = true;
                var r = new Si(function(e) {
                    if (!i) return true;
                    if (e instanceof Tn) {
                        if (e === k) return;
                        if (zn(e)) {
                            for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(r);
                        } else if (e instanceof In && t[e.name.name]) {
                            i = false;
                        }
                        return true;
                    }
                    if (e instanceof Wt && t[e.name] && e !== k.name) i = false;
                });
                e.walk(r);
                return i;
            }
            function W(e) {
                if (!e) return xe(bi, l);
                if (e instanceof et) return e.value || xe(bi, l);
                if (e instanceof pn) return xe($t, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function J(e) {
                var n = k.body.length;
                if (n < 2) {
                    e = W(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = k.body[t];
                    if (i instanceof mt) {
                        var r = M || !nn(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            M = true;
                            if (e) return false;
                        }
                    } else if (i instanceof Bn || i instanceof Ln || i instanceof cn) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return W(e);
            }
            function X(e) {
                for (var n = k.argnames.length; --n >= 0; ) {
                    if (k.argnames[n].definition() === e) return n;
                }
            }
            function K() {
                if (D || O || M || k.rest) return;
                if (u.option("inline") < 2 && k.argnames.length) return;
                if (!k.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof ei;
                })) return;
                var r = false;
                var a = V();
                var o;
                var s = [];
                var f = false;
                h.walk(new Si(function(e, n) {
                    if (r) return true;
                    if (e instanceof qt && De[e.operator] || e instanceof Ft) {
                        s = null;
                        return;
                    }
                    if (e instanceof Tn) return r = true;
                    if (a && e instanceof Wt && a[e.name]) return r = true;
                    if (e instanceof ai) {
                        var t = e.definition();
                        if (k.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof In) return r = true;
                        if (Mi(e, this.parent())) return r = true;
                        var i = X(t);
                        if (!(o < i)) o = i;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(k.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        f = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = l.args.length;
                if (s && k.argnames.length >= e) {
                    e = k.argnames.length;
                    while (e-- > o && k.argnames[e] === s.pop()) ;
                    e++;
                }
                var n = f && !s && u.find_parent(Tn);
                return e <= o || nn(l.args.slice(o, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function Q(e, n) {
                return e[n] || ue[n] || I.var_names()[n];
            }
            function Z(n, t, i) {
                var r = false;
                k.each_argname(function(e) {
                    if (r) return;
                    if (e.__unused) return;
                    if (e instanceof wt) e = e.name;
                    if (!i || Q(n, e.name)) return r = true;
                    t[e.name] = true;
                    if (Y) Y.push(e.definition());
                });
                return !r;
            }
            function ee(n, e, t) {
                for (var i = 0; i < k.body.length; i++) {
                    var r = k.body[i];
                    if (r instanceof In) {
                        if (!t || Q(e, r.name.name)) return false;
                        if (!nn(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        if (Y) Y.push(r.name.definition());
                        continue;
                    }
                    if (!(r instanceof mt)) continue;
                    if (!t) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var o = r.definitions[a].name;
                        if (Q(n, o.name)) return false;
                        if (Y) Y.push(o.definition());
                    }
                }
                return true;
            }
            function ne() {
                var n = Object.create(null);
                var e = 0, t;
                I = S;
                do {
                    if (I.variables) I.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    t = I;
                    I = u.parent(e++);
                    if (I instanceof bn) {
                        Y = [];
                    } else if (I instanceof xn) {
                        if (I.init === t) continue;
                        Y = [];
                    } else if (I instanceof kn) {
                        if (I.init === t) continue;
                        if (I.object === t) continue;
                        Y = [];
                    } else if (I instanceof ai) {
                        if (I.fixed_value() instanceof Tn) return false;
                    }
                } while (!(I instanceof Tn));
                H = I.body.indexOf(t) + 1;
                if (!H) return false;
                if (!G(k)) return false;
                var i = o !== k || k.parent_scope.resolve() === I;
                if (I instanceof An) {
                    if (u.toplevel.vars) {
                        n["arguments"] = true;
                    } else {
                        i = false;
                    }
                }
                var r = u.option("inline");
                N = Object.create(n);
                if (!Z(n, N, r >= 2 && i)) return false;
                var a = Object.create(N);
                if (!ee(n, a, r >= 3 && i)) return false;
                return !Y || Y.length == 0 || !Ne(k, Y);
            }
            function te(e, n, t, i) {
                var r = t.definition();
                I.variables.set(t.name, r);
                I.enclosed.push(r);
                if (!I.var_names()[t.name]) {
                    I.var_names()[t.name] = true;
                    e.push(xe(_t, t, {
                        name: t,
                        value: null
                    }));
                }
                if (!i) return;
                var a = xe(ai, t, t);
                r.references.push(a);
                n.push(xe(Mt, l, {
                    operator: "=",
                    left: a,
                    right: i
                }));
            }
            function ie(e, n) {
                var t = k.argnames.length;
                for (var i = l.args.length; --i >= t; ) {
                    n.push(l.args[i]);
                }
                var r = [];
                for (i = t; --i >= 0; ) {
                    var a = k.argnames[i];
                    var o;
                    if (a instanceof wt) {
                        r.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = l.args[i];
                    if (o.__unused || I.var_names()[o.name]) {
                        if (s) n.push(s);
                    } else {
                        var f = xe(Zt, o, o);
                        o.definition().orig.push(f);
                        if ("__unused" in o) {
                            te(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && Y && a === o) s = xe(bi, l);
                            te(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (i = r.length; --i >= 0; ) {
                    var u = r[i];
                    if ("__unused" in u.name) {
                        n.push(u.value);
                    } else {
                        var c = xe(ai, u.name, u.name);
                        u.name.definition().references.push(c);
                        n.push(xe(Mt, u, {
                            operator: "=",
                            left: c,
                            right: u.value
                        }));
                    }
                }
            }
            function re(i, r) {
                r.push(xe(Mt, l, {
                    operator: "=",
                    left: xe(Ht, l, {
                        elements: k.argnames.map(function(e) {
                            return e.convert_symbol(ai, n);
                        }),
                        rest: k.rest && k.rest.convert_symbol(ai, n)
                    }),
                    right: xe(Pt, l, {
                        elements: l.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = xe(Zt, n, n);
                    n.definition().orig.push(t);
                    te(i, r, t);
                }
            }
            function ae(e) {
                var n = e.definition().redefined();
                if (n) {
                    e = e.clone();
                    e.thedef = n;
                }
                return e;
            }
            function oe(e, n) {
                var t = [ H, 0 ];
                var i = [], r = [], a = [];
                for (var o = 0; o < k.body.length; o++) {
                    var s = k.body[o];
                    if (s instanceof In) {
                        if (Y) {
                            var f = xe(Zt, s.name, ae(s.name));
                            f.definition().orig.push(f);
                            te(e, n, f, ze(s, true));
                        } else {
                            var u = s.name.definition();
                            I.functions.set(u.name, u);
                            I.variables.set(u.name, u);
                            I.enclosed.push(u);
                            I.var_names()[u.name] = true;
                            t.push(s);
                        }
                        continue;
                    }
                    if (!(s instanceof mt)) continue;
                    for (var c = 0; c < s.definitions.length; c++) {
                        var l = s.definitions[c];
                        var f = ae(l.name);
                        te(i, r, f, l.value);
                        if (Y && !rn(N, f.name)) {
                            var u = k.variables.get(f.name);
                            var p = xe(ai, f, f);
                            u.references.push(p);
                            a.push(xe(Mt, l, {
                                operator: "=",
                                left: p,
                                right: xe(bi, f)
                            }));
                        }
                    }
                }
                [].push.apply(e, i);
                [].push.apply(n, a);
                [].push.apply(n, r);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (D > 1 || O || k.rest) {
                    re(e, n);
                } else {
                    ie(e, n);
                }
                var t = oe(e, n);
                n.push(h);
                if (e.length) t.push(xe(mt, k, {
                    definitions: e
                }));
                [].splice.apply(I.body, t);
                k.enclosed.forEach(function(e) {
                    if (I.var_names()[e.name]) return;
                    I.enclosed.push(e);
                    I.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(kt, function(e, n) {
            if (n.option("sequences")) {
                var t = Fe(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unused")) Me(e, n);
            if (n.option("unsafe")) {
                var i = e.expression;
                if (Te(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return xe(xt, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function Z(t, i, e, n) {
            if (!(n instanceof qt)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof Mt)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof ai)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? xe(Ft, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : xe(Ft, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Si(function(e) {
                    if (n) return true;
                    if (e instanceof ai && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(Et, function(e, a) {
            var r = n();
            var o = r.length - 1;
            i();
            t();
            if (o == 0) {
                e = ke(a, a.parent(), a.self(), r[0]);
                if (!(e instanceof Et)) e = e.optimize(a);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var i = an(a);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(a, i);
                    if (e) {
                        b(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (o > 0 && Ae(r[o], a)) o--;
                if (o < r.length - 1) {
                    r[o] = xe($t, e, {
                        operator: "void",
                        expression: r[o]
                    });
                    r.length = o + 1;
                }
            }
            function i() {
                if (!a.option("conditionals")) return;
                for (var e = 1; e < o; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof Mt)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof ai)) continue;
                    var t = n.left.definition();
                    var i = Z(a, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    o--;
                }
            }
        });
        e(zt, function(e, n) {
            if (n.option("sequences")) {
                var t = Fe(e, n);
                if (t !== e) return t.optimize(n);
            }
            return Oe(n, e);
        });
        var ee = en("+ -");
        var ne = en("* / %");
        e($t, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !o(i)) {
                return ce(e, [ i, xe(Ei, e) ]).optimize(n);
            }
            if (n.option("sequences") && s()) {
                var r = Fe(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return xe(bi, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return ce(e, [ i, xe(ki, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof $t && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof qt) {
                        e = me(n, e, i.negate(n, an(n)));
                    }
                    break;

                  case "typeof":
                    on.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    var a = [ xe(Ei, e) ];
                    if (!(i instanceof ai && ye(i, n))) a.unshift(i);
                    return ce(e, a).optimize(n);
                }
            }
            if (t == "-" && i instanceof wi) i = i.transform(n);
            if (n.option("evaluate") && i instanceof qt && ee[t] && ne[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return xe(qt, e, {
                    operator: i.operator,
                    left: xe($t, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof hi || i instanceof wi) ? e : Oe(n, e);
            function o(e) {
                return e instanceof wi || e instanceof gi || e instanceof ci || e instanceof St || e instanceof ai || e instanceof bi;
            }
            function s() {
                switch (t) {
                  case "delete":
                    return !o(i.tail_node());

                  case "typeof":
                    return !Te(i.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(Ct, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = Fe(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var i = e.expression;
                if (i instanceof Ct) return i;
                if (i instanceof $t) {
                    if (i.expression instanceof Ct) return i;
                    if (i.operator == "void") return xe($t, e, {
                        operator: "void",
                        expression: xe(Ct, e, {
                            expression: i.expression
                        })
                    });
                }
            }
            return e;
        });
        e(jt, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = Fe(e, n);
                if (t !== e) return t.optimize(n);
            }
            var i = e.expression;
            if (e.nested && i.TYPE == "Call") {
                var r = i.clone().optimize(n);
                if (r.TYPE != "Call") return r;
            }
            return e;
        });
        qt.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof St) {
                if (!(this.left.expression instanceof Et)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return ce(this, n);
            }
            if (this.left instanceof Et) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return ce(this, n);
            }
            if (this.right instanceof Et) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof ai;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var a = 0; a < r; a++) {
                    if (!i && n[a].has_side_effects(e)) break;
                }
                if (a == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return ce(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = ce(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return ce(this, n);
                }
            }
            return this;
        });
        var te = en("indexOf lastIndexOf");
        var ie = en("== === != !== * & | ^");
        function Ce(e) {
            if (e instanceof Mt) return e.operator == "=" && Ce(e.right);
            if (e instanceof Et) return Ce(e.tail_node());
            if (e instanceof ai) return Ce(e.fixed_value());
            return e instanceof Pt || e instanceof Vn || e instanceof Dn || e instanceof kt || e instanceof Bt;
        }
        function re(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof Mt) return n.operator != "=" || re(e, n.right);
            if (n instanceof qt) {
                return !De[n.operator] || re(e, n.left) && re(e, n.right);
            }
            if (n instanceof Ft) {
                return re(e, n.consequent) && re(e, n.alternative);
            }
            if (n instanceof Et) return re(e, n.tail_node());
            if (n instanceof ai) {
                var t = n.fixed_value();
                return t && re(e, t);
            }
            if (n instanceof li) return !n.tag || Pe(e, n.tag);
            if (n instanceof Ot) return true;
        }
        function ae(e, n) {
            if (n instanceof Tt) return ae(e, n.expression);
            if (n instanceof At) {
                return ae(e, n.expression) && ae(e, n.property);
            }
            if (n instanceof Wt) return true;
            return !n.has_side_effects(e);
        }
        e(qt, function(i, o) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(o) && !i.right.has_side_effects(o);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = xe(qt, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(o);
            }
            if (ie[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof qt && zi[i.left.operator] >= zi[i.operator])) {
                e();
            }
            if (o.option("sequences")) {
                var r = i.lift_sequences(o);
                if (r !== i) return r.optimize(o);
            }
            if (o.option("assignments") && De[i.operator]) {
                var a = i.right;
                if (i.left instanceof ai && a instanceof Mt && a.operator == "=" && i.left.equivalent_to(a.left)) {
                    i.right = a.right;
                    a.right = i;
                    return a;
                }
            }
            if (o.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if (Ae(i.left, o) && i.right.is_defined(o)) {
                    on.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return ce(i, [ i.right, xe(i.operator == "===" ? ki : Ei, i) ]).optimize(o);
                }
                var s = true;
                if (i.left.is_string(o) && i.right.is_string(o) || i.left.is_number(o) && i.right.is_number(o) || i.left.is_boolean(o) && i.right.is_boolean(o) || ae(o, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && Ae(i.left, o)) {
                    i.left = xe(_i, i.left);
                } else if (o.option("typeofs") && i.left instanceof di && i.left.value == "undefined" && i.right instanceof $t && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof ai ? f.is_declared(o) : !(f instanceof St && o.option("ie8"))) {
                        i.right = f;
                        i.left = xe(bi, i.left).optimize(o);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof ai && i.right instanceof ai && i.left.definition() === i.right.definition() && Ce(i.left)) {
                    return xe(i.operator[0] == "=" ? Ei : ki, i).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof qt && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof qt && u.operator == i.right.operator && (Ae(u.left, o) && i.right.left instanceof _i || u.left instanceof _i && Ae(i.right.left, o)) && !u.right.has_side_effects(o) && u.right.equivalent_to(i.right.right)) {
                    var c = xe(qt, i, {
                        operator: u.operator.slice(0, -1),
                        left: xe(_i, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = xe(qt, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = o.option("booleans") && o.in_boolean_context();
            if (l) switch (i.operator) {
              case "+":
                var p = i.left.evaluate(o);
                var d = i.right.evaluate(o);
                if (p && typeof p == "string") {
                    on.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return ce(i, [ i.right, xe(Ei, i) ]).optimize(o);
                }
                if (d && typeof d == "string") {
                    on.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return ce(i, [ i.left, xe(Ei, i) ]).optimize(o);
                }
                break;

              case "==":
                if (i.left instanceof di && i.left.value == "" && i.right.is_string(o)) {
                    return xe($t, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (i.left instanceof di && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                break;
            }
            var h = o.parent();
            if (o.option("comparisons") && i.is_boolean(o)) {
                if (!(h instanceof qt) || h instanceof Mt) {
                    var v = me(o, i, xe($t, i, {
                        operator: "!",
                        expression: i.negate(o, an(o))
                    }));
                    if (v !== i) return v;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (o.option("conditionals") && De[i.operator] && i.right instanceof qt && i.operator == i.right.operator) {
                n();
            }
            if (o.option("strings") && i.operator == "+") {
                if (i.right instanceof di && i.right.value == "" && i.left.is_string(o)) {
                    return i.left.optimize(o);
                }
                if (i.left instanceof di && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                if (i.left instanceof qt && i.left.operator == "+" && i.left.left instanceof di && i.left.left.value == "" && i.right.is_string(o)) {
                    i.left = i.left.right;
                    return i.optimize(o);
                }
                if (i.right instanceof qt && i.operator == i.right.operator && (i.left.is_string(o) && i.right.is_string(o) || i.right.left.is_string(o) && (i.left.is_constant() || !i.right.right.has_side_effects(o)))) {
                    n();
                }
            }
            if (o.option("evaluate")) {
                var m = true;
                switch (i.operator) {
                  case "&&":
                    var p = D(i.left);
                    if (!p) {
                        on.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return ke(o, h, o.self(), i.left).optimize(o);
                    } else if (!(p instanceof on)) {
                        on.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return ce(i, [ i.left, i.right ]).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l) {
                            on.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return ce(i, [ i.left, xe(ki, i) ]).optimize(o);
                        } else i.falsy = true;
                    } else if (!(d instanceof on)) {
                        if (l || h.operator == "&&" && h.left === o.self()) {
                            on.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    }
                    if (i.left.operator == "||") {
                        var _ = i.left.right.evaluate(o, true);
                        if (!_) return xe(Ft, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(o);
                    }
                    break;

                  case "??":
                    var g = true;

                  case "||":
                    var p = D(i.left, g);
                    if (g ? p == null : !p) {
                        on.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: i.operator,
                            value: g ? "nulish" : "false",
                            file: i.start.file,
                            line: i.start.line,
                            col: i.start.col
                        });
                        return ce(i, [ i.left, i.right ]).optimize(o);
                    } else if (!(p instanceof on)) {
                        on.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: i.operator,
                            value: g ? "defined" : "true",
                            file: i.start.file,
                            line: i.start.line,
                            col: i.start.col
                        });
                        return ke(o, h, o.self(), i.left).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l || h.operator == "||" && h.left === o.self()) {
                            on.warn("Dropping side-effect-free {operator} [{file}:{line},{col}]", {
                                operator: i.operator,
                                file: i.start.file,
                                line: i.start.line,
                                col: i.start.col
                            });
                            return i.left.optimize(o);
                        }
                    } else if (!g && !(d instanceof on)) {
                        if (l) {
                            on.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return ce(i, [ i.left, xe(Ei, i) ]).optimize(o);
                        } else i.truthy = true;
                    }
                    if (!g && i.left.operator == "&&") {
                        var _ = i.left.right.is_truthy() || i.left.right.evaluate(o, true);
                        if (_ && !(_ instanceof on)) return xe(Ft, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (i.left instanceof pi && i.right instanceof qt && i.right.operator == "+" && i.right.left instanceof pi && i.right.is_string(o)) {
                        i = xe(qt, i, {
                            operator: "+",
                            left: xe(di, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof pi && i.left instanceof qt && i.left.operator == "+" && i.left.right instanceof pi && i.left.is_string(o)) {
                        i = xe(qt, i, {
                            operator: "+",
                            left: i.left.left,
                            right: xe(di, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof $t && i.right.operator == "-" && i.left.is_number(o)) {
                        i = xe(qt, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof $t && i.left.operator == "-" && t() && i.right.is_number(o)) {
                        i = xe(qt, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && i.left instanceof qt && zi[i.left.operator] == zi[i.operator] && i.right.is_constant() && (i.right.is_boolean(o) || i.right.is_number(o)) && i.left.is_number(o) && !i.left.right.is_constant() && (i.left.left.is_boolean(o) || i.left.left.is_number(o))) {
                        i = xe(qt, i, {
                            operator: i.left.operator,
                            left: xe(qt, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof $t && i.right.operator == "-" && i.left.is_number(o) && i.right.expression.is_number(o)) {
                        i = xe(qt, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    m = o.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof $t && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(o) || i.left.is_number(o)) && (i.right.is_boolean(o) || i.right.is_number(o)) && t() && !(i.left instanceof qt && i.left.operator != i.operator && zi[i.left.operator] >= zi[i.operator])) {
                        var b = xe(qt, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof pi && !(i.left instanceof pi)) {
                            i = me(o, b, i);
                        } else {
                            i = me(o, i, b);
                        }
                    }
                    if (!m || !i.is_number(o)) break;
                    if (i.right instanceof qt && i.right.operator != "%" && zi[i.right.operator] == zi[i.operator] && i.right.is_number(o) && (i.operator != "+" || i.right.left.is_boolean(o) || i.right.left.is_number(o)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(o)) && !S(i.right.right)) {
                        i = xe(qt, i, {
                            operator: T(i.operator, i.right.operator),
                            left: xe(qt, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(o) && !i.right.is_number(o)) {
                            i.right = xe($t, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof pi && i.left instanceof qt && i.left.operator != "%" && zi[i.left.operator] == zi[i.operator] && i.left.is_number(o)) {
                        if (i.left.left instanceof pi) {
                            var u = A(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = A(i, i.left.operator, Oe(o, u), i.left.right);
                        } else if (i.left.right instanceof pi) {
                            var y = T(i.left.operator, i.operator);
                            var w = Oe(o, A(i.left, y, i.left.right, i.right));
                            if (w.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +w.value == 0 && i.left.left.is_negative_zero())) {
                                i = A(i, i.left.operator, i.left.left, w);
                            }
                        }
                    }
                    break;
                }
                if (!(h instanceof $t && h.operator == "delete")) {
                    if (i.left instanceof hi && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(o)) return xe($t, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                            if (i.right.is_number(o) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(o) ? i.right : xe($t, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (i.right instanceof hi && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(o)) return xe($t, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                            if (i.left.is_number(o) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(o) ? i.left : xe($t, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(o) ? i.left : xe($t, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (i.operator) {
              case "&&":
                R(i.left, i.right, null);
                break;

              case "||":
                R(i.left, null, i.right);
                break;
            }
            if (o.option("unsafe")) {
                var x = O(i.right);
                if (l && x && (i.operator == "==" || i.operator == "!=") && i.left instanceof hi && i.left.value == 0) {
                    return (i.operator == "==" ? xe($t, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(o);
                }
                var k = O(i.left);
                if (o.option("comparisons") && $()) {
                    var E = xe($t, i, {
                        operator: "!",
                        expression: xe($t, i, {
                            operator: "~",
                            expression: k ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (k) break;

                      case "<=":
                      case "!=":
                        E = xe($t, i, {
                            operator: "!",
                            expression: E
                        });
                        break;
                    }
                    return E.optimize(o);
                }
            }
            return Oe(o, i);
            function S(e) {
                var n = false;
                e.walk(new Si(function(e) {
                    if (n) return true;
                    if (e instanceof Mt) {
                        if (e.left instanceof St) return n = true;
                    } else if (e instanceof Ot) {
                        if (Fi[e.operator] && e.expression instanceof St) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function T(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function A(e, n, t, i, r, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = xe($t, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(o) && !i.is_number(o)) {
                        i = xe($t, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return xe(qt, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: a
                });
            }
            function D(e, n) {
                if (e.truthy) return true;
                if (e.falsy && !n) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(o, true);
            }
            function O(e) {
                return e.TYPE == "Call" && e.expression instanceof Tt && te[e.expression.property];
            }
            function $() {
                switch (i.operator) {
                  case "<=":
                    return x && i.left instanceof hi && i.left.value == 0;

                  case "<":
                    if (k && i.right instanceof hi && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!x) return false;
                    return i.left instanceof hi && i.left.value == -1 || i.left instanceof $t && i.left.operator == "-" && i.left.expression instanceof hi && i.left.expression.value == 1;
                }
            }
        });
        e(oi, function(e) {
            return e;
        });
        function je(e, n) {
            var t = 0, i = e.self();
            do {
                if (A(i) && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(t++));
        }
        function oe(e) {
            var n = e.scope.resolve();
            return nn(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(ai, function(e, n) {
            if (!n.option("ie8") && Te(e) && !(e.scope.resolve().uses_with && n.find_parent(Sn))) {
                switch (e.name) {
                  case "undefined":
                    return xe(bi, e).optimize(n);

                  case "NaN":
                    return xe(gi, e).optimize(n);

                  case "Infinity":
                    return xe(wi, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && Mi(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var a = i.single_use && !(t instanceof xt && t.is_expr_pure(n));
                if (a) {
                    if (A(r)) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            a = false;
                        } else if (je(n, i)) {
                            a = false;
                        } else if (r.name && r.name.definition() !== i) {
                            a = false;
                        } else if (r.parent_scope !== e.scope || be(i)) {
                            a = r.is_constant_expression(e.scope);
                            if (a == "f") {
                                var o = e.scope;
                                do {
                                    if (o instanceof In || o instanceof $n) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (r.name && (r.name.name == "await" && qn(r) || r.name.name == "yield" && Fn(r))) {
                            a = false;
                        } else if (r.has_side_effects(n)) {
                            a = false;
                        } else if (n.option("ie8") && r instanceof Vn) {
                            a = false;
                        }
                        if (a) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression() || r.drop_side_effect_free(n)) {
                        a = false;
                    }
                }
                if (a) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof Gn) r = X(r);
                    if (r instanceof In) r = ze(r);
                    if (A(r)) {
                        var o = e.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (o.var_names()[e.name]) return;
                            o.enclosed.push(e);
                            o.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        var l, p;
                        if (s instanceof Vn) {
                            l = "def_function";
                            p = ii;
                        } else {
                            l = "def_variable";
                            p = ti;
                        }
                        if (!(c instanceof p)) {
                            c = xe(p, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s[l](c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new Si(function(e) {
                            if (!(e instanceof ai)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!A(t)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s[l](t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        if (r instanceof Tn) {
                            n.push(r);
                            s = r.optimize(n);
                            n.pop();
                        } else {
                            s = r.optimize(n);
                        }
                        s = s.transform(new Ti(function(e, n) {
                            if (e instanceof Tn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var d = e.fixed !== i.fixed;
                if (r && (d || i.should_replace !== false)) {
                    var h;
                    if (r instanceof ui) {
                        if (!be(i) && oe(i)) {
                            h = r;
                        }
                    } else {
                        var v = r.evaluate(n, true);
                        if (v !== r && typeof v != "function" && (typeof v != "object" || v instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && oe(i))) {
                            h = le(v, r);
                        }
                    }
                    if (h) {
                        if (!d && i.should_replace === undefined) {
                            var m = h.optimize(n).print_to_string().length;
                            if (!y(r)) {
                                m = Math.min(m, r.print_to_string().length);
                            }
                            var _ = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var g = i.references.length - i.replaced;
                                _ += (_ + 2 + m) / (g - i.assignments);
                            }
                            var b = m - Math.floor(_);
                            i.should_replace = b < n.eval_threshold;
                        }
                        if (d || i.should_replace) {
                            var s;
                            if (y(r)) {
                                s = h.optimize(n);
                                if (s === h) s = s.clone(true);
                            } else {
                                s = ve(h.optimize(n), r);
                                if (s === h || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function y(e) {
                var n;
                e.walk(new Si(function(e) {
                    if (e instanceof ai) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Pe(e, n) {
            return e.option("unsafe") && n instanceof Tt && n.property == "raw" && Te(n.expression) && n.expression.name == "String";
        }
        e(li, function(e, n) {
            if (!n.option("templates")) return e;
            if (!e.tag || Pe(n, e.tag)) {
                var t = e.expressions.slice();
                var i = e.strings.slice();
                var r = false;
                for (var a = t.length; --a >= 0; ) {
                    var o = t[a];
                    var s = o.evaluate(n);
                    if (s === o) continue;
                    s = ("" + s).replace(/\r|\\|`/g, function(e) {
                        return "\\" + (e == "\r" ? "r" : e);
                    });
                    if (s.length > o.print_to_string().length + 3) continue;
                    var f = i[a] + s + i[a + 1];
                    if (typeof xe(li, e, {
                        expressions: [],
                        strings: [ f ],
                        tag: e.tag
                    }).evaluate(n) != typeof xe(li, e, {
                        expressions: [ o ],
                        strings: i.slice(a, a + 2),
                        tag: e.tag
                    }).evaluate(n)) continue;
                    t.splice(a, 1);
                    i.splice(a, 2, f);
                    r = true;
                }
                if (r) {
                    e.expressions = t;
                    e.strings = i;
                }
            }
            return Oe(n, e);
        });
        function se(e, n) {
            return e instanceof ai || e.TYPE === n.TYPE;
        }
        e(bi, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = fe(n).find_variable("undefined");
                if (t) {
                    var i = xe(ai, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = Mi(n.self(), n.parent());
            if (r && se(r, e)) return e;
            return xe($t, e, {
                operator: "void",
                expression: xe(hi, e, {
                    value: 0
                })
            });
        });
        e(wi, function(e, n) {
            var t = Mi(n.self(), n.parent());
            if (t && se(t, e)) return e;
            if (n.option("keep_infinity") && !t && !fe(n).find_variable("Infinity")) {
                return e;
            }
            return xe(qt, e, {
                operator: "/",
                left: xe(hi, e, {
                    value: 1
                }),
                right: xe(hi, e, {
                    value: 0
                })
            });
        });
        e(gi, function(e, n) {
            var t = Mi(n.self(), n.parent());
            if (t && se(t, e)) return e;
            if (!t && !fe(n).find_variable("NaN")) return e;
            return xe(qt, e, {
                operator: "/",
                left: xe(hi, e, {
                    value: 0
                }),
                right: xe(hi, e, {
                    value: 0
                })
            });
        });
        function Ne(t, n) {
            var i = false;
            var r = new Si(function(e) {
                if (i) return true;
                if (e instanceof ai && Re(e.definition(), n)) {
                    return i = true;
                }
            });
            var a = new Si(function(e) {
                if (i) return true;
                if (e instanceof Tn && e !== t) {
                    var n = a.parent();
                    if (n instanceof xt && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(a);
            return i;
        }
        var He = en("+ - * / % >> << >>> | ^ &");
        var Ye = en("* | ^ &");
        e(Mt, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof St) {
                    if (a.operator == "=") {
                        if (a.__drop) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof At) e.push(a.left.property);
                            e.push(a.right);
                            return ce(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof Dn || !o.has_directive("use strict") && n instanceof pi && !n.may_throw_on_access(o)) {
                            return a.left instanceof Tt ? a.right : ce(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof ai && nn(a.left.definition().orig, function(e) {
                    return !(e instanceof Xt);
                })) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof $t && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return h();
                    var i = a.left.definition();
                    var s = i.scope.resolve();
                    var r = s === o.find_parent(Dn);
                    var f = 0, u;
                    t = o.self();
                    do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Mt) {
                            var c = false;
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof St) return true;
                                if (!c && e instanceof ai && e.definition() === i) {
                                    if (d(f, t)) return true;
                                    i.fixed = false;
                                    c = true;
                                }
                            })) break;
                            if (c) return h();
                        } else if (t instanceof Zn) {
                            if (!r) break;
                            if (d(f, t)) break;
                            if (Ne(s, [ i ])) break;
                            i.fixed = false;
                            return h();
                        } else if (t instanceof _t) {
                            if (!(t.name instanceof Jt)) continue;
                            if (t.name.definition() !== i) continue;
                            if (d(f, t)) break;
                            i.fixed = false;
                            return h();
                        }
                    } while (t instanceof qt && t.right === u || t instanceof Ft && t.condition !== u || t instanceof Et && t.tail_node() === u || t instanceof $t);
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof ai && a.right instanceof qt) {
                    if (a.right.left instanceof ai && a.right.left.name == a.left.name && He[a.right.operator]) {
                        return xe(Mt, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if (a.right.right instanceof ai && a.right.right.name == a.left.name && Ye[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        return xe(Mt, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof hi && a.right.value == 1) {
                    var p = a.operator.slice(0, -1);
                    return xe($t, a, {
                        operator: p + p,
                        expression: a.left
                    });
                }
            }
            return Oe(o, a);
            function d(e, n) {
                var t = a.right;
                a.right = xe(_i, t);
                var i = n.may_throw(o);
                a.right = t;
                var r;
                while (r = o.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof ct) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function h() {
                return (a.operator != "=" ? xe(qt, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : ke(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Ft, function(r, n) {
            if (n.option("sequences") && r.condition instanceof Et) {
                var e = r.condition.expressions.slice();
                r.condition = e.pop();
                e.push(r);
                return ce(r, e);
            }
            if (!n.option("conditionals")) return r;
            var a = r.condition.is_truthy() || r.condition.evaluate(n, true);
            if (!a) {
                on.warn("Condition always false [{file}:{line},{col}]", r.start);
                return ce(r, [ r.condition, r.alternative ]).optimize(n);
            } else if (!(a instanceof on)) {
                on.warn("Condition always true [{file}:{line},{col}]", r.start);
                return ce(r, [ r.condition, r.consequent ]).optimize(n);
            }
            var t = a.negate(n, an(n));
            if (me(n, a, t) === t) {
                r = xe(Ft, r, {
                    condition: t,
                    consequent: r.alternative,
                    alternative: r.consequent
                });
                t = a;
                a = r.condition;
            }
            var i = r.consequent;
            var o = r.alternative;
            if (ae(n, a)) {
                if (a.equivalent_to(i)) return xe(qt, r, {
                    operator: "||",
                    left: a,
                    right: o
                }).optimize(n);
                if (a.equivalent_to(o)) return xe(qt, r, {
                    operator: "&&",
                    left: a,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof Mt) {
                var f = s.operator == "=";
                var u = f ? o.tail_node() : o;
                if ((f || i === s) && u instanceof Mt && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof ai || !a.has_side_effects(n) && w(i) && w(o))) {
                    return xe(Mt, r, {
                        operator: s.operator,
                        left: s.left,
                        right: xe(Ft, r, {
                            condition: a,
                            consequent: x(i),
                            alternative: x(o)
                        })
                    });
                }
            }
            if (i.equivalent_to(o)) return ce(r, [ a, i ]).optimize(n);
            var c = y(i, o, true);
            if (c) return c;
            var l;
            if (i instanceof xt && o.TYPE == i.TYPE && (l = g(i, o)) >= 0 && i.expression.equivalent_to(o.expression) && !a.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                var d = i.args[l];
                p.args[l] = d instanceof Dt ? xe(Dt, r, {
                    expression: xe(Ft, r, {
                        condition: a,
                        consequent: d.expression,
                        alternative: o.args[l].expression
                    })
                }) : xe(Ft, r, {
                    condition: a,
                    consequent: d,
                    alternative: o.args[l]
                });
                return p;
            }
            if (i instanceof Ft && i.alternative.equivalent_to(o)) {
                return xe(Ft, r, {
                    condition: xe(qt, r, {
                        left: a,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: o
                });
            }
            if (i instanceof Ft && i.consequent.equivalent_to(o)) {
                return xe(Ft, r, {
                    condition: xe(qt, r, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: o,
                    alternative: i.alternative
                });
            }
            if (o instanceof Ft && i.equivalent_to(o.consequent)) {
                return xe(Ft, r, {
                    condition: xe(qt, r, {
                        left: a,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: i,
                    alternative: o.alternative
                });
            }
            if (o instanceof Ft && i.equivalent_to(o.alternative)) {
                return xe(Ft, r, {
                    condition: xe(qt, r, {
                        left: t,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: i
                });
            }
            if ((i instanceof Et || o instanceof Et) && i.tail_node().equivalent_to(o.tail_node())) {
                return ce(r, [ xe(Ft, r, {
                    condition: a,
                    consequent: k(i),
                    alternative: k(o)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof qt && i.operator == "&&" && i.right.equivalent_to(o)) {
                return xe(qt, r, {
                    operator: "&&",
                    left: xe(qt, r, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (i instanceof qt && i.operator == "||" && i.right.equivalent_to(o)) {
                return xe(qt, r, {
                    operator: "||",
                    left: xe(qt, r, {
                        operator: "&&",
                        left: a,
                        right: i.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (o instanceof qt && o.operator == "&&" && o.right.equivalent_to(i)) {
                return xe(qt, r, {
                    operator: "&&",
                    left: xe(qt, r, {
                        operator: "||",
                        left: a,
                        right: o.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (o instanceof qt && o.operator == "||" && o.right.equivalent_to(i)) {
                return xe(qt, r, {
                    operator: "||",
                    left: xe(qt, r, {
                        operator: "&&",
                        left: t,
                        right: o.left
                    }),
                    right: i
                }).optimize(n);
            }
            var h = n.option("booleans") && n.in_boolean_context();
            if (m(i)) {
                if (_(o)) {
                    return v(a);
                }
                return xe(qt, r, {
                    operator: "||",
                    left: v(a),
                    right: o
                });
            }
            if (_(i)) {
                if (m(o)) {
                    return v(a.negate(n));
                }
                return xe(qt, r, {
                    operator: "&&",
                    left: v(a.negate(n)),
                    right: o
                });
            }
            if (m(o)) {
                return xe(qt, r, {
                    operator: "||",
                    left: v(a.negate(n)),
                    right: i
                });
            }
            if (_(o)) {
                return xe(qt, r, {
                    operator: "&&",
                    left: v(a),
                    right: i
                });
            }
            if (n.option("typeofs")) R(a, i, o);
            return r;
            function v(e) {
                if (e.is_boolean(n)) return e;
                return xe($t, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Ei || h && e instanceof pi && e.value || e instanceof $t && e.operator == "!" && e.expression instanceof pi && !e.expression.value;
            }
            function _(e) {
                return e instanceof ki || h && (e instanceof pi && !e.value || e instanceof $t && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof $t && e.operator == "!" && e.expression instanceof pi && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var a = 0; a < r; a++) {
                    if (!t[a].equivalent_to(i[a])) {
                        if (t[a] instanceof Dt !== i[a] instanceof Dt) return -3;
                        for (var o = a + 1; o < r; o++) {
                            if (!t[o].equivalent_to(i[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e instanceof xt) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof St || n.expression instanceof St) || b(e.expression, n.expression);
                }
                if (!(e instanceof St)) return;
                var t = e.property;
                var i = n.property;
                return (t instanceof on ? t.equivalent_to(i) : t == i) && !(e.expression instanceof fi || n.expression instanceof fi);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && xe(Ft, r, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var i = e.clone();
                i.expression = y(e.expression, n.expression);
                return i;
            }
            function w(e) {
                return e === e.tail_node() || nn(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof Et)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return ce(e, n);
            }
            function k(e) {
                if (!(e instanceof Et)) return xe(hi, e, {
                    value: 0
                });
                return ce(e, e.expressions.slice(0, -1));
            }
        });
        e(xi, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return xe(hi, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof qt && (t.operator == "==" || t.operator == "!=")) {
                on.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return xe(hi, e, {
                    value: +e.value
                });
            }
            return xe($t, e, {
                operator: "!",
                expression: xe(hi, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Dt, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof Pt && !(n.parent() instanceof Bt)) {
                return Xe.splice(t.elements.map(function(e) {
                    return e instanceof yi ? xe(bi, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function Ie(e, n) {
            if (e instanceof ai) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof Dn)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(At, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var a = parseFloat(r);
                            if (a.toString() == r) {
                                r = a;
                            }
                        }
                    }
                    i = e.property = ve(i, le(r, i).transform(t));
                    var o = "" + r;
                    if (Ai(o) && o.length <= i.print_to_string().length + 1) {
                        return xe(Tt, e, {
                            expression: n,
                            property: o
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f = Mi(t.self(), s);
            var u, c, l;
            if (t.option("arguments") && n instanceof ai && ge(u = n.definition()) && !n.in_arg && i instanceof hi && (c = u.scope) === E() && c.uses_arguments < (f ? 2 : 3)) {
                var p = i.value;
                if (s instanceof $t && s.operator == "delete") {
                    if (!u.deleted) u.deleted = [];
                    u.deleted[p] = true;
                }
                var d = c.argnames[p];
                if (u.deleted && u.deleted[p]) {
                    d = null;
                } else if (d) {
                    var h;
                    if (!(d instanceof ei) || d.name == "await" || n.scope.find_variable(d.name) !== (h = d.definition())) {
                        d = null;
                    } else if (t.has_directive("use strict") || c.name || c.rest || !(l instanceof xt && p < l.args.length) || !nn(c.argnames, function(e) {
                        return e instanceof ei;
                    })) {
                        if (S() || h.assignments || h.orig.length > 1) d = null;
                    }
                } else if ((f || !S()) && p < c.argnames.length + 5 && t.drop_fargs(c, l) && !c.rest) {
                    while (p >= c.argnames.length) {
                        d = c.make_var(ei, c, "argument_" + c.argnames.length);
                        c.argnames.push(d);
                    }
                }
                if (d && Le(function(e) {
                    return e.name === d.name;
                }, c.argnames) === d) {
                    if (f) u.reassigned--;
                    var v = xe(ai, e, d);
                    v.reference();
                    delete d.__unused;
                    return v;
                }
            }
            if (f) return e;
            if (t.option("sequences") && s.TYPE != "Call" && !(s instanceof kn && s.init === e)) {
                var m = Fe(e, t);
                if (m !== e) return m.optimize(t);
            }
            if (r !== i) {
                var _ = e.flatten_object(o, t);
                if (_) {
                    n = e.expression = _.expression;
                    i = e.property = _.property;
                }
            }
            var g;
            if (t.option("properties") && t.option("side_effects") && i instanceof hi && n instanceof Pt && nn(g = n.elements, function(e) {
                return !(e instanceof Dt);
            })) {
                var p = i.value;
                var b = g[p];
                if (Ie(b, t)) {
                    var y = b instanceof yi;
                    var w = !y;
                    var x = [];
                    for (var k = g.length; --k > p; ) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                            if (w && a.has_side_effects(t)) w = false;
                        }
                    }
                    if (!w) x.unshift(b);
                    while (--k >= 0) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                        } else if (y) {
                            x.unshift(xe(yi, g[k]));
                        } else {
                            p--;
                        }
                    }
                    if (w) {
                        x.push(b);
                        return ce(e, x).optimize(t);
                    } else return xe(At, e, {
                        expression: xe(Pt, n, {
                            elements: x
                        }),
                        property: xe(hi, i, {
                            value: p
                        })
                    });
                }
            }
            return Oe(t, e);
            function E() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof Dn) {
                        if (n instanceof On) return;
                        if (zn(n)) continue;
                        l = t.parent(e);
                        return n;
                    }
                }
            }
            function S() {
                return !t.option("reduce_vars") || u.reassigned;
            }
        });
        Cn.DEFMETHOD("contains_super", Ve);
        jn.DEFMETHOD("contains_super", Ve);
        Dn.DEFMETHOD("contains_super", function() {
            var n;
            var t = this;
            t.walk(new Si(function(e) {
                if (n) return true;
                if (e instanceof fi) return n = true;
                if (e !== t && e instanceof Tn && !zn(e)) return true;
            }));
            return n;
        });
        In.DEFMETHOD("contains_super", Ve);
        Tn.DEFMETHOD("contains_super", Ve);
        Cn.DEFMETHOD("contains_this", Ve);
        jn.DEFMETHOD("contains_this", Ve);
        on.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new Si(function(e) {
                if (n) return true;
                if (e instanceof ui) return n = true;
                if (e !== t && e instanceof Tn && !zn(e)) return true;
            }));
            return n;
        });
        function Be(e) {
            return e instanceof Lt && typeof e.key == "string" && !(e instanceof Ut && e.value.contains_super());
        }
        St.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof Bt) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a.key != e) continue;
                    if (!nn(i, Be)) break;
                    if (!Ie(a.value, n)) break;
                    i = i.map(function(e) {
                        return e.value;
                    });
                    if (a instanceof Ut && a.value instanceof Hn && !(n.parent() instanceof xt)) {
                        if (a.value.uses_arguments) break;
                        i[r] = xe(Cn, a.value, a.value);
                    }
                    return xe(At, this, {
                        expression: xe(Pt, t, {
                            elements: i
                        }),
                        property: xe(hi, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(Tt, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                on.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (Mi(n.self(), t)) return e;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof kn && t.init === e)) {
                var i = Fe(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Tt && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (Te(r)) switch (r.name) {
                  case "Array":
                    e.expression = xe(Pt, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = xe(Hn, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(r.scope);
                    break;

                  case "Number":
                    e.expression = xe(hi, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = xe(Bt, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = xe(mi, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = xe(di, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var a = e.flatten_object(e.property, n);
            if (a) return a.optimize(n);
            return Oe(n, e);
        });
        e(Ht, function(e, n) {
            if (n.option("rests") && e.rest instanceof Ht) {
                e.elements = e.elements.concat(e.rest.elements);
                e.rest = null;
            }
            return e;
        });
        e(Yt, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof on) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(Bt, function(t, i) {
            if (!i.option("objects")) return t;
            var r = false;
            var a = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = new tn();
            var u = [];
            t.properties.forEach(function(e) {
                if (!(e instanceof Dt)) return l(e);
                a = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof Bt && nn(n.properties, function(e) {
                    return !(e instanceof Gt || e instanceof Dt);
                })) {
                    r = true;
                    n.properties.forEach(function(e) {
                        l(e instanceof Vt ? xe(Lt, e, {
                            key: e.key,
                            value: xe(bi, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!r) return t;
            if (a && o && u.length == 1) {
                var e = u[0];
                if (e instanceof Rt && e.key instanceof hi) {
                    e.key = "" + e.key.value;
                }
            }
            return xe(Bt, t, {
                properties: u
            });
            function c() {
                f.each(function(e) {
                    if (e.length == 1) return u.push(e[0]);
                    r = true;
                    var n = s && !o && e.pop();
                    u.push(e.length == 1 ? e[0] : xe(Lt, t, {
                        key: e[0].key,
                        value: ce(t, e.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (n) u.push(n);
                });
                f = new tn();
            }
            function l(e) {
                var n = e.key;
                if (n instanceof on) {
                    a = true;
                    n = n.evaluate(i);
                    if (n === e.key) {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (Be(e)) {
                    if (e.value.has_side_effects(i)) c();
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (a && !o && typeof n == "string" && D.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = xe(hi, e, {
                        value: +n
                    });
                }
            }
        });
        e(et, function(e, n) {
            if (n.option("side_effects") && e.value && Ae(e.value, n) && !g(n.find_parent(Tn))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ie(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function ji(f) {
        f = ge(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = Ve;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = ie;
            } else {
                u = Ge;
            }
        }
        var a = 0;
        var o = 1;
        var c = 0;
        var t = f.indent_start;
        var s;
        var r = 0;
        var l = true;
        var p = f.source_map && [];
        var d;
        var h;
        var v;
        var m;
        var _ = false;
        var g = false;
        var b = -1;
        var i;
        var y;
        function w() {
            s = "";
            v = false;
            m = false;
            i = [];
            var e = y;
            y = "";
            return e;
        }
        w();
        var x = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (ee(r)) {
                    if (ne(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ne(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function k(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function E(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var S = [ null, k, E, function(e, n) {
            return n == "'" ? k(e) : E(e);
        } ][f.quote_style] || function(e, n, t, i) {
            return t > i ? k(e) : E(e);
        };
        function T(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return S(x(t), e, i, r);
        }
        var A = p ? function(n, t) {
            p.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Ue;
        var D = p ? function() {
            p.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            p = [];
        } : Ue;
        function O(e) {
            var n = y.lastIndexOf("\n");
            if (r < n) r = n;
            var t = y.slice(0, r);
            var i = y.slice(r);
            A(e, i.length - a);
            o += e;
            c += e;
            a = i.length;
            y = t;
            while (e--) y += "\n";
            y += i;
        }
        var $ = f.max_line_len ? function() {
            if (l) {
                if (a > f.max_line_len) {
                    on.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (a > f.max_line_len) O(1);
            l = true;
            D();
        } : Ue;
        var z = en("( [ + * / - , .");
        var q = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (_ && n) {
                _ = false;
                if (n != "\n") {
                    q("\n");
                    M();
                }
            }
            if (g && n) {
                g = false;
                if (!/[\s;})]/.test(n)) {
                    F();
                }
            }
            b = -1;
            var t = s.slice(-1);
            if (m) {
                m = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        y += ";";
                        a++;
                        c++;
                    } else {
                        $();
                        y += "\n";
                        c++;
                        o++;
                        a = 0;
                        if (/^\s+$/.test(e)) {
                            m = true;
                        }
                    }
                    if (!f.beautify) v = false;
                }
            }
            if (v) {
                if (te(t) && (te(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == s || e == "--" && s == "!" || e == "in" && t == "/" || s == "--" && n == ">") {
                    y += " ";
                    a++;
                    c++;
                }
                if (t != "<" || e != "!") v = false;
            }
            if (h) {
                p.push({
                    token: h,
                    name: d,
                    line: o,
                    col: a
                });
                h = false;
                if (l) D();
            }
            y += e;
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            o += r;
            a += i[0].length;
            if (r > 0) {
                $();
                a = i[r].length;
            }
            s = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = s.slice(-1);
            if (m) {
                m = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    y += ";";
                    v = false;
                }
            }
            if (v) {
                if (te(t) && (te(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == s || e == "--" && s == "!" || e == "in" && t == "/" || s == "--" && n == ">") {
                    y += " ";
                }
                if (t != "<" || e != "!") v = false;
            }
            y += e;
            s = e;
        };
        var F = f.beautify ? function() {
            q(" ");
        } : function() {
            v = true;
        };
        var M = f.beautify ? function(e) {
            if (_) q("\n");
            q(Q(" ", e ? t - (f.indent_level >> 1) : t));
        } : Ue;
        var C = f.beautify ? function(e) {
            var n = t;
            t += f.indent_level;
            e();
            t = n;
        } : function(e) {
            e();
        };
        var j = f.max_line_len || f.preserve_line ? function() {
            $();
            r = y.length;
            l = false;
        } : Ue;
        var P = f.beautify ? function() {
            if (b < 0) return q("\n");
            if (y[b] != "\n") {
                y = y.slice(0, b) + "\n" + y.slice(b);
                c++;
                o++;
            }
            b++;
        } : j;
        var N = f.beautify ? function() {
            q(";");
        } : function() {
            m = true;
        };
        function H() {
            if (m) q(";");
            q(";");
        }
        function Y(e) {
            q("{");
            P();
            C(e);
            M();
            q("}");
        }
        function I(e) {
            q("(");
            j();
            e();
            j();
            q(")");
        }
        function B(e) {
            q("[");
            j();
            e();
            j();
            q("]");
        }
        function R() {
            j();
            q(",");
            j();
            F();
        }
        function L() {
            q(":");
            F();
        }
        var U = p ? function(e, n) {
            h = e;
            d = n;
        } : Ue;
        function V() {
            if (!l) $();
            return y;
        }
        function G() {
            var e = y.lastIndexOf("\n");
            return /^ *$/.test(y.slice(e + 1));
        }
        function W(e, n) {
            if (_) return;
            if (e.nlb && (n || !G())) {
                _ = true;
            } else if (n) {
                g = true;
            }
        }
        function J(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                q("//" + n);
                _ = true;
            } else if (e.type == "comment2") {
                q("/*" + n + "*/");
            }
            return true;
        }
        function X(e) {
            var i = this;
            var r = e instanceof Zn && e.value;
            var a = s(e);
            if (!a) a = [];
            if (r) {
                var o = new Si(function(e) {
                    var n = o.parent();
                    if (n instanceof Zn || n instanceof qt && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof Ft && n.condition === e || n instanceof Tt && n.expression === e || n instanceof Et && n.expressions[0] === e || n instanceof At && n.expression === e || n instanceof zt) {
                        var t = s(e);
                        if (t) a = a.concat(t);
                    } else {
                        return true;
                    }
                });
                o.push(e);
                e.value.walk(o);
            }
            if (c == 0) {
                if (a.length > 0 && f.shebang && a[0].type == "comment5") {
                    q("#!" + a.shift().value + "\n");
                    M();
                }
                var n = f.preamble;
                if (n) {
                    q(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            a = a.filter(u, e);
            var t = false;
            a.forEach(function(e, n) {
                W(e, n);
                if (J(e)) t = true;
            });
            if (t) W(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Z();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function K(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof sn || nn(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var a = y.length;
            r.filter(u, e).forEach(function(e, n) {
                W(e, n || !t);
                J(e);
            });
            if (y.length > a) b = a;
        }
        return {
            get: V,
            reset: w,
            indent: M,
            should_break: f.width ? function() {
                return a - t >= f.width;
            } : Ve,
            has_parens: function() {
                return s.slice(-1) == "(";
            },
            newline: P,
            print: q,
            space: F,
            comma: R,
            colon: L,
            last: function() {
                return s;
            },
            semicolon: N,
            force_semicolon: H,
            to_utf8: x,
            print_name: function(e) {
                q(x(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = T(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                q(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                q(T(e, n));
            },
            with_indent: C,
            with_block: Y,
            with_parens: I,
            with_square: B,
            add_mapping: U,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? X : Ue,
            append_comments: f.comments ? K : Ue,
            push_node: function(e) {
                i.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = i.pop();
                if (e.start && e.start.line > o) {
                    O(e.start.line - o);
                }
            } : function() {
                i.pop();
            },
            parent: function(e) {
                return i[i.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        on.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var t = ji({
            inline_script: false,
            shebang: false,
            width: false
        });
        on.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = ji(e);
                this.print(n);
                return n.get();
            }
            this.print(t);
            return t.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(on, Ve);
        function i(e) {
            var n = e.parent();
            if (!e.has_parens() && an(e, false, true)) {
                return this.name || !(n instanceof bt);
            }
            if (e.option("webkit") && n instanceof St && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof xt && n.expression === this) return true;
        }
        n(Pn, i);
        n(Nn, i);
        n(Wn, i);
        n(Hn, i);
        n(Yn, i);
        function r(e) {
            return !e.has_parens() && an(e, true);
        }
        n(Bt, r);
        function a(e) {
            var n = e.parent();
            if (n instanceof qt) return n.operator == "**" && n.left === this;
            if (n instanceof xt) return n.expression === this;
            if (n instanceof Vn) return true;
            if (n instanceof St) return n.expression === this;
        }
        n(Ct, a);
        n(Ot, a);
        n(Et, function(e) {
            var n = e.parent();
            return n instanceof Pt || zn(n) && n.value === this || n instanceof Ct || n instanceof qt || n instanceof xt || n instanceof Vn || n instanceof Jn || n instanceof Ft || n instanceof wt || n instanceof Yt || n instanceof bt || n instanceof be || n instanceof Rt || n instanceof St && n.expression === this || n instanceof Dt || n instanceof li && n.tag === this || n instanceof Ot || n instanceof _t || n instanceof jt;
        });
        n(qt, function(e) {
            var n = e.parent();
            if (n instanceof Ct) return true;
            if (n instanceof qt) {
                var t = n.operator, i = zi[t];
                var r = this.operator, a = zi[r];
                return i > a || t == "??" && (r == "&&" || r == "||") || i == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof xt) return n.expression === this;
            if (n instanceof Vn) return true;
            if (n instanceof St) return n.expression === this;
            if (n instanceof Ot) return true;
        });
        n(St, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof kt && t.expression === n) {
                do {
                    n = n.expression;
                } while (n instanceof St);
                return n.TYPE == "Call";
            }
        });
        n(xt, function(e) {
            var n = e.parent();
            if (n instanceof kt) return n.expression === this;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof Hn && n instanceof St && n.expression === this && t instanceof Mt && t.left === n;
            }
        });
        n(kt, function(e) {
            if (z(this, e)) return false;
            var n = e.parent();
            if (n instanceof xt) return n.expression === this;
            if (n instanceof St) return true;
            if (n instanceof li) return n.tag === this;
        });
        n(hi, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof St && n.expression === this && /^0/.test(F(this.value));
        });
        function o(e, n) {
            var t = n.parent();
            if (t instanceof Ct) return true;
            if (t instanceof qt) return !(t instanceof Mt);
            if (t instanceof xt) return t.expression === e;
            if (t instanceof Vn) return true;
            if (t instanceof Ft) return t.condition === e;
            if (t instanceof St) return t.expression === e;
            if (t instanceof li) return t.tag === e;
            if (t instanceof Ot) return true;
        }
        n(Cn, function(e) {
            return o(this, e);
        });
        n(Mt, function(e) {
            if (o(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Nt;
            if (this.left instanceof It) return r(e);
        });
        n(jn, function(e) {
            return o(this, e);
        });
        n(Ft, function(e) {
            return o(this, e);
        });
        n(jt, function(e) {
            return o(this, e);
        });
        e(un, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(fn, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function f(e, t, i, n) {
            var r = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof un) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof cn)) {
                        if (e instanceof pn && e.body instanceof di) {
                            i.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof cn) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = o;
        }
        e(An, function(e) {
            f(this.body, true, e, true);
            e.print("");
        });
        e(_n, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(pn, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function u(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function c(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    f(e.body, false, n, t);
                });
            } else u(e, n);
        }
        e(mn, function(e) {
            c(this, e);
        });
        e(cn, function(e) {
            e.semicolon();
        });
        e(yn, function(e) {
            var n = this;
            e.print("do");
            e.space();
            M(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(wn, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            $(n.body, e);
        });
        e(xn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof dt) {
                        n.init.print(e);
                    } else {
                        k(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            e.space();
            $(n.body, e);
        });
        function l(t, i) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(i);
                    e.space();
                    n.object.print(e);
                });
                e.space();
                $(n.body, e);
            };
        }
        e(ye, l("for await", "of"));
        e(En, l("for", "in"));
        e(be, l("for", "of"));
        e(Sn, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            e.space();
            $(n.body, e);
        });
        e(gt, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(bt, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof Wn) {
                if (!n.name) return;
            }
            if (n instanceof Gn) return;
            if (n instanceof In) return;
            if (n instanceof $n) {
                if (!n.name && !zn(n)) return;
            }
            e.semicolon();
        });
        e(ke, function(i) {
            var r = this;
            i.print("export");
            i.space();
            var n = r.keys.length;
            if (n == 0) {
                u(r, i);
            } else if (r.keys[0] == "*") {
                t(0);
            } else i.with_block(function() {
                i.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    i.print(",");
                    i.newline();
                    i.indent();
                    t(e);
                }
                i.newline();
            });
            i.space();
            i.print("from");
            i.space();
            i.print_string(r.path, r.quote);
            i.semicolon();
            function t(e) {
                var n = r.aliases[e];
                var t = r.keys[e];
                i.print_name(t);
                if (n != t) {
                    i.space();
                    i.print("as");
                    i.space();
                    i.print_name(n);
                }
            }
        });
        e(yt, function(e) {
            var n = this;
            e.print("export");
            e.space();
            T(n, e);
            e.semicolon();
        });
        e(Ee, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                T(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            e.print_string(n.path, n.quote);
            e.semicolon();
        });
        function p(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function d(e, n) {
            if (e.argnames.length == 1 && e.argnames[0] instanceof ei && !e.rest) {
                e.argnames[0].print(n);
            } else {
                p(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                c(e, n, true);
            }
        }
        e(Cn, function(e) {
            d(this, e);
        });
        e(jn, function(e) {
            e.print("async");
            e.space();
            d(this, e);
        });
        function h(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            p(e, n);
            n.space();
            c(e, n, true);
        }
        e(Dn, function(e) {
            e.print("function");
            h(this, e);
        });
        function v(e) {
            e.print("async");
            e.space();
            e.print("function");
            h(this, e);
        }
        e(Bn, v);
        e(Pn, v);
        function m(e) {
            e.print("async");
            e.space();
            e.print("function*");
            h(this, e);
        }
        e(Rn, m);
        e(Nn, m);
        function _(e) {
            e.print("function*");
            h(this, e);
        }
        e(Un, _);
        e(Yn, _);
        e(Vn, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            T(n, e, true);
        });
        e(Xn, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            A(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(we, D("get"));
        e(xe, D("set"));
        function g(e, n) {
            var t = e.value;
            if (qn(t)) {
                n.print("async");
                n.space();
            }
            if (Fn(t)) n.print("*");
            A(e, n);
            h(e.value, n);
        }
        e(Kn, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            g(n, e);
        });
        function b(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(et, b("return", "value"));
        e(nt, b("throw", "value"));
        e(it, b("break", "label"));
        e(rt, b("continue", "label"));
        function y(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof ht || t instanceof vt) || n.option("ie8") && t instanceof yn) return M(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof at) {
                    if (!t.alternative) {
                        M(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof j) {
                    t = t.body;
                } else break;
            }
            $(e.body, n);
        }
        e(at, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            if (n.alternative) {
                y(n, e);
                e.space();
                e.print("else");
                e.space();
                if (n.alternative instanceof at) n.alternative.print(e); else $(n.alternative, e);
            } else {
                $(n.body, e);
            }
        });
        e(ot, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) u(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function w(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(ft, function(e) {
            e.print("default:");
            w(this, e);
        });
        e(ut, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            w(n, e);
        });
        e(ct, function(e) {
            var n = this;
            e.print("try");
            e.space();
            c(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(lt, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            c(n, e);
        });
        e(pt, function(e) {
            e.print("finally");
            e.space();
            c(this, e);
        });
        function x(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof gn && n.init === e)) t.semicolon();
            };
        }
        e(ht, x("const"));
        e(vt, x("let"));
        e(mt, x("var"));
        function k(e, n, t) {
            var i = false;
            if (t) e.walk(new Si(function(e) {
                if (i) return true;
                if (e instanceof qt && e.operator == "in") return i = true;
                if (e instanceof Tn && !(zn(e) && e.value)) return true;
            }));
            e.print(n, i);
        }
        e(_t, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof xn || t instanceof kn;
                k(n.value, e, i);
            }
        });
        e(wt, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function E(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, i = e, r;
            do {
                r = i;
                i = n.parent(t++);
                if (i instanceof xt && i.expression === r) return;
            } while (i instanceof St && i.expression === r);
            n.print("/*" + e.pure + "*/");
        }
        function S(e, t) {
            if (e.expression instanceof xt || e.expression instanceof Dn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(xt, function(e) {
            var n = this;
            E(n, e);
            n.expression.print(e);
            S(n, e);
        });
        e(kt, function(e) {
            var n = this;
            E(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (z(n, e)) S(n, e);
        });
        e(Et, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Tt, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie8") && P[i]) {
                e.print("[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof hi && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(At, function(e) {
            this.expression.print(e);
            e.print("[");
            this.property.print(e);
            e.print("]");
        });
        e(Dt, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e($t, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof $t && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(zt, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(qt, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Ft, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Ct, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(jt, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(Pt, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof yi) t.comma();
                });
                t.space();
            } : Ue);
        });
        e(Ht, function(t) {
            var e = this.elements, n = e.length, i = this.rest;
            t.with_square(n || i ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (i) {
                    if (n) t.comma();
                    t.print("...");
                    i.print(t);
                } else if (e[n - 1] instanceof yi) {
                    t.comma();
                }
                t.space();
            } : Ue);
        });
        e(Yt, function(e) {
            var n = this;
            var t = A(n, e);
            var i = n.value;
            if (t && i instanceof Jt && t == O(i)) return;
            e.colon();
            i.print(e);
        });
        e(It, function(t) {
            var e = this.properties, n = e.length, i = this.rest;
            if (n || i) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (i) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    i.print(t);
                }
                t.newline();
            }); else u(this, t);
        });
        function T(e, t, i) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!i) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else u(e, t);
        }
        e(Bt, function(e) {
            T(this, e);
        });
        function A(e, n) {
            var t = e.key;
            if (t instanceof on) {
                n.with_square(function() {
                    t.print(n);
                });
            } else if (n.option("quote_keys")) {
                n.print_string(t);
            } else if ("" + +t == t && t >= 0) {
                n.print(F(t));
            } else {
                var i = e.start && e.start.quote;
                if (e.private) {
                    n.print_name(t);
                } else if (P[t] ? !n.option("ie8") : Ai(t)) {
                    if (i && n.option("keep_quoted_props")) {
                        n.print_string(t, i);
                    } else {
                        n.print_name(t);
                        return t;
                    }
                } else {
                    n.print_string(t, i);
                }
            }
        }
        e(Lt, function(e) {
            var n = this;
            A(n, e);
            e.colon();
            n.value.print(e);
        });
        e(Ut, function(e) {
            g(this, e);
        });
        function D(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                A(n, e);
                h(n.value, e);
            };
        }
        e(Gt, D("get"));
        e(Vt, D("set"));
        function O(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(Wt, function(e) {
            e.print_name(O(this));
        });
        e(oi, function(e) {
            var n = this;
            var t = O(n);
            e.print_name(t);
            var i = n.alias;
            if (i != t) {
                e.space();
                e.print("as");
                e.space();
                e.print_name(i);
            }
        });
        e(Kt, function(e) {
            var n = this;
            var t = O(n);
            var i = n.key;
            if (i && i != t) {
                e.print_name(i);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(yi, Ue);
        e(li, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(pi, function(e) {
            e.print("" + this.value);
        });
        e(di, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(hi, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(F(this.value));
            }
        });
        e(mi, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof qt && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function $(e, n) {
            if (n.option("braces") && !(e instanceof ht || e instanceof vt)) {
                M(e, n);
            } else if (e instanceof cn) {
                n.force_semicolon();
            } else {
                e.print(n);
            }
        }
        function z(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function q(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function F(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, a;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                a = n.slice(r);
                t.push(a + "e-" + (a.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return q(t);
        }
        function M(e, n) {
            if (e instanceof cn) {
                u(e, n);
            } else if (e instanceof mn) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function C(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        C([ on, _n ], Ue);
        C([ Pt, mn, lt, pi, fn, dt, Nt, pt, Qn, Dn, kt, Bt, j, Wt, ot, st, ct ], function(e) {
            e.add_mapping(this.start);
        });
        C([ Yt, Rt ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var S = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var T = S.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, a = 0; r < n.length; r++) {
            var o = T[n[r]];
            t += (o & 31) << i;
            if (o & 32) {
                i += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return a;
    }
    function D(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += S[t];
        } while (e);
        return n;
    }
    function O() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!rn(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function $(l) {
        var f = O();
        var a = l.includeSources && Object.create(null);
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) a[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, i, r, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!(e in a)) {
                    a[e] = n;
                }
            } : Ue,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += D(t - h);
            h = t;
            if (e == null) return;
            var o = f.index(e);
            c += D(o - v);
            v = o;
            c += D(i - m);
            m = i;
            c += D(r - _);
            _ = r;
            if (l.names && a != null) {
                var s = u.index(a);
                c += D(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof sn && e[t].body instanceof di) {
                    e[t] = new un({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof sn && e[t].body instanceof di)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new An({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new Ln({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new Hn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new pn({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new ct({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new pt(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new Lt(t);
                t.value = new On(t.value);
                if (e.kind == "get") return new Gt(t);
                if (e.kind == "set") return new Vt(t);
            },
            ArrayExpression: function(e) {
                return new Pt({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new yi() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new Bt({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new Et({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? At : Tt)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? ut : ft)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new mt({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new _i(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new mi(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new mi(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new di(t);

                  case "number":
                    t.value = n;
                    return new hi(t);

                  case "boolean":
                    return new (n ? Ei : ki)(t);
                }
            },
            Identifier: function(e) {
                var n = a[a.length - 2];
                return new (n.type == "LabeledStatement" ? Te : n.type == "VariableDeclarator" && n.id === e ? Zt : n.type == "FunctionExpression" ? n.id === e ? ti : ei : n.type == "FunctionDeclaration" ? n.id === e ? ni : ei : n.type == "CatchClause" ? ri : n.type == "BreakStatement" || n.type == "ContinueStatement" ? Ae : ai)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new ui({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? $t : zt)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", cn);
        e("BlockStatement", mn, "body@body");
        e("IfStatement", at, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", _n, "label>label, body>body");
        e("BreakStatement", it, "label>label");
        e("ContinueStatement", rt, "label>label");
        e("WithStatement", Sn, "object>expression, body>body");
        e("SwitchStatement", ot, "discriminant>expression, cases@body");
        e("ReturnStatement", et, "argument>value");
        e("ThrowStatement", nt, "argument>value");
        e("WhileStatement", wn, "test>condition, body>body");
        e("DoWhileStatement", yn, "test>condition, body>body");
        e("ForStatement", xn, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", En, "left>init, right>object, body>body");
        e("DebuggerStatement", fn);
        e("VariableDeclarator", _t, "id>name, init>value");
        e("CatchClause", lt, "param>argname, body%body");
        e("BinaryExpression", qt, "operator=operator, left>left, right>right");
        e("LogicalExpression", qt, "operator=operator, left>left, right>right");
        e("AssignmentExpression", Mt, "operator=operator, left>left, right>right");
        e("ConditionalExpression", Ft, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", kt, "callee>expression, arguments@args");
        e("CallExpression", xt, "callee>expression, arguments@args");
        c(An, function e(n) {
            return d("Program", n);
        });
        c(Ln, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(Hn, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(un, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(pn, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(st, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(ct, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(lt, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(dt, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(Et, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(St, function e(n) {
            var t = n instanceof At;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(Ot, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof $t,
                argument: l(n.expression)
            };
        });
        c(qt, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(Pt, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(Bt, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(Rt, function e(n) {
            var t = {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof Lt) {
                i = "init";
            } else if (n instanceof Gt) {
                i = "get";
            } else if (n instanceof Vt) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(Wt, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(ui, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(mi, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(pi, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(v, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        xi.DEFMETHOD("to_mozilla_ast", pi.prototype.to_mozilla_ast);
        _i.DEFMETHOD("to_mozilla_ast", pi.prototype.to_mozilla_ast);
        yi.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        vn.DEFMETHOD("to_mozilla_ast", mn.prototype.to_mozilla_ast);
        Dn.DEFMETHOD("to_mozilla_ast", Hn.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Z({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Z({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var a = "function From_Moz_" + e + "(M){\n";
            a += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var o = "function To_Moz_" + e + "(M){\n";
            o += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                a += ",\n" + r + ": ";
                o += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    a += "M." + t + ".map(from_moz)";
                    o += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    a += "from_moz(M." + t + ")";
                    o += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    a += "M." + t;
                    o += "M." + r;
                    break;

                  case "%":
                    a += "from_moz(M." + t + ").body";
                    o += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            a += "\n})\n}";
            o += "\n}\n}";
            a = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + a + ")")(h, s, f, u);
            o = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + o + ")")(l, p, d);
            i[e] = a;
            c(n, o);
        }
        var a = null;
        function u(e) {
            a.push(e);
            var n = e != null ? i[e.type](e) : null;
            a.pop();
            return n;
        }
        on.from_mozilla_ast = function(e) {
            var n = a;
            a = [];
            var t = u(e);
            a = n;
            t.walk(new Si(function(e) {
                if (e instanceof Ae) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof Tn) break;
                        if (t instanceof _n && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        $e("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof pn && n.body[0].body instanceof di) {
                t.unshift(l(new cn(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var z = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return en(n);
        function t(e) {
            n.push(e);
        }
    }();
    function q(e, n) {
        e.walk(new Si(function(e) {
            if (e instanceof Jn) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Rt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof At) {
                G(e.property, t);
            }
        }));
        function t(e) {
            Ke(n, e);
        }
    }
    function G(e, n) {
        if (e instanceof Ft) {
            G(e.consequent, n);
            G(e.alternative, n);
        } else if (e instanceof Et) {
            G(e.tail_node(), n);
        } else if (e instanceof di) {
            n(e.value);
        }
    }
    function W(e, t) {
        t = ge(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : z);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new tn();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new Si(function(e) {
            if (e instanceof qt) {
                if (e.operator == "in") G(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Tt) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof ai)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    G(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    G(e.args[0], p);
                    break;
                }
            } else if (e instanceof Jn) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Tt) {
                p(e.property);
            } else if (e instanceof Rt) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof At) {
                G(e.property, p);
            }
        }));
        e.walk(new Si(function(e) {
            if (e instanceof qt) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Tt) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof ai)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof Jn) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Tt) {
                e.property = d(e.property);
            } else if (e instanceof Rt) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof At) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (a && !a.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) return e;
            var n = r.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = E(++i);
                } while (!c(n));
                if (/^#/.test(e)) n = "#" + n;
                r.set(e, n);
            }
            return n;
        }
        function h(e) {
            if (e instanceof Et) {
                h(e.expressions.tail_node());
            } else if (e instanceof di) {
                e.value = d(e.value);
            } else if (e instanceof Ft) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var J, X;
    if (typeof Buffer == "undefined") {
        J = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        J = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        J = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(a[2]);
                if (!a) break;
                return J(a[2]);
            }
        }
        on.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function re(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function ae(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function oe(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new tn();
        } else if (!(e.props instanceof tn)) {
            e.props = tn.fromObject(e.props);
        }
    }
    function se(e) {
        return {
            props: e.props.toObject()
        };
    }
    function fe(i, r) {
        try {
            r = ge(r, {
                annotations: undefined,
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) on.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) r.rename = r.compress && r.mangle;
            if (r.annotations !== undefined) ae("annotations", r, [ "compress", "output" ]);
            if (r.ie8) ae("ie8", r, [ "compress", "mangle", "output" ]);
            if (r.keep_fnames) ae("keep_fnames", r, [ "compress", "mangle" ]);
            if (r.toplevel) ae("toplevel", r, [ "compress", "mangle" ]);
            if (r.v8) ae("v8", r, [ "mangle", "output" ]);
            if (r.webkit) ae("webkit", r, [ "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = ge(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                oe(r.mangle.cache);
                oe(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = ge(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) on.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (i instanceof An) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var o = r.sourceMap && r.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = re(o);
                }
                if (o) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (rn(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = a = qi(i[s], r.parse);
                    if (o == "inline") {
                        var f = K(s, a);
                        if (f) {
                            r.sourceMap.orig[s] = re(f);
                        }
                    } else if (o) {
                        r.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                q(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (r.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                a = new Ci(r.compress).compress(a);
                if (r.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) W(a, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = a;
            }
            if (!rn(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = $(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof An) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (rn(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = ji(r.output);
                a.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = se(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = se(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            on.log_function();
            on.disable_validation();
        }
    }
    h["Dictionary"] = tn;
    h["is_statement"] = ln;
    h["List"] = Xe;
    h["minify"] = fe;
    h["parse"] = qi;
    h["push_uniq"] = Ke;
    h["TreeTransformer"] = Ti;
    h["TreeWalker"] = Si;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
